program io;

uses
  Types,
  SysUtils,
  Windows,
  Messages,
  Lapage,
  GameConstr in 'GameConstr.pas',
  GameTypes in 'GameTypes.pas',
  BaseFile in 'BaseFile.pas';

var
  Game: TGame;

procedure DisplayLogo;
var
  buff : TLpgRowsBuffer;
  i: Integer;
  Intro: Cardinal;
begin
  buff := lpgCreateRowsBuffer(0,0);
  buff.LoadFromFile('data\logo.jpg');

  if PlaySfx then
  begin
    Intro := lpgMMLoadSound('data\intro.mp3', 1);
    lpgMMPlaySound(Intro, false);
  end;

  for i := 0 to 127 - 1 do
  begin
    lpgWindowBuffer.FillRect(0, 0, Screen_Width, Screen_Height, $ff000000);
    buff.Draw(lpgWindowBuffer, (Screen_Width - buff.Width) div 2, (Screen_Height - buff.Height) div 2);
    lpgWindowBuffer.FillRect(0, 0, Screen_Width, Screen_Height,
      $000000 or ($04000000 * (abs(i - 63))));
    lpgFlipWindow;
    Sleep(15);
  end;
  buff.Release;
  lpgMMFreeSound(Intro);
end;

function DisplayMenu : Integer;
var
  BtnStart : TLpgUi;
  BtnBest : TLpgUi;
  BtnAbout : TLpgUi;
  BtnExit : TLpgUi;
  ShowTick : Integer;
  Girls : TLpgList;
  TmpBuff : TLpgRowsBuffer;
  i: Integer;
  j: Integer;
begin
{$REGION 'UI   '}
    lpgUiSetDialogRect(Rect(
      Screen_Width div 4,
      8,
      (Screen_Width div 4)*3,
      Screen_Height - 8));
    BtnStart := lpgCreateUiControl(LAPAGE_UI_BUTTON, 0, ' ', 0, 0, 0, 0,
      LAPAGE_UIS_VISIBLE, LAPAGE_UI_INIT_DEFAULT);
//    BtnBest := lpgCreateUiControl(LAPAGE_UI_BUTTON, 0, '', 0, 0, 0, 0,
//      LAPAGE_UIS_VISIBLE, LAPAGE_UI_INIT_DEFAULT);
//    BtnAbout := lpgCreateUiControl(LAPAGE_UI_BUTTON, 0, '', 0, 0, 0, 0,
//      LAPAGE_UIS_VISIBLE, LAPAGE_UI_INIT_DEFAULT);
//    BtnExit := lpgCreateUiControl(LAPAGE_UI_BUTTON, 0, '', 0, 0, 0, 0,
//      LAPAGE_UIS_VISIBLE, LAPAGE_UI_INIT_DEFAULT);
{$ENDREGION}
{$REGION '  '}
  Girls := lpgCreateList;
  for j := 0 to 3 - 1 do
    for i := 0 to 4 - 1 do
    begin
      TmpBuff := lpgCreateRowsBuffer(Game.GirlsSpr[4+i].Width, Game.GirlsSpr[4+i].Height);
      lpgCopyBuffer(TmpBuff, Game.GirlsSpr[j * 20 + 4 + i], 0, 0);
      lpgScaleBufer(TmpBuff, TmpBuff.Width * 8, TmpBuff.Height * 8, LAPAGE_SCALE_FAST);
      Girls.CropAndAdd(TmpBuff, TmpBuff.Width, TmpBuff.Height);
    end;
{$ENDREGION}
  ShowTick := 0;
  repeat
    //
    lpgWindowBuffer.FillRect(0, 0, Screen_Width, Screen_Height, $ffff60ff);
    //UI
    lpgUiDisplay(lpgWindowBuffer, 0, 0);
    //  
    for i := 0 to 3 - 1 do
    begin
      Girls.Draw(lpgWindowBuffer,
        (GetTickCount div (10 + i * 2) mod (420)) - 100,
        Screen_Height - (Girls[0].Height div 2) + Trunc(Sin( GetTickCount/ (80 + i * 10)) * (i+4)),
        (GetTickCount div 200 mod 4) + i * 4);
    end;
    //
    Game.CursorSpr.Draw(lpgWindowBuffer, lpgMouseX - 6, lpgMouseY - 2, 0);
    // ,  .
    if ShowTick < 31 then
    begin
      lpgWindowBuffer.FillRect(0, 0, Screen_Width, Screen_Height,
        $000000 or ($08000000 * (abs(31 - ShowTick))));
      Inc(ShowTick);
    end;
    //
    lpgFlipWindow;
    Sleep(30);
  until (not IsWindow(lpgWindow))or(isKeyDown(VK_LBUTTON));
  Girls.Clear;
  Girls.Release;
  BtnStart.Release;
  BtnBest.Release;
  BtnAbout.Release;
  BtnExit.Release;
end;

function MouseEventProc(var MouseEvent : TMouseEventRec) : bool; stdcall;
begin
  case MouseEvent.Event of
    WM_LBUTTONDOWN, WM_LBUTTONDBLCLK:
    begin
      Game.Click(MouseEvent.X, MouseEvent.Y);
    end;
  end;
  Result := true;
end;

function ExistsKey(key : string): Boolean;
var
  i: Integer;
begin
  for i := 0 to ParamCount do
    if ParamStr(i) = key then exit(true);
  result := false;
end;

begin
  try
    //  
    Randomize;
    PlaySnd := not ExistsKey('-m');;
    PlaySfx := not ExistsKey('-s');;

    if PlaySfx or PlaySnd then
      lpgMMInit;
    //
    ShowCursor(false);
    ReportMemoryLeaksOnShutdown := true;

    lpgCreateWindow(Screen_Width, Screen_Height,
      LAPAGE_WINDOWMODE_BORDER or LAPAGE_WINDOWMODE_DOUBLESIZE);

    //
    DisplayLogo;
    // 

    Game := TGame.Create;
    //Game.Area.SetSize((Screen_Width div 20) - 1, (Screen_Height div 20) - 1);
    Game.LoadLevel('.\data\level\1.txt');

    TGirl.Create(Game).GirlType := Girl_Blond;
    TGirl.Create(Game).GirlType := Girl_Brun;
    TGirl.Create(Game).GirlType := Girl_Red;

    lpgUiSetFont(lpgCreateFont(24, 10, 0, 0, 0, 0, 0, 0, DEFAULT_CHARSET, 0, 0,
      ANTIALIASED_QUALITY, 0, 'Comic Sans Ms'), false);

    lpgUiSetColor($ff80ff, $ffffff, $ffffff, $ff00ff, $e040e0, $c0c0c0,
      $ffc000, $ffffff);

    DisplayMenu;
    Game.StartGame;
    lpgSetMouseEvent(@MouseEventProc);
    repeat
      Game.Action;

      lpgWindowBuffer.FillRect(0, 0, Screen_Width, Screen_Height, $FF406080);
      Game.Draw(lpgWindowBuffer);

      lpgFlipWindow;
      sleep(40);
    until not IsWindow(lpgWindow);
    lpgSetMouseEvent(nil);

    Game.Free;

    if PlaySfx or PlaySnd then
      lpgMMFree;

  except
    on E: Exception do
      MessageBox(lpgWindow, Pchar(E.ClassName + ' : ' + E.Message), nil,
        MB_ICONERROR);
  end;

end.
