program TDGame;

uses
  zglHeader,
  uINI_Files,
  uGlobalData,
  uResources,
  uGUI,
 // uBass,
  uLoad,
  uLogo,
  uMainMenuGUI,
  uMainMenu,
//  uHelp,
  uGame,
  uGameTypes,
  uGame_Intro in 'uGame_Intro.pas',
  uGame_Map in 'uGame_Map.pas',
  uGame_Buildings in 'uGame_Buildings.pas',
  uGame_Enemies in 'uGame_Enemies.pas',
  uGame1 in 'uGame1.pas',
  uGame1_GUI in 'uGame1_GUI.pas';

procedure Init;
var i : integer;
    t : boolean;
begin
  {==============  =========================}
  //     -   
  NowScrW    := INI_Options.INI_ReadKeyInt( 'SYS', 'RES_SCRW' );
  NowScrH    := INI_Options.INI_ReadKeyInt( 'SYS', 'RES_SCRH' );
  DefScrW    := INI_Options.INI_ReadKeyInt( 'SYS', 'RES_DEF_SCRW' );
  DefScrH    := INI_Options.INI_ReadKeyInt( 'SYS', 'RES_DEF_SCRH' );
  //DefScrW := 1024;
  //DefScrH := 768;
  //   
  ScrResNymb := INI_Options.INI_ReadKeyInt( 'SYS', 'RES_NUMB' );
  //   
  ScrResList := zglPResolutionList( zgl_Get( RESOLUTION_LIST ) );
  //  -1    
  if ScrResNymb = -1 then begin
    NowScrW := ScrResList.Width [ ScrResList.Count - 1 ];
    NowScrH := ScrResList.Height[ ScrResList.Count - 1 ];
  end else begin
    // ,     
    t := false;
    for i:=0 to ScrResList.Count-1 do begin
      if ( ScrResList.Width[ i ] = NowScrW ) and
         ( ScrResList.Width[ i ] = NowScrW ) then
      begin
        t := true;
        ScrResNymb := i;
        break;
      end;
    end;
    if not t then begin
      NowScrW := ScrResList^.Width [ 0 ];
      NowScrH := ScrResList^.Height[ 0 ];
    end;
  end;
  //  
  zgl_Enable( CORRECT_RESOLUTION );
  scr_CorrectResolution( DefScrW, DefScrH );
  //  
  scr_SetOptions( NowScrW, NowScrH, REFRESH_MAXIMUM, FullScr, False );

{======  ====================================}
  ///    
//  UseSound     := INI_Options.INI_ReadKeyBol( 'SYS', 'USESOUND' );
//  Glb_Sound_Volume := INI_Options.INI_ReadKeyInt( 'SYS', 'SOUND_VOLUME' );
  //   
  ShowLogo     := INI_Options.INI_ReadKeyBol( 'SYS', 'SHOWLOGO' );
  //   
  UseEffects   := INI_Options.INI_ReadKeyBol( 'SYS', 'USEEFFECTS' );

{======  ===================================}
  //  
  Font1     := Font_LoadFromFile( DataFolder + 'gui\fonts\comic sans\Comic Sans MS-16pt.zfi' );
  //Font1            := Font_LoadFromFile( DataFolder + 'gui\fonts\arial\Arial-16pt.zfi' );
  //Font1.Pages[ 0 ] := Tex_LoadFromFile ( DataFolder + 'gui\fonts\arial\Arial-16pt-page0.png',
  //                                     $FF000000, TEX_DEFAULT_2D );
  //   
  //Font1Big  := Font_LoadFromFile( DataFolder + 'gui\fonts\arial\Arial-32pt.zfi' );
  Font2     := Font_LoadFromFile( DataFolder + 'gui\fonts\comic sans\Comic Sans MS-16pt.zfi' );
  //Font2Big  := Font_LoadFromFile( DataFolder + 'gui\fonts\comic sans\Comic Sans MS-32pt.zfi' );

  //  
  ErrorTex  := Tex_LoadFromFile( DataFolder + 'gui\error.jpg', $00000000, TEX_DEFAULT_2D );

{======    =====================}
  // 
//  Init_Sounds( hWnd );
  // . 
  Resources := tResources.Create;

  GameProgress := tGameProgress.Create;
  GameProgress.LoadFrom( DataFolder + INI_Options.INI_ReadKeyStr( 'PLAYER', 'SAVE_FILE' ) );

  //     0
  GlobScrAlpha := 0;
  // 
  mGUI_Init;
  //  
  if ShowLogo then begin
    NextScene := sLogo;
    NextGScene:= gsIntoduce;
    NextProc  := @LogoFstInit;
  end else begin
    NextScene := sMenu;
    NextGScene:= gsIntoduce;
    NextProc  := @MainMenuInit;
  end;

  Scene := sLoad;
  LoadInit( DataFolder + 'scenes\FstLoad.scene' );
end;

procedure Draw;
begin
  case Scene of
    sLoad   : LoadDraw;
    sLogo   : LogoDraw;
    sMenu   : MainMenuDraw;
//    sOptions: OptionsDraw;
//    sAbout  : AboutDraw;
    sScore  : ;
    sGame   : GameDraw;
  end;
  //  
  PR2D_Rect( 0, 0, DefScrW, DefScrH, $000000, GlobScrAlpha, PR2D_FILL );
end;

procedure Update;
begin
  case Scene of
    sLoad   : LoadUpdate;
    sLogo   : LogoUpdate;
    sMenu   : MainMenuUpdate;
//    sOptions: OptionsUpdate;
//    sAbout  : AboutUpdate;
    sScore  : ;
    sGame   : GameUpdate;
  end;
  //   
  key_ClearState;
  mouse_ClearState;
end;

procedure Quit;
begin
  // 
  INI_Options.INI_LoadFromFile( DataFolder+'cfg\options.ini' );
  INI_Options.INI_WriteKeyBol( 'SYS', 'RES_FULLSCR', FullScr );
  INI_Options.INI_WriteKeyInt( 'SYS', 'RES_SCRW', NowScrW );
  INI_Options.INI_WriteKeyInt( 'SYS', 'RES_SCRH', NowScrH );
  INI_Options.INI_WriteKeyInt( 'SYS', 'RES_DEF_SCRW', DefScrW );
  INI_Options.INI_WriteKeyInt( 'SYS', 'RES_DEF_SCRH', DefScrH );
  INI_Options.INI_WriteKeyInt( 'SYS', 'RES_NUMB', ScrResNymb );
//  INI_Options.INI_WriteKeyBol( 'SYS', 'USESOUND', UseSound );
//  INI_Options.INI_WriteKeyInt( 'SYS', 'SOUND_VOLUME', Glb_Sound_Volume );
  INI_Options.INI_WriteKeyBol( 'SYS', 'SHOWLOGO', ShowLogo );
  INI_Options.INI_WriteKeyBol(  'SYS', 'USEEFFECTS', UseEffects );
  INI_Options.INI_SaveToFile( DataFolder+'cfg\options.ini' );
  //
  GameProgress.SaveTo( DataFolder + INI_Options.INI_ReadKeyStr( 'PLAYER', 'SAVE_FILE' ) );
end;

begin
  INI_Options := tINI.Create;
  //    
  INI_Options.INI_LoadFromFile( DataFolder+'cfg\options.ini' );
  FullScr := INI_Options.INI_ReadKeyBol( 'SYS', 'RES_FULLSCR' );
  //   
  zglLoad  ( 'ZenGL.dll' );
  Timer_Add( @Update, Timer_dt );
  zgl_Reg  ( SYS_LOAD, @Init );
  zgl_Reg  ( SYS_DRAW, @Draw );
  zgl_Reg  ( SYS_EXIT, @Quit );
  wnd_SetCaption( GameCaption + GameVersion );
  wnd_ShowCursor( TRUE );
  scr_SetOptions( 640, 480, REFRESH_MAXIMUM, FullScr, False );
  zgl_Init;
end.

