unit uGame;

interface

procedure GameInit;
procedure GameDraw;
procedure GameUpdate;

procedure StartNewGame;
procedure ContinueGame;

implementation

uses  uGUI,
      uGlobalData,
      uGame_Intro,
      uGame1;

////////////////////////////////////////////////////////////////////////////////

procedure StartNewGame;
begin
  GameProgress.GameStarted := true;
  GameInit;
end;

procedure ContinueGame;
begin
  if not GameProgress.GameStarted then begin
    StartNewGame;
    Exit;
  end;
  GameInit;
end;

////////////////////////////////////////////////////////////////////////////////

procedure GameInit;
begin
  GUI_SetLayer( 0 );
  Game1Init;
  GScene := gsGame;
end;

procedure GameDraw;
begin

  case GScene of
    gsIntoduce : GameIntroDraw;
    gsGame     : Game1Draw;
  end;

  mGUI_Draw;
end;

procedure GameUpdate;
begin

  case GScene of
    gsIntoduce : GameIntroUpdate;
    gsGame     : Game1Update;
  end;

  mGUI_Update;
end;

end.
