unit uGame1;

interface

uses  uGame_Map;

type  tAddModes = ( ADD_BASE_1, ADD_BASE_2, ADD_BASE_3,
                    ADD_ENG_1, ADD_ENG_2, ADD_ENG_3,
                    ADD_SHAXT_1, ADD_SHAXT_2, ADD_SHAXT_3,
                    ADD_MING_1, ADD_MING_2, ADD_MING_3,
                    ADD_ROCG_1, ADD_ROCG_2, ADD_ROCG_3,
                    ADD_LAZR_1, ADD_LAZR_2, ADD_LAZR_3 );

procedure Game1Init;
procedure Game1Draw;
procedure Game1Update;

var   Map : tMap;
var   BaseAdded : boolean = false;

var   Add_Mode      : boolean = false;
      Add_Mode_What : tAddModes;
var   Kill_Mode     : boolean = false;
var   Pause_Mode    : boolean = false;

implementation

uses  uGlobalData,
      zglHeader,
      uGame1_GUI,
      uMainMenu,
      uGUI,
      uGame_Buildings;

var   PanelHeight : integer;
var   PanelHeight2: integer;

var   TotalMet   : single;
var   TotalEng   : single;
var   ProdMet    : integer;
//var   ProdEng    : integer;
var   BaseHealth : integer;

var   Last_MX, Last_MY : integer;

procedure SetBaseAdded;
begin
  baseAdded := true;
  Bn_Add_Base_1.Visible := false;
  Bn_Add_Base_2.Visible := false;
  Bn_Add_Base_3.Visible := false;

  Bn_Add_Eng.Visible := true;
  Bn_Add_Shaxt.Visible := true;
  Bn_Add_Ming.Visible := true;
  Bn_Add_Rocg.Visible := true;
  Bn_Add_Lazr.Visible := true;

  Add_Mode := false;
end;

procedure CheckAvaiblBuilds;
var avb_met, avb_eng : single;
begin
  avb_met := map.GetTotalMet;
  avb_eng := map.GetTotalEng;

  if avb_met >= Eng_1_Price then begin
    pGUIButtonDesc( Bn_Add_Eng.Desc ).Pressed := false;
    pGUIButtonDesc( Bn_Add_Eng_1.Desc ).Pressed := false;
    if avb_met >= Eng_2_Price then pGUIButtonDesc( Bn_Add_Eng_2.Desc ).Pressed := false
      else pGUIButtonDesc( Bn_Add_Eng_2.Desc ).Pressed := true;
    if avb_met >= Eng_3_Price then pGUIButtonDesc( Bn_Add_Eng_3.Desc ).Pressed := false
      else pGUIButtonDesc( Bn_Add_Eng_3.Desc ).Pressed := true;
  end else begin
    pGUIButtonDesc( Bn_Add_Eng.Desc ).Pressed := true;
    pGUIButtonDesc( Bn_Add_Eng_1.Desc ).Pressed := true;
    pGUIButtonDesc( Bn_Add_Eng_2.Desc ).Pressed := true;
    pGUIButtonDesc( Bn_Add_Eng_3.Desc ).Pressed := true;
  end;

  if avb_met >= Shaxt_1_Price then begin
    pGUIButtonDesc( Bn_Add_Shaxt.Desc ).Pressed := false;
    pGUIButtonDesc( Bn_Add_Shaxt_1.Desc ).Pressed := false;
    if avb_met >= Shaxt_2_Price then pGUIButtonDesc( Bn_Add_Shaxt_2.Desc ).Pressed := false
      else pGUIButtonDesc( Bn_Add_Shaxt_2.Desc ).Pressed := true;
    if avb_met >= Shaxt_3_Price then pGUIButtonDesc( Bn_Add_Shaxt_3.Desc ).Pressed := false
      else pGUIButtonDesc( Bn_Add_Shaxt_3.Desc ).Pressed := true;
  end else begin
    pGUIButtonDesc( Bn_Add_Shaxt.Desc ).Pressed := true;
    pGUIButtonDesc( Bn_Add_Shaxt_1.Desc ).Pressed := true;
    pGUIButtonDesc( Bn_Add_Shaxt_2.Desc ).Pressed := true;
    pGUIButtonDesc( Bn_Add_Shaxt_3.Desc ).Pressed := true;
  end;

  if (avb_met >= Ming_1_Price) and (avb_eng >= Ming_1_UsEng) then begin
    pGUIButtonDesc( Bn_Add_Ming.Desc ).Pressed := false;
    pGUIButtonDesc( Bn_Add_Ming_1.Desc ).Pressed := false;
    if (avb_met >= Ming_2_Price) and (avb_eng >= Ming_2_UsEng) then pGUIButtonDesc( Bn_Add_Ming_2.Desc ).Pressed := false
      else pGUIButtonDesc( Bn_Add_Ming_2.Desc ).Pressed := true;
    if (avb_met >= Ming_3_Price) and (avb_eng >= Ming_3_UsEng) then pGUIButtonDesc( Bn_Add_Ming_3.Desc ).Pressed := false
      else pGUIButtonDesc( Bn_Add_Ming_3.Desc ).Pressed := true;
  end else begin
    pGUIButtonDesc( Bn_Add_Ming.Desc ).Pressed := true;
    pGUIButtonDesc( Bn_Add_Ming_1.Desc ).Pressed := true;
    pGUIButtonDesc( Bn_Add_Ming_2.Desc ).Pressed := true;
    pGUIButtonDesc( Bn_Add_Ming_3.Desc ).Pressed := true;
  end;

  if (avb_met >= rocg_1_Price) and (avb_eng >= rocg_1_UsEng) then begin
    pGUIButtonDesc( Bn_Add_rocg.Desc ).Pressed := false;
    pGUIButtonDesc( Bn_Add_rocg_1.Desc ).Pressed := false;
    if (avb_met >= rocg_2_Price) and (avb_eng >= rocg_2_UsEng) then pGUIButtonDesc( Bn_Add_rocg_2.Desc ).Pressed := false
      else pGUIButtonDesc( Bn_Add_rocg_2.Desc ).Pressed := true;
    if (avb_met >= rocg_3_Price) and (avb_eng >= rocg_3_UsEng) then pGUIButtonDesc( Bn_Add_rocg_3.Desc ).Pressed := false
      else pGUIButtonDesc( Bn_Add_rocg_3.Desc ).Pressed := true;
  end else begin
    pGUIButtonDesc( Bn_Add_rocg.Desc ).Pressed := true;
    pGUIButtonDesc( Bn_Add_rocg_1.Desc ).Pressed := true;
    pGUIButtonDesc( Bn_Add_rocg_2.Desc ).Pressed := true;
    pGUIButtonDesc( Bn_Add_rocg_3.Desc ).Pressed := true;
  end;

  if (avb_met >= lazr_1_Price) and (avb_eng >= lazr_1_UsEng) then begin
    pGUIButtonDesc( Bn_Add_lazr.Desc ).Pressed := false;
    pGUIButtonDesc( Bn_Add_lazr_1.Desc ).Pressed := false;
    if (avb_met >= lazr_2_Price) and (avb_eng >= lazr_2_UsEng) then pGUIButtonDesc( Bn_Add_lazr_2.Desc ).Pressed := false
      else pGUIButtonDesc( Bn_Add_lazr_2.Desc ).Pressed := true;
    if (avb_met >= lazr_3_Price) and (avb_eng >= lazr_3_UsEng) then pGUIButtonDesc( Bn_Add_lazr_3.Desc ).Pressed := false
      else pGUIButtonDesc( Bn_Add_lazr_3.Desc ).Pressed := true;
  end else begin
    pGUIButtonDesc( Bn_Add_lazr.Desc ).Pressed := true;
    pGUIButtonDesc( Bn_Add_lazr_1.Desc ).Pressed := true;
    pGUIButtonDesc( Bn_Add_lazr_2.Desc ).Pressed := true;
    pGUIButtonDesc( Bn_Add_lazr_3.Desc ).Pressed := true;
  end;

end;

procedure Game1Init;
begin
  Map := tMap.Create( DataFolder + 'levels\level2.lvl' );
  Map.Greed( false );

  PanelHeight := 100;
  PanelHeight2:= 75;

  InitGame1GUI;

  Last_MX := Mouse_X;
  Last_MY := Mouse_Y;
end;

procedure Game1Draw;
begin
  Map.SetCamera( true );
    Map.Draw;
  Map.SetCamera( false );
  PR2D_Rect ( 0, DefScrH - PanelHeight, DefScrW, PanelHeight,
              $333333, 180, PR2D_FILL );
  PR2D_Rect ( 0, 0, DefScrW, PanelHeight2, $333333, 180, PR2D_FILL );
  if BaseAdded then begin
    PR2D_Rect ( 5, 0, 480, PanelHeight2/2, $111111 );
    text_Draw ( font2, 15, (PanelHeight2/2 - font2.MaxHeight)/2,
                ':   ' + U_FloatToStr( map.GetTotalMet ) +
                '  (- ' + U_IntToStr( map.GetProdMet) + '  20 .)' );

    PR2D_Rect ( 5, PanelHeight2/2, 480, PanelHeight2/2, $111111 );
    text_Draw ( font2, 15, PanelHeight2/2 + (PanelHeight2/2 - font2.MaxHeight)/2,
                ':   ' + U_FloatToStr( map.GetTotalEng ) );

    PR2D_Rect ( 490, 0, 320, PanelHeight2, $111111 );
    text_Draw ( font2, 500, (PanelHeight2 - font2.MaxHeight)/2,
                ' :   '+ U_IntToStr( map.GetBaseHealth ) + ' HP' );
  end;

  G1GDraw;
end;

procedure Game1Update;
var dx, dy : integer;
begin
  //if Mouse_Wheel ( M_WUP ) then Map.ZoomCamera( true );
  //if Mouse_Wheel ( M_WDOWN ) then Map.ZoomCamera( false );
  //if Mouse_Click ( M_BMIDLE ) then Map.DefaultCamera;

  if Pause_Mode then begin
    CheckAvaiblBuilds;
    G1GUpdt;
    exit;
  end;

  if Mouse_Down( M_BMIDLE ) then begin
    dx := Mouse_X - last_MX;
    dy := Mouse_Y - last_MY;
    map.ShiftMap( 1, 2*dx );
    map.ShiftMap( 2, 2*dy );
  end;
  last_MX := Mouse_X;
  last_MY := Mouse_Y;

  if Add_Mode then begin
    if Mouse_Click ( M_BLEFT ) and map.GetAddBuildFocused and
      (Mouse_Y < (DefScrH - PanelHeight)) and
      (Mouse_Y > PanelHeight2) then begin
      case Add_Mode_What of
        ADD_BASE_1, ADD_BASE_2, ADD_BASE_3:
          begin
            if Add_Mode_What = ADD_BASE_1 then begin
              Map.AddBase( 1 );
              SetBaseAdded
            end;
            if Add_Mode_What = ADD_BASE_2 then begin
              Map.AddBase( 2 );
              SetBaseAdded
            end;
            if Add_Mode_What = ADD_BASE_3 then begin
              Map.AddBase( 3 );
              SetBaseAdded
            end;
            Add_Mode := false;
          end;
        ADD_ENG_1, ADD_ENG_2, ADD_ENG_3: begin
            if Add_Mode_What = ADD_ENG_1 then begin
              Map.AddEng( 1 );
            end;
            if Add_Mode_What = ADD_ENG_2 then begin
              Map.AddEng( 2 );
            end;
            if Add_Mode_What = ADD_ENG_3 then begin
              Map.AddEng( 3 );
            end;
            Add_Mode := false;
        end;
        ADD_SHAXT_1, ADD_SHAXT_2, ADD_SHAXT_3: begin
            if Add_Mode_What = ADD_SHAXT_1 then begin
              Map.AddShaxt( 1 );
            end;
            if Add_Mode_What = ADD_SHAXT_2 then begin
              Map.AddShaxt( 2 );
            end;
            if Add_Mode_What = ADD_SHAXT_3 then begin
              Map.AddShaxt( 3 );
            end;
            Add_Mode := false;
        end;
        ADD_MING_1, ADD_MING_2, ADD_MING_3: begin
            if Add_Mode_What = ADD_MING_1 then begin
              Map.AddMing( 1 );
            end;
            if Add_Mode_What = ADD_MING_2 then begin
              Map.AddMing( 2 );
            end;
            if Add_Mode_What = ADD_MING_3 then begin
              Map.AddMing( 3 );
            end;
            Add_Mode := false;
        end;
        ADD_ROCG_1, ADD_ROCG_2, ADD_ROCG_3: begin
            if Add_Mode_What = ADD_ROCG_1 then begin
              Map.AddRocg( 1 );
            end;
            if Add_Mode_What = ADD_ROCG_2 then begin
              Map.AddRocg( 2 );
            end;
            if Add_Mode_What = ADD_ROCG_3 then begin
              Map.AddRocg( 3 );
            end;
            Add_Mode := false;
        end;
        ADD_LAZR_1, ADD_LAZR_2, ADD_LAZR_3: begin
            if Add_Mode_What = ADD_LAZR_1 then begin
              Map.AddLazr( 1 );
            end;
            if Add_Mode_What = ADD_LAZR_2 then begin
              Map.AddLazr( 2 );
            end;
            if Add_Mode_What = ADD_LAZR_3 then begin
              Map.AddLazr( 3 );
            end;
            Add_Mode := false;            
        end;
      end;
    end;
  end;

  if Mouse_Click ( M_BRIGHT ) then begin
    Add_Mode := false;
    Map.SetAddMode( nil );
  end;

  Map.Updt;
  CheckAvaiblBuilds;
  G1GUpdt;

  if Key_Up ( k_escape ) then begin
//    scene := sMenu;
//    MainMenuInit;
    zgl_Exit;
  end;

end;

end.
