unit uGame_Buildings;

interface

uses  uGame_Map,
      zglHeader;

var   cPosBuilds : array [ 1 .. 7 ] of tBuildStructure;

const Base_1_Price = 50;
const Base_1_UsEng = -5;
const Base_1_UsMet = -10;
const Base_1_HP    = 750;
////////////////////////
const Base_2_Price = 100;
const Base_2_UsEng = -15;
const Base_2_UsMet = -24;
const Base_2_HP    = 1200;
////////////////////////
const Base_3_Price = 150;
const Base_3_UsEng = -25;
const Base_3_UsMet = -40;
const Base_3_HP    = 1800;

const Eng_1_Price = 20;
const Eng_1_UsEng = -15;
const Eng_1_UsMet = 0;
const Eng_1_HP    = 150;
////////////////////////
const Eng_2_Price = 100;
const Eng_2_UsEng = -50;
const Eng_2_UsMet = 0;
const Eng_2_HP    = 250;
////////////////////////
const Eng_3_Price = 300;
const Eng_3_UsEng = -150;
const Eng_3_UsMet = 0;
const Eng_3_HP    = 400;

const Shaxt_1_Price = 30;
const Shaxt_1_UsEng = 0;
const Shaxt_1_UsMet = -12;
const Shaxt_1_HP    = 200;
////////////////////////
const Shaxt_2_Price = 120;
const Shaxt_2_UsEng = 0;
const Shaxt_2_UsMet = -45;
const Shaxt_2_HP    = 350;
////////////////////////
const Shaxt_3_Price = 350;
const Shaxt_3_UsEng = 0;
const Shaxt_3_UsMet = -160;
const Shaxt_3_HP    = 400;

const Ming_1_Price = 10;
const Ming_1_UsEng = 1;
const Ming_1_UsMet = 0;
const Ming_1_HP    = 50;
const Ming_1_Dmg   = 6;
const Ming_1_Atk   = 12;
////////////////////////
const Ming_2_Price = 50;
const Ming_2_UsEng = 3;
const Ming_2_UsMet = 0;
const Ming_2_HP    = 120;
const Ming_2_Dmg   = 10;
const Ming_2_Atk   = 25;
////////////////////////
const Ming_3_Price = 200;
const Ming_3_UsEng = 10;
const Ming_3_UsMet = 0;
const Ming_3_HP    = 180;
const Ming_3_Dmg   = 20;
const Ming_3_Atk   = 60;

const Rocg_1_Price = 50;
const Rocg_1_UsEng = 5;
const Rocg_1_UsMet = 0;
const Rocg_1_HP    = 80;
const Rocg_1_Dmg   = 20;
const Rocg_1_Atk   = 8;
////////////////////////
const Rocg_2_Price = 150;
const Rocg_2_UsEng = 15;
const Rocg_2_UsMet = 0;
const Rocg_2_HP    = 180;
const Rocg_2_Dmg   = 25;
const Rocg_2_Atk   = 12;
////////////////////////
const Rocg_3_Price = 300;
const Rocg_3_UsEng = 40;
const Rocg_3_UsMet = 0;
const Rocg_3_HP    = 300;
const Rocg_3_Dmg   = 30;
const Rocg_3_Atk   = 18;

const Lazr_1_Price = 120;
const Lazr_1_UsEng = 10;
const Lazr_1_UsMet = 0;
const Lazr_1_HP    = 220;
const Lazr_1_Dmg   = 20;
const Lazr_1_Atk   = 10;
////////////////////////
const Lazr_2_Price = 250;
const Lazr_2_UsEng = 30;
const Lazr_2_UsMet = 0;
const Lazr_2_HP    = 500;
const Lazr_2_Dmg   = 40;
const Lazr_2_Atk   = 18;
////////////////////////
const Lazr_3_Price = 500;
const Lazr_3_UsEng = 100;
const Lazr_3_UsMet = 0;
const Lazr_3_HP    = 1100;
const Lazr_3_Dmg   = 60;
const Lazr_3_Atk   = 35;

type  tBuildType = ( BD_BASE, BD_ENG, BD_SHAXT, BD_MING, BD_ROCG, BD_LAZR );

type  pBuild = ^tBuild;
      tBuild = class ( tMapElement )
        public
          kill : boolean;
          col  : zglTCircle;
          structure : tBuildStructure;
          mx, my : integer;

          constructor Create ( param : pointer ); override;

          procedure   Draw ( param : pMapElemDrawParam ); override;
          procedure   DrawInf; virtual;
          procedure   Updt ( param, param2 : pointer ); override;

          function GetPrice : integer;
          function GetHealth : integer;
          function GetUseEng : integer;
          function GetUseMet : integer;

          function GetBuildType : tBuildType;
        protected
          bd_type   : tBuildType;
          gun       : boolean;

          health    : integer;
          def_health: integer;
          price_met : integer;
          use_eng   : integer;
          use_met   : integer;

          damage    : integer;
          atk_pr_tm : integer;
          atk_dtm     : single;
          last_atk_tm : single;
      end;

type  pBuildCh = ^tBuildCh;
      tBuildCh = record
        data : pBuild;
        next : pointer;
        prew : pointer;
      end;

type  pBuildBaseParam = ^tBuildBaseParam;
      tBuildBaseParam = record
        x, y : integer;
        r : single;
        tp : byte;
        tex1, tex2,
        tex3, tex4 : string;
        str : tBuildStructure;
      end;

      pBuildBase = ^tBuildBase;
      tBuildBase = class ( tBuild )
        public
          cnt : byte;
          tex1, tex2,
          tex3, tex4  : zglPTexture;
          col1, col2,
          col3, col4  : zglTCircle;

          constructor   Create ( param : pointer ); override;

          procedure     Draw ( param : pMapElemDrawParam );  override;
          procedure     DrawInf; override;
          procedure     Updt ( param, param2 : pointer ); override;
      end;

type  pBuildEngParam = ^tBuildEngParam;
      tBuildEngParam = record
        x, y : integer;
        r : single;
        tp : byte;
        tex1, tex2, tex3,
        tex4, tex5, tex6,
        tex7 : string;
        str : tBuildStructure;
      end;

      pBuildEng = ^tBuildEng;
      tBuildEng = class ( tBuild )
        public
          cnt : byte;
          tex1, tex2,
          tex3, tex4,
          tex5, tex6, tex7 : zglPTexture;
          col1, col2,
          col3, col4,
          col5, col6, col7 : zglTCircle;

          constructor   Create ( param : pointer ); override;

          procedure     Draw ( param : pMapElemDrawParam );  override;
          procedure     DrawInf; override;
          procedure     Updt ( param, param2 : pointer ); override;
      end;

type  pBuildShaxtParam = ^tBuildShaxtParam;
      tBuildShaxtParam = record
        x, y : integer;
        r : single;
        tp : byte;
        tex1, tex2, tex3,
        tex4, tex5,
        tex6 : string;
        str : tBuildStructure;
      end;

      pBuildShaxt = ^tBuildShaxt;
      tBuildShaxt = class ( tBuild )
        public
          cnt : byte;
          tex1, tex2,
          tex3, tex4,
          tex5, tex6  : zglPTexture;
          col1, col2,
          col3, col4,
          col5, col6  : zglTCircle;

          constructor   Create ( param : pointer ); override;

          procedure     Draw ( param : pMapElemDrawParam );  override;
          procedure     DrawInf; override;
          procedure     Updt ( param, param2 : pointer ); override;
      end;

type  pBuildMingParam = ^tBuildMingParam;
      tBuildMingParam = record
        x, y : integer;
        r : single;
        tp : byte;
        tex1, tex2,
        tex3 : string;
        str : tBuildStructure;
      end;

      pBuildMing = ^tBuildMing;
      tBuildMing = class ( tBuild )
        public
          cnt : byte;
          tex1, tex2,
          tex3 : zglPTexture;
          col1, col2,
          col3 : zglTCircle;
          last_tm : single;

          constructor   Create ( param : pointer ); override;

          procedure     Draw ( param : pMapElemDrawParam );  override;
          procedure     DrawInf; override;
          procedure     Updt ( param, param2 : pointer ); override;
      end;

type  pBuildRocgParam = ^tBuildRocgParam;
      tBuildRocgParam = record
        x, y : integer;
        r : single;
        tp : byte;
        tex1, tex2,
        tex3 : string;
        str : tBuildStructure;
      end;

      pBuildRocg = ^tBuildRocg;
      tBuildRocg = class ( tBuild )
        public
          cnt : byte;
          tex1, tex2,
          tex3 : zglPTexture;
          col1, col2,
          col3 : zglTCircle;
          last_tm : single;

          constructor   Create ( param : pointer ); override;

          procedure     Draw ( param : pMapElemDrawParam );  override;
          procedure     DrawInf; override;
          procedure     Updt ( param, param2 : pointer ); override;
      end;

type  pBuildLazrParam = ^tBuildLazrParam;
      tBuildLazrParam = record
        x, y : integer;
        r : single;
        tp : byte;
        tex1 : string;
        str : tBuildStructure;
      end;

      pBuildLazr = ^tBuildLazr;
      tBuildLazr = class ( tBuild )
        public
          cnt : byte;
          tex1 : zglPTexture;
          col1 : zglTCircle;
          last_tm : single;

          constructor   Create ( param : pointer ); override;

          procedure     Draw ( param : pMapElemDrawParam );  override;
          procedure     DrawInf; override;
          procedure     Updt ( param, param2 : pointer ); override;
      end;

implementation

uses  uGlobalData,
      uGame_Enemies,
      uGame1;

////////////////////////////////////////////////////////////////////////////////

constructor tBuild.Create(param: Pointer);
begin
  el_type := ME_BUILD;
  gun := false;
end;

procedure tBuild.Draw(param: pMapElemDrawParam);
begin

end;

procedure tBuild.DrawInf;
begin

end;

procedure tBuild.Updt(param, param2: Pointer);
begin

end;

function tBuild.GetPrice : integer;
begin
  result := price_met;
end;

function tBuild.GetHealth : integer;
begin
  result := health;
end;

function tBuild.GetUseEng : integer;
begin
  result := use_eng;
end;

function tBuild.GetUseMet : integer;
begin
  result := use_met;
end;

function tBuild.GetBuildType;
begin
  result := bd_type;
end;

////////////////////////////////////////////////////////////////////////////////

constructor tBuildBase.Create(param: Pointer);
begin
  KILL := false;
  el_type := ME_BUILD;
  gun := false;
  structure := pBuildBaseParam( param ).str;
  cnt := structure.count;
  mx := pBuildBaseParam( param ).x;
  my := pBuildBaseParam( param ).y;
  case pBuildBaseParam( param ).tp of
    1: begin
      tex1 := Resources.GetTex( pBuildBaseParam( param ).tex1 );
      tex2 := nil;
      tex3 := nil;
      tex4 := nil;

      col1.cX := pBuildBaseParam( param ).x *
                 pBuildBaseParam( param ).r * 3/2;
      col1.cY := pBuildBaseParam( param ).r *
                ( pBuildBaseParam( param ).y * sqrt( 3 ) + pBuildBaseParam( param ).x * sqrt( 3 )/2 );
      col1.Radius := pBuildBaseParam( param ).r * sqrt( 3 )/2;

      health := Base_1_HP;
      use_eng := Base_1_UsEng;
      use_met := Base_1_UsMet;
      price_met := Base_1_Price;
    end;
    2: begin
      tex1 := Resources.GetTex( pBuildBaseParam( param ).tex1 );
      tex2 := Resources.GetTex( pBuildBaseParam( param ).tex2 );
      tex3 := Resources.GetTex( pBuildBaseParam( param ).tex3 );
      tex4 := nil;

      col1.cX := pBuildBaseParam( param ).x *
                 pBuildBaseParam( param ).r * 3/2;
      col1.cY := pBuildBaseParam( param ).r *
                ( pBuildBaseParam( param ).y * sqrt( 3 ) + pBuildBaseParam( param ).x * sqrt( 3 )/2 );
      col1.Radius := pBuildBaseParam( param ).r * sqrt( 3 )/2;

      col2.cX := (pBuildBaseParam( param ).x + structure.points[ 2, 1 ]) *
                 pBuildBaseParam( param ).r * 3/2;
      col2.cY := pBuildBaseParam( param ).r *
                ( (pBuildBaseParam( param ).y + structure.points[ 2, 2 ]) * sqrt( 3 ) +
                (pBuildBaseParam( param ).x + structure.points[ 2, 1 ]) * sqrt( 3 )/2 );
      col2.Radius := pBuildBaseParam( param ).r * sqrt( 3 )/2;

      col3.cX := (pBuildBaseParam( param ).x + structure.points[ 3, 1 ]) *
                 pBuildBaseParam( param ).r * 3/2;
      col3.cY := pBuildBaseParam( param ).r *
                ( (pBuildBaseParam( param ).y + structure.points[ 3, 2 ]) * sqrt( 3 ) +
                (pBuildBaseParam( param ).x + structure.points[ 3, 1 ]) * sqrt( 3 )/2 );
      col3.Radius := pBuildBaseParam( param ).r * sqrt( 3 )/2;

      health := Base_2_HP;
      use_eng := Base_2_UsEng;
      use_met := Base_2_UsMet;
      price_met := Base_2_Price;
    end;
    3 : begin
      tex1 := Resources.GetTex( pBuildBaseParam( param ).tex1 );
      tex2 := Resources.GetTex( pBuildBaseParam( param ).tex2 );
      tex3 := Resources.GetTex( pBuildBaseParam( param ).tex3 );
      tex4 := Resources.GetTex( pBuildBaseParam( param ).tex4 );

      col1.cX := pBuildBaseParam( param ).x *
                 pBuildBaseParam( param ).r * 3/2;
      col1.cY := pBuildBaseParam( param ).r *
                ( pBuildBaseParam( param ).y * sqrt( 3 ) + pBuildBaseParam( param ).x * sqrt( 3 )/2 );
      col1.Radius := pBuildBaseParam( param ).r * sqrt( 3 )/2;

      col2.cX := (pBuildBaseParam( param ).x + structure.points[ 2, 1 ])*
                 pBuildBaseParam( param ).r * 3/2;
      col2.cY := pBuildBaseParam( param ).r *
                ( (pBuildBaseParam( param ).y + structure.points[ 2, 2 ]) * sqrt( 3 ) +
                (pBuildBaseParam( param ).x + structure.points[ 2, 1 ]) * sqrt( 3 )/2 );
      col2.Radius := pBuildBaseParam( param ).r * sqrt( 3 )/2;

      col3.cX := (pBuildBaseParam( param ).x + structure.points[ 3, 1 ]) *
                 pBuildBaseParam( param ).r * 3/2;
      col3.cY := pBuildBaseParam( param ).r *
                ( (pBuildBaseParam( param ).y + structure.points[ 3, 2 ]) * sqrt( 3 ) +
                (pBuildBaseParam( param ).x + structure.points[ 3, 1 ]) * sqrt( 3 )/2 );
      col3.Radius := pBuildBaseParam( param ).r * sqrt( 3 )/2;

      col4.cX := (pBuildBaseParam( param ).x + structure.points[ 4, 1 ]) *
                 pBuildBaseParam( param ).r * 3/2;
      col4.cY := pBuildBaseParam( param ).r *
                ( (pBuildBaseParam( param ).y + structure.points[ 4, 2 ]) * sqrt( 3 ) +
                (pBuildBaseParam( param ).x + structure.points[ 4, 1 ]) * sqrt( 3 )/2 );
      col4.Radius := pBuildBaseParam( param ).r * sqrt( 3 )/2;

      health := Base_3_HP;
      use_eng := Base_3_UsEng;
      use_met := Base_3_UsMet;
      price_met := Base_3_Price;
    end;
  end;
  def_health := health;
  col := col1;
end;

procedure tBuildBase.Draw(param: pMapElemDrawParam);
begin
  if param = nil then exit;
  if kill then exit;

  case cnt of
    1: begin
      SSprite2D_Draw( tex1,
        SetX_ByCenter( col1.cX, param.w ),
        SetY_ByCenter( col1.cY, param.h ),
        param.w,
        param.h,
        param.angle,
        param.alpha );
    end;
    3: begin
      SSprite2D_Draw( tex1,
        SetX_ByCenter( col1.cX, param.w ),
        SetY_ByCenter( col1.cY, param.h ),
        param.w,
        param.h,
        param.angle,
        param.alpha );

      SSprite2D_Draw( tex2,
        SetX_ByCenter( col2.cX, param.w ),
        SetY_ByCenter( col2.cY, param.h ),
        param.w,
        param.h,
        param.angle,
        param.alpha );

      SSprite2D_Draw( tex3,
        SetX_ByCenter( col3.cX, param.w ),
        SetY_ByCenter( col3.cY, param.h ),
        param.w,
        param.h,
        param.angle,
        param.alpha );
    end;
    4: begin
      SSprite2D_Draw( tex1,
        SetX_ByCenter( col1.cX, param.w ),
        SetY_ByCenter( col1.cY, param.h ),
        param.w,
        param.h,
        param.angle,
        param.alpha );

      SSprite2D_Draw( tex2,
        SetX_ByCenter( col2.cX, param.w ),
        SetY_ByCenter( col2.cY, param.h ),
        param.w,
        param.h,
        param.angle,
        param.alpha );

      SSprite2D_Draw( tex3,
        SetX_ByCenter( col3.cX, param.w ),
        SetY_ByCenter( col3.cY, param.h ),
        param.w,
        param.h,
        param.angle,
        param.alpha );

      SSprite2D_Draw( tex4,
        SetX_ByCenter( col4.cX, param.w ),
        SetY_ByCenter( col4.cY, param.h ),
        param.w,
        param.h,
        param.angle,
        param.alpha );
    end;
  end;

end;

procedure tBuildBase.DrawInf;
begin
  if kill then exit;

  PR2D_Rect ( col1.cX - col1.Radius * 1.3, col1.cY - col1.Radius * 1.3,
              col1.Radius * 2.6, col1.Radius * 0.2, $000000 );
  PR2D_Rect ( col1.cX - col1.Radius * 1.3, col1.cY - col1.Radius * 1.3,
              col1.Radius * 2.6 * health / def_health, col1.Radius * 0.2, $ffffff,
              160, PR2D_FILL );
end;

procedure tBuildBase.Updt(param, param2: Pointer);
var ptr : pointer;
    blt : zglTLine;
begin
  if kill then exit;

  ptr := param;
  while ptr <> nil do begin
    blt.x0 := pBulletCh( ptr ).data.lx;
    blt.x1 := pBulletCh( ptr ).data.x;
    blt.y0 := pBulletCh( ptr ).data.ly;
    blt.y1 := pBulletCh( ptr ).data.y;
    if col2d_LineVsCircle( blt, col1 ) and
       not pBulletCh(ptr).data.side then begin
      pBulletCh( ptr ).data.kill := true;
      health := health - pBulletCh( ptr ).data.damage;
      //if health <= 0 then kill := true;
    end;
    ptr := pBulletCh( ptr ).prew;
  end;
end;

////////////////////////////////////////////////////////////////////////////////

constructor tBuildEng.Create(param: Pointer);
begin
  KILL := false;
  el_type := ME_BUILD;
  structure := pBuildEngParam( param ).str;
  cnt := structure.count;
  mx := pBuildEngParam( param ).x;
  my := pBuildEngParam( param ).y;
  case pBuildEngParam( param ).tp of
    1: begin
      tex1 := Resources.GetTex( pBuildEngParam( param ).tex1 );
      tex2 := nil;
      tex3 := nil;
      tex4 := nil;
      tex5 := nil;
      tex6 := nil;
      tex7 := nil;

      col1.cX := pBuildEngParam( param ).x *
                 pBuildEngParam( param ).r * 3/2;
      col1.cY := pBuildEngParam( param ).r *
                ( pBuildEngParam( param ).y * sqrt( 3 ) + pBuildEngParam( param ).x * sqrt( 3 )/2 );
      col1.Radius := pBuildEngParam( param ).r * sqrt( 3 )/2;

      health := Eng_1_HP;
      use_eng := Eng_1_UsEng;
      use_met := Eng_1_UsMet;
      price_met := Eng_1_Price;
    end;
    2: begin
      tex1 := Resources.GetTex( pBuildEngParam( param ).tex1 );
      tex2 := Resources.GetTex( pBuildEngParam( param ).tex2 );
      tex3 := Resources.GetTex( pBuildEngParam( param ).tex3 );
      tex4 := nil;
      tex5 := nil;
      tex6 := nil;
      tex7 := nil;

      col1.cX := pBuildEngParam( param ).x *
                 pBuildEngParam( param ).r * 3/2;
      col1.cY := pBuildEngParam( param ).r *
                ( pBuildEngParam( param ).y * sqrt( 3 ) + pBuildEngParam( param ).x * sqrt( 3 )/2 );
      col1.Radius := pBuildEngParam( param ).r * sqrt( 3 )/2;

      col2.cX := (pBuildEngParam( param ).x + structure.points[ 2, 1 ]) *
                 pBuildEngParam( param ).r * 3/2;
      col2.cY := pBuildEngParam( param ).r *
                ( (pBuildEngParam( param ).y + structure.points[ 2, 2 ]) * sqrt( 3 ) +
                (pBuildEngParam( param ).x + structure.points[ 2, 1 ]) * sqrt( 3 )/2 );
      col2.Radius := pBuildEngParam( param ).r * sqrt( 3 )/2;

      col3.cX := (pBuildEngParam( param ).x + structure.points[ 3, 1 ]) *
                 pBuildEngParam( param ).r * 3/2;
      col3.cY := pBuildEngParam( param ).r *
                ( (pBuildEngParam( param ).y + structure.points[ 3, 2 ]) * sqrt( 3 ) +
                (pBuildEngParam( param ).x + structure.points[ 3, 1 ]) * sqrt( 3 )/2 );
      col3.Radius := pBuildEngParam( param ).r * sqrt( 3 )/2;

      health := Eng_2_HP;
      use_eng := Eng_2_UsEng;
      use_met := Eng_2_UsMet;
      price_met := Eng_2_Price;
    end;
    3 : begin
      tex1 := Resources.GetTex( pBuildEngParam( param ).tex1 );
      tex2 := Resources.GetTex( pBuildEngParam( param ).tex2 );
      tex3 := Resources.GetTex( pBuildEngParam( param ).tex3 );
      tex4 := Resources.GetTex( pBuildEngParam( param ).tex4 );
      tex5 := Resources.GetTex( pBuildEngParam( param ).tex5 );
      tex6 := Resources.GetTex( pBuildEngParam( param ).tex6 );
      tex7 := Resources.GetTex( pBuildEngParam( param ).tex7 );

      col1.cX := pBuildEngParam( param ).x *
                 pBuildEngParam( param ).r * 3/2;
      col1.cY := pBuildEngParam( param ).r *
                ( pBuildEngParam( param ).y * sqrt( 3 ) + pBuildEngParam( param ).x * sqrt( 3 )/2 );
      col1.Radius := pBuildEngParam( param ).r * sqrt( 3 )/2;

      col2.cX := (pBuildEngParam( param ).x + structure.points[ 2, 1 ])*
                 pBuildEngParam( param ).r * 3/2;
      col2.cY := pBuildEngParam( param ).r *
                ( (pBuildEngParam( param ).y + structure.points[ 2, 2 ]) * sqrt( 3 ) +
                (pBuildEngParam( param ).x + structure.points[ 2, 1 ]) * sqrt( 3 )/2 );
      col2.Radius := pBuildEngParam( param ).r * sqrt( 3 )/2;

      col3.cX := (pBuildEngParam( param ).x + structure.points[ 3, 1 ]) *
                 pBuildEngParam( param ).r * 3/2;
      col3.cY := pBuildEngParam( param ).r *
                ( (pBuildEngParam( param ).y + structure.points[ 3, 2 ]) * sqrt( 3 ) +
                (pBuildEngParam( param ).x + structure.points[ 3, 1 ]) * sqrt( 3 )/2 );
      col3.Radius := pBuildEngParam( param ).r * sqrt( 3 )/2;

      col4.cX := (pBuildEngParam( param ).x + structure.points[ 4, 1 ]) *
                 pBuildEngParam( param ).r * 3/2;
      col4.cY := pBuildEngParam( param ).r *
                ( (pBuildEngParam( param ).y + structure.points[ 4, 2 ]) * sqrt( 3 ) +
                (pBuildEngParam( param ).x + structure.points[ 4, 1 ]) * sqrt( 3 )/2 );
      col4.Radius := pBuildEngParam( param ).r * sqrt( 3 )/2;

      col5.cX := (pBuildEngParam( param ).x + structure.points[ 5, 1 ]) *
                 pBuildEngParam( param ).r * 3/2;
      col5.cY := pBuildEngParam( param ).r *
                ( (pBuildEngParam( param ).y + structure.points[ 5, 2 ]) * sqrt( 3 ) +
                (pBuildEngParam( param ).x + structure.points[ 5, 1 ]) * sqrt( 3 )/2 );
      col5.Radius := pBuildEngParam( param ).r * sqrt( 3 )/2;

      col6.cX := (pBuildEngParam( param ).x + structure.points[ 6, 1 ]) *
                 pBuildEngParam( param ).r * 3/2;
      col6.cY := pBuildEngParam( param ).r *
                ( (pBuildEngParam( param ).y + structure.points[ 6, 2 ]) * sqrt( 3 ) +
                (pBuildEngParam( param ).x + structure.points[ 6, 1 ]) * sqrt( 3 )/2 );
      col6.Radius := pBuildEngParam( param ).r * sqrt( 3 )/2;

      col7.cX := (pBuildEngParam( param ).x + structure.points[ 7, 1 ]) *
                 pBuildEngParam( param ).r * 3/2;
      col7.cY := pBuildEngParam( param ).r *
                ( (pBuildEngParam( param ).y + structure.points[ 7, 2 ]) * sqrt( 3 ) +
                (pBuildEngParam( param ).x + structure.points[ 7, 1 ]) * sqrt( 3 )/2 );
      col7.Radius := pBuildEngParam( param ).r * sqrt( 3 )/2;

      health := Eng_3_HP;
      use_eng := Eng_3_UsEng;
      use_met := Eng_3_UsMet;
      price_met := Eng_3_Price;
    end;
  end;
  def_health := health;
  col := col1;
end;

procedure tBuildEng.Draw(param: pMapElemDrawParam);
begin
  if param = nil then exit;
  if kill then exit;

  case cnt of
    1: begin
      SSprite2D_Draw( tex1,
        SetX_ByCenter( col1.cX, param.w ),
        SetY_ByCenter( col1.cY, param.h ),
        param.w,
        param.h,
        param.angle,
        param.alpha );
    end;
    3: begin
      SSprite2D_Draw( tex1,
        SetX_ByCenter( col1.cX, param.w ),
        SetY_ByCenter( col1.cY, param.h ),
        param.w,
        param.h,
        param.angle,
        param.alpha );

      SSprite2D_Draw( tex2,
        SetX_ByCenter( col2.cX, param.w ),
        SetY_ByCenter( col2.cY, param.h ),
        param.w,
        param.h,
        param.angle,
        param.alpha );

      SSprite2D_Draw( tex3,
        SetX_ByCenter( col3.cX, param.w ),
        SetY_ByCenter( col3.cY, param.h ),
        param.w,
        param.h,
        param.angle,
        param.alpha );
    end;
    7: begin
      SSprite2D_Draw( tex1,
        SetX_ByCenter( col1.cX, param.w ),
        SetY_ByCenter( col1.cY, param.h ),
        param.w,
        param.h,
        param.angle,
        param.alpha );

      SSprite2D_Draw( tex2,
        SetX_ByCenter( col2.cX, param.w ),
        SetY_ByCenter( col2.cY, param.h ),
        param.w,
        param.h,
        param.angle,
        param.alpha );

      SSprite2D_Draw( tex3,
        SetX_ByCenter( col3.cX, param.w ),
        SetY_ByCenter( col3.cY, param.h ),
        param.w,
        param.h,
        param.angle,
        param.alpha );

      SSprite2D_Draw( tex4,
        SetX_ByCenter( col4.cX, param.w ),
        SetY_ByCenter( col4.cY, param.h ),
        param.w,
        param.h,
        param.angle,
        param.alpha );

      SSprite2D_Draw( tex5,
        SetX_ByCenter( col5.cX, param.w ),
        SetY_ByCenter( col5.cY, param.h ),
        param.w,
        param.h,
        param.angle,
        param.alpha );

      SSprite2D_Draw( tex6,
        SetX_ByCenter( col6.cX, param.w ),
        SetY_ByCenter( col6.cY, param.h ),
        param.w,
        param.h,
        param.angle,
        param.alpha );

      SSprite2D_Draw( tex7,
        SetX_ByCenter( col7.cX, param.w ),
        SetY_ByCenter( col7.cY, param.h ),
        param.w,
        param.h,
        param.angle,
        param.alpha );
    end;
  end;
end;

procedure tBuildEng.DrawInf;
begin
  if kill then exit;
  case cnt of
    1, 3: begin
      PR2D_Rect ( col1.cX - col1.Radius * 1.3, col1.cY - col1.Radius * 1.3,
        col1.Radius * 2.6, col1.Radius * 0.2, $000000 );
      PR2D_Rect ( col1.cX - col1.Radius * 1.3, col1.cY - col1.Radius * 1.3,
        col1.Radius * 2.6 * health / def_health, col1.Radius * 0.2, $ffffff,
        160, PR2D_FILL );
    end;
    7: begin
      PR2D_Rect ( col2.cX - col2.Radius * 1.3, col2.cY - col2.Radius * 1.3,
        col2.Radius * 2.6, col2.Radius * 0.2, $000000 );
      PR2D_Rect ( col2.cX - col2.Radius * 1.3, col2.cY - col2.Radius * 1.3,
        col2.Radius * 2.6 * health / def_health, col2.Radius * 0.2, $ffffff,
        160, PR2D_FILL );
    end;
  end;

end;

procedure tBuildEng.Updt(param, param2: Pointer);
var ptr : pointer;
    blt : zglTLine;
begin
  if kill then exit;
  ptr := param;
  while ptr <> nil do begin
    blt.x0 := pBulletCh( ptr ).data.lx;
    blt.x1 := pBulletCh( ptr ).data.x;
    blt.y0 := pBulletCh( ptr ).data.ly;
    blt.y1 := pBulletCh( ptr ).data.y;
    if col2d_LineVsCircle( blt, col1 ) and
       not pBulletCh(ptr).data.side then begin
      pBulletCh( ptr ).data.kill := true;
      health := health - pBulletCh( ptr ).data.damage;
      if health <= 0 then kill := true;
    end;
    ptr := pBulletCh( ptr ).prew;
  end;
end;

////////////////////////////////////////////////////////////////////////////////

constructor tBuildShaxt.Create(param: Pointer);
begin
  KILL := false;
  el_type := ME_BUILD;
  structure := pBuildShaxtParam( param ).str;
  cnt := structure.count;
  mx := pBuildShaxtParam( param ).x;
  my := pBuildShaxtParam( param ).y;
  case pBuildShaxtParam( param ).tp of
    1: begin
      tex1 := Resources.GetTex( pBuildShaxtParam( param ).tex1 );
      tex2 := nil;
      tex3 := nil;
      tex4 := nil;
      tex5 := nil;
      tex6 := nil;

      col1.cX := pBuildShaxtParam( param ).x *
                 pBuildShaxtParam( param ).r * 3/2;
      col1.cY := pBuildShaxtParam( param ).r *
                ( pBuildShaxtParam( param ).y * sqrt( 3 ) + pBuildShaxtParam( param ).x * sqrt( 3 )/2 );
      col1.Radius := pBuildShaxtParam( param ).r * sqrt( 3 )/2;

      health := Shaxt_1_HP;
      use_eng := Shaxt_1_UsEng;
      use_met := Shaxt_1_UsMet;
      price_met := Shaxt_1_Price;
    end;
    2: begin
      tex1 := Resources.GetTex( pBuildShaxtParam( param ).tex1 );
      tex2 := Resources.GetTex( pBuildShaxtParam( param ).tex2 );
      tex3 := Resources.GetTex( pBuildShaxtParam( param ).tex3 );
      tex4 := nil;
      tex5 := nil;
      tex6 := nil;

      col1.cX := pBuildShaxtParam( param ).x *
                 pBuildShaxtParam( param ).r * 3/2;
      col1.cY := pBuildShaxtParam( param ).r *
                ( pBuildShaxtParam( param ).y * sqrt( 3 ) + pBuildShaxtParam( param ).x * sqrt( 3 )/2 );
      col1.Radius := pBuildShaxtParam( param ).r * sqrt( 3 )/2;

      col2.cX := (pBuildShaxtParam( param ).x + structure.points[ 2, 1 ]) *
                 pBuildShaxtParam( param ).r * 3/2;
      col2.cY := pBuildShaxtParam( param ).r *
                ( (pBuildShaxtParam( param ).y + structure.points[ 2, 2 ]) * sqrt( 3 ) +
                (pBuildShaxtParam( param ).x + structure.points[ 2, 1 ]) * sqrt( 3 )/2 );
      col2.Radius := pBuildShaxtParam( param ).r * sqrt( 3 )/2;

      col3.cX := (pBuildShaxtParam( param ).x + structure.points[ 3, 1 ]) *
                 pBuildShaxtParam( param ).r * 3/2;
      col3.cY := pBuildShaxtParam( param ).r *
                ( (pBuildShaxtParam( param ).y + structure.points[ 3, 2 ]) * sqrt( 3 ) +
                (pBuildShaxtParam( param ).x + structure.points[ 3, 1 ]) * sqrt( 3 )/2 );
      col3.Radius := pBuildShaxtParam( param ).r * sqrt( 3 )/2;

      health := Shaxt_2_HP;
      use_eng := Shaxt_2_UsEng;
      use_met := Shaxt_2_UsMet;
      price_met := Shaxt_2_Price;
    end;
    3 : begin
      tex1 := Resources.GetTex( pBuildShaxtParam( param ).tex1 );
      tex2 := Resources.GetTex( pBuildShaxtParam( param ).tex2 );
      tex3 := Resources.GetTex( pBuildShaxtParam( param ).tex3 );
      tex4 := Resources.GetTex( pBuildShaxtParam( param ).tex4 );
      tex5 := Resources.GetTex( pBuildShaxtParam( param ).tex5 );
      tex6 := Resources.GetTex( pBuildShaxtParam( param ).tex6 );

      col1.cX := pBuildShaxtParam( param ).x *
                 pBuildShaxtParam( param ).r * 3/2;
      col1.cY := pBuildShaxtParam( param ).r *
                ( pBuildShaxtParam( param ).y * sqrt( 3 ) + pBuildShaxtParam( param ).x * sqrt( 3 )/2 );
      col1.Radius := pBuildShaxtParam( param ).r * sqrt( 3 )/2;

      col2.cX := (pBuildShaxtParam( param ).x + structure.points[ 2, 1 ])*
                 pBuildShaxtParam( param ).r * 3/2;
      col2.cY := pBuildShaxtParam( param ).r *
                ( (pBuildShaxtParam( param ).y + structure.points[ 2, 2 ]) * sqrt( 3 ) +
                (pBuildShaxtParam( param ).x + structure.points[ 2, 1 ]) * sqrt( 3 )/2 );
      col2.Radius := pBuildShaxtParam( param ).r * sqrt( 3 )/2;

      col3.cX := (pBuildShaxtParam( param ).x + structure.points[ 3, 1 ]) *
                 pBuildShaxtParam( param ).r * 3/2;
      col3.cY := pBuildShaxtParam( param ).r *
                ( (pBuildShaxtParam( param ).y + structure.points[ 3, 2 ]) * sqrt( 3 ) +
                (pBuildShaxtParam( param ).x + structure.points[ 3, 1 ]) * sqrt( 3 )/2 );
      col3.Radius := pBuildShaxtParam( param ).r * sqrt( 3 )/2;

      col4.cX := (pBuildShaxtParam( param ).x + structure.points[ 4, 1 ]) *
                 pBuildShaxtParam( param ).r * 3/2;
      col4.cY := pBuildShaxtParam( param ).r *
                ( (pBuildShaxtParam( param ).y + structure.points[ 4, 2 ]) * sqrt( 3 ) +
                (pBuildShaxtParam( param ).x + structure.points[ 4, 1 ]) * sqrt( 3 )/2 );
      col4.Radius := pBuildShaxtParam( param ).r * sqrt( 3 )/2;

      col5.cX := (pBuildShaxtParam( param ).x + structure.points[ 5, 1 ]) *
                 pBuildShaxtParam( param ).r * 3/2;
      col5.cY := pBuildShaxtParam( param ).r *
                ( (pBuildShaxtParam( param ).y + structure.points[ 5, 2 ]) * sqrt( 3 ) +
                (pBuildShaxtParam( param ).x + structure.points[ 5, 1 ]) * sqrt( 3 )/2 );
      col5.Radius := pBuildShaxtParam( param ).r * sqrt( 3 )/2;

      col6.cX := (pBuildShaxtParam( param ).x + structure.points[ 6, 1 ]) *
                 pBuildShaxtParam( param ).r * 3/2;
      col6.cY := pBuildShaxtParam( param ).r *
                ( (pBuildShaxtParam( param ).y + structure.points[ 6, 2 ]) * sqrt( 3 ) +
                (pBuildShaxtParam( param ).x + structure.points[ 6, 1 ]) * sqrt( 3 )/2 );
      col6.Radius := pBuildShaxtParam( param ).r * sqrt( 3 )/2;

      health := Shaxt_3_HP;
      use_eng := Shaxt_3_UsEng;
      use_met := Shaxt_3_UsMet;
      price_met := Shaxt_3_Price;
    end;
  end;
  def_health := health;
  col := col1;
end;

procedure tBuildShaxt.Draw(param: pMapElemDrawParam);
begin
  if param = nil then exit;
  if kill then exit;

  case cnt of
    1: begin
      SSprite2D_Draw( tex1,
        SetX_ByCenter( col1.cX, param.w ),
        SetY_ByCenter( col1.cY, param.h ),
        param.w,
        param.h,
        param.angle,
        param.alpha );
    end;
    3: begin
      SSprite2D_Draw( tex1,
        SetX_ByCenter( col1.cX, param.w ),
        SetY_ByCenter( col1.cY, param.h ),
        param.w,
        param.h,
        param.angle,
        param.alpha );

      SSprite2D_Draw( tex2,
        SetX_ByCenter( col2.cX, param.w ),
        SetY_ByCenter( col2.cY, param.h ),
        param.w,
        param.h,
        param.angle,
        param.alpha );

      SSprite2D_Draw( tex3,
        SetX_ByCenter( col3.cX, param.w ),
        SetY_ByCenter( col3.cY, param.h ),
        param.w,
        param.h,
        param.angle,
        param.alpha );
    end;
    6: begin
      SSprite2D_Draw( tex1,
        SetX_ByCenter( col1.cX, param.w ),
        SetY_ByCenter( col1.cY, param.h ),
        param.w,
        param.h,
        param.angle,
        param.alpha );

      SSprite2D_Draw( tex2,
        SetX_ByCenter( col2.cX, param.w ),
        SetY_ByCenter( col2.cY, param.h ),
        param.w,
        param.h,
        param.angle,
        param.alpha );

      SSprite2D_Draw( tex3,
        SetX_ByCenter( col3.cX, param.w ),
        SetY_ByCenter( col3.cY, param.h ),
        param.w,
        param.h,
        param.angle,
        param.alpha );

      SSprite2D_Draw( tex4,
        SetX_ByCenter( col4.cX, param.w ),
        SetY_ByCenter( col4.cY, param.h ),
        param.w,
        param.h,
        param.angle,
        param.alpha );

      SSprite2D_Draw( tex5,
        SetX_ByCenter( col5.cX, param.w ),
        SetY_ByCenter( col5.cY, param.h ),
        param.w,
        param.h,
        param.angle,
        param.alpha );

      SSprite2D_Draw( tex6,
        SetX_ByCenter( col6.cX, param.w ),
        SetY_ByCenter( col6.cY, param.h ),
        param.w,
        param.h,
        param.angle,
        param.alpha );
    end;
  end;
end;

procedure tBuildShaxt.DrawInf;
begin
  if kill then exit;
  case cnt of
    1, 3: begin
      PR2D_Rect ( col1.cX - col1.Radius * 1.3, col1.cY - col1.Radius * 1.3,
        col1.Radius * 2.6, col1.Radius * 0.2, $000000 );
      PR2D_Rect ( col1.cX - col1.Radius * 1.3, col1.cY - col1.Radius * 1.3,
        col1.Radius * 2.6 * health / def_health, col1.Radius * 0.2, $ffffff,
        160, PR2D_FILL );
    end;
    6: begin
      PR2D_Rect ( col2.cX - col2.Radius * 1.3, col2.cY - col2.Radius * 1.3,
        col2.Radius * 2.6, col2.Radius * 0.2, $000000 );
      PR2D_Rect ( col2.cX - col2.Radius * 1.3, col2.cY - col2.Radius * 1.3,
        col2.Radius * 2.6 * health / def_health, col2.Radius * 0.2, $ffffff,
        160, PR2D_FILL );
    end;
  end;
end;

procedure tBuildShaxt.Updt(param, param2: Pointer);
var ptr : pointer;
    blt : zglTLine;
begin
  if kill then exit;
  ptr := param;
  while ptr <> nil do begin
    blt.x0 := pBulletCh( ptr ).data.lx;
    blt.x1 := pBulletCh( ptr ).data.x;
    blt.y0 := pBulletCh( ptr ).data.ly;
    blt.y1 := pBulletCh( ptr ).data.y;
    if col2d_LineVsCircle( blt, col1 ) and
       not pBulletCh(ptr).data.side then begin
      pBulletCh( ptr ).data.kill := true;
      health := health - pBulletCh( ptr ).data.damage;
      if health <= 0 then kill := true;
    end;
    ptr := pBulletCh( ptr ).prew;
  end;
end;

////////////////////////////////////////////////////////////////////////////////

constructor tBuildMing.Create(param: Pointer);
begin
  last_tm := timer_GetTicks;
  KILL := false;
  el_type := ME_BUILD;
  gun := true;
  structure := pBuildMingParam( param ).str;
  cnt := structure.count;
  mx := pBuildMingParam( param ).x;
  my := pBuildMingParam( param ).y;
  case pBuildMingParam( param ).tp of
    1: begin
      tex1 := Resources.GetTex( pBuildMingParam( param ).tex1 );
      tex2 := nil;
      tex3 := nil;

      col1.cX := pBuildMingParam( param ).x *
                 pBuildMingParam( param ).r * 3/2;
      col1.cY := pBuildMingParam( param ).r *
                ( pBuildMingParam( param ).y * sqrt( 3 ) + pBuildMingParam( param ).x * sqrt( 3 )/2 );
      col1.Radius := pBuildMingParam( param ).r * sqrt( 3 )/2;

      health := Ming_1_HP;
      use_eng := ming_1_UsEng;
      use_met := ming_1_UsMet;
      price_met := ming_1_Price;

      damage := Ming_1_dmg;
      atk_pr_tm := Ming_1_atk;
      atk_dtm := PROD_DT / atk_pr_tm;
    end;
    2: begin
      tex1 := Resources.GetTex( pBuildMingParam( param ).tex1 );
      tex2 := nil;
      tex3 := nil;

      col1.cX := pBuildMingParam( param ).x *
                 pBuildMingParam( param ).r * 3/2;
      col1.cY := pBuildMingParam( param ).r *
                ( pBuildMingParam( param ).y * sqrt( 3 ) + pBuildMingParam( param ).x * sqrt( 3 )/2 );
      col1.Radius := pBuildMingParam( param ).r * sqrt( 3 )/2;

      health := Ming_2_HP;
      use_eng := ming_2_UsEng;
      use_met := ming_2_UsMet;
      price_met := ming_2_Price;

      damage := Ming_2_dmg;
      atk_pr_tm := Ming_2_atk;
      atk_dtm := PROD_DT / atk_pr_tm;
    end;
    3 : begin
      tex1 := Resources.GetTex( pBuildMingParam( param ).tex1 );
      tex2 := Resources.GetTex( pBuildMingParam( param ).tex2 );
      tex3 := Resources.GetTex( pBuildMingParam( param ).tex3 );

      col1.cX := pBuildMingParam( param ).x *
                 pBuildMingParam( param ).r * 3/2;
      col1.cY := pBuildMingParam( param ).r *
                ( pBuildMingParam( param ).y * sqrt( 3 ) + pBuildMingParam( param ).x * sqrt( 3 )/2 );
      col1.Radius := pBuildMingParam( param ).r * sqrt( 3 )/2;

      col2.cX := (pBuildMingParam( param ).x + structure.points[ 2, 1 ])*
                 pBuildMingParam( param ).r * 3/2;
      col2.cY := pBuildMingParam( param ).r *
                ( (pBuildMingParam( param ).y + structure.points[ 2, 2 ]) * sqrt( 3 ) +
                (pBuildMingParam( param ).x + structure.points[ 2, 1 ]) * sqrt( 3 )/2 );
      col2.Radius := pBuildMingParam( param ).r * sqrt( 3 )/2;

      col3.cX := (pBuildMingParam( param ).x + structure.points[ 3, 1 ]) *
                 pBuildMingParam( param ).r * 3/2;
      col3.cY := pBuildMingParam( param ).r *
                ( (pBuildMingParam( param ).y + structure.points[ 3, 2 ]) * sqrt( 3 ) +
                (pBuildMingParam( param ).x + structure.points[ 3, 1 ]) * sqrt( 3 )/2 );
      col3.Radius := pBuildMingParam( param ).r * sqrt( 3 )/2;

      health := Ming_3_HP;
      use_eng := ming_3_UsEng;
      use_met := ming_3_UsMet;
      price_met := ming_3_Price;

      damage := Ming_1_dmg;
      atk_pr_tm := Ming_1_atk;
      atk_dtm := PROD_DT / atk_pr_tm;
    end;
  end;
  def_health := health;
  col := col1;
end;

procedure tBuildMing.Draw(param: pMapElemDrawParam);
begin
  if param = nil then exit;
  if kill then exit;

  case cnt of
    1: begin
      SSprite2D_Draw( tex1,
        SetX_ByCenter( col1.cX, param.w ),
        SetY_ByCenter( col1.cY, param.h ),
        param.w,
        param.h,
        param.angle,
        param.alpha );
    end;
    3: begin
      SSprite2D_Draw( tex1,
        SetX_ByCenter( col1.cX, param.w ),
        SetY_ByCenter( col1.cY, param.h ),
        param.w,
        param.h,
        param.angle,
        param.alpha );

      SSprite2D_Draw( tex2,
        SetX_ByCenter( col2.cX, param.w ),
        SetY_ByCenter( col2.cY, param.h ),
        param.w,
        param.h,
        param.angle,
        param.alpha );

      SSprite2D_Draw( tex3,
        SetX_ByCenter( col3.cX, param.w ),
        SetY_ByCenter( col3.cY, param.h ),
        param.w,
        param.h,
        param.angle,
        param.alpha );
    end;
  end;
end;

procedure tBuildMing.DrawInf;
begin
  if kill then exit;
  PR2D_Rect ( col1.cX - col1.Radius * 1.3, col1.cY - col1.Radius * 1.3,
    col1.Radius * 2.6, col1.Radius * 0.2, $000000 );
  PR2D_Rect ( col1.cX - col1.Radius * 1.3, col1.cY - col1.Radius * 1.3,
    col1.Radius * 2.6 * health / def_health, col1.Radius * 0.2, $ffffff,
    160, PR2D_FILL );
end;

procedure tBuildMing.Updt(param, param2: Pointer);
var ptr : pointer;
    blt : zglTLine;
    dt : single;
    mx, my : single;
    nx, ny : single;
    mr, nr : single;
begin
  if kill then exit;

  ptr := param;
  while ptr <> nil do begin
    blt.x0 := pBulletCh( ptr ).data.lx;
    blt.x1 := pBulletCh( ptr ).data.x;
    blt.y0 := pBulletCh( ptr ).data.ly;
    blt.y1 := pBulletCh( ptr ).data.y;
    if col2d_LineVsCircle( blt, col1 ) and
       not pBulletCh(ptr).data.side then begin
      pBulletCh( ptr ).data.kill := true;
      health := health - pBulletCh( ptr ).data.damage;
      if health <= 0 then kill := true;
    end;
    ptr := pBulletCh( ptr ).prew;
  end;

  dt := timer_GetTicks - last_tm;
  if dt > atk_dtm then begin
    ptr := param2;
    mx := 100500;
    my := 100500;
    while ptr <> nil do begin
      nx := pEnemyCh( ptr ).data.x;
      ny := pEnemyCh( ptr ).data.y;
      nr := sqrt( sqr(col1.cX-nx) + sqr(col1.cY-ny) );
      mr := sqrt( sqr(col1.cX-mx) + sqr(col1.cY-my) );
      if nr < mr then begin
        mx := nx;
        my := ny;
      end;
      ptr := pEnemyCh( ptr ).prew;
    end;

    last_tm := timer_GetTicks;
    map.AddBullet( col1.cX, col1.cY, mx, my, 5, damage, true );
  end;
end;

////////////////////////////////////////////////////////////////////////////////

constructor tBuildRocg.Create(param: Pointer);
begin
  last_tm := timer_GetTicks;
  KILL := false;
  el_type := ME_BUILD;
  gun := true;
  structure := pBuildRocgParam( param ).str;
  cnt := structure.count;
  mx := pBuildRocgParam( param ).x;
  my := pBuildRocgParam( param ).y;
  case pBuildRocgParam( param ).tp of
    1: begin
      tex1 := Resources.GetTex( pBuildRocgParam( param ).tex1 );
      tex2 := nil;
      tex3 := nil;

      col1.cX := pBuildRocgParam( param ).x *
                 pBuildRocgParam( param ).r * 3/2;
      col1.cY := pBuildRocgParam( param ).r *
                ( pBuildRocgParam( param ).y * sqrt( 3 ) + pBuildRocgParam( param ).x * sqrt( 3 )/2 );
      col1.Radius := pBuildRocgParam( param ).r * sqrt( 3 )/2;

      health := rocg_1_HP;
      use_eng := rocg_1_UsEng;
      use_met := rocg_1_UsMet;
      price_met := rocg_1_Price;

      damage := rocg_1_dmg;
      atk_pr_tm := rocg_1_atk;
      atk_dtm := PROD_DT / atk_pr_tm;
    end;
    2: begin
      tex1 := Resources.GetTex( pBuildRocgParam( param ).tex1 );
      tex2 := Resources.GetTex( pBuildRocgParam( param ).tex2 );
      tex3 := nil;

      col1.cX := pBuildRocgParam( param ).x *
                 pBuildRocgParam( param ).r * 3/2;
      col1.cY := pBuildRocgParam( param ).r *
                ( pBuildRocgParam( param ).y * sqrt( 3 ) + pBuildRocgParam( param ).x * sqrt( 3 )/2 );
      col1.Radius := pBuildRocgParam( param ).r * sqrt( 3 )/2;

      col2.cX := (pBuildRocgParam( param ).x + structure.points[ 2, 1 ])*
                 pBuildRocgParam( param ).r * 3/2;
      col2.cY := pBuildRocgParam( param ).r *
                ( (pBuildRocgParam( param ).y + structure.points[ 2, 2 ]) * sqrt( 3 ) +
                (pBuildRocgParam( param ).x + structure.points[ 2, 1 ]) * sqrt( 3 )/2 );
      col2.Radius := pBuildRocgParam( param ).r * sqrt( 3 )/2;

      health := rocg_2_HP;
      use_eng := rocg_2_UsEng;
      use_met := rocg_2_UsMet;
      price_met := rocg_2_Price;

      damage := Rocg_2_dmg;
      atk_pr_tm := Rocg_2_atk;
      atk_dtm := PROD_DT / atk_pr_tm;
    end;
    3 : begin
      tex1 := Resources.GetTex( pBuildRocgParam( param ).tex1 );
      tex2 := Resources.GetTex( pBuildRocgParam( param ).tex2 );
      tex3 := Resources.GetTex( pBuildRocgParam( param ).tex3 );

      col1.cX := pBuildRocgParam( param ).x *
                 pBuildRocgParam( param ).r * 3/2;
      col1.cY := pBuildRocgParam( param ).r *
                ( pBuildRocgParam( param ).y * sqrt( 3 ) + pBuildRocgParam( param ).x * sqrt( 3 )/2 );
      col1.Radius := pBuildRocgParam( param ).r * sqrt( 3 )/2;

      col2.cX := (pBuildRocgParam( param ).x + structure.points[ 2, 1 ])*
                 pBuildRocgParam( param ).r * 3/2;
      col2.cY := pBuildRocgParam( param ).r *
                ( (pBuildRocgParam( param ).y + structure.points[ 2, 2 ]) * sqrt( 3 ) +
                (pBuildRocgParam( param ).x + structure.points[ 2, 1 ]) * sqrt( 3 )/2 );
      col2.Radius := pBuildRocgParam( param ).r * sqrt( 3 )/2;

      col3.cX := (pBuildRocgParam( param ).x + structure.points[ 3, 1 ]) *
                 pBuildRocgParam( param ).r * 3/2;
      col3.cY := pBuildRocgParam( param ).r *
                ( (pBuildRocgParam( param ).y + structure.points[ 3, 2 ]) * sqrt( 3 ) +
                (pBuildRocgParam( param ).x + structure.points[ 3, 1 ]) * sqrt( 3 )/2 );
      col3.Radius := pBuildRocgParam( param ).r * sqrt( 3 )/2;

      health := rocg_3_HP;
      use_eng := rocg_3_UsEng;
      use_met := rocg_3_UsMet;
      price_met := rocg_3_Price;

      damage := rocg_3_dmg;
      atk_pr_tm := rocg_3_atk;
      atk_dtm := PROD_DT / atk_pr_tm;
    end;
  end;
  def_health := health;
  col := col1;
end;

procedure tBuildRocg.Draw(param: pMapElemDrawParam);
begin
  if param = nil then exit;
    if kill then exit;

  case cnt of
    1: begin
      SSprite2D_Draw( tex1,
        SetX_ByCenter( col1.cX, param.w ),
        SetY_ByCenter( col1.cY, param.h ),
        param.w,
        param.h,
        param.angle,
        param.alpha );
    end;
    2: begin
      SSprite2D_Draw( tex1,
        SetX_ByCenter( col1.cX, param.w ),
        SetY_ByCenter( col1.cY, param.h ),
        param.w,
        param.h,
        param.angle,
        param.alpha );

      SSprite2D_Draw( tex2,
        SetX_ByCenter( col2.cX, param.w ),
        SetY_ByCenter( col2.cY, param.h ),
        param.w,
        param.h,
        param.angle,
        param.alpha );
    end;
    3: begin
      SSprite2D_Draw( tex1,
        SetX_ByCenter( col1.cX, param.w ),
        SetY_ByCenter( col1.cY, param.h ),
        param.w,
        param.h,
        param.angle,
        param.alpha );

      SSprite2D_Draw( tex2,
        SetX_ByCenter( col2.cX, param.w ),
        SetY_ByCenter( col2.cY, param.h ),
        param.w,
        param.h,
        param.angle,
        param.alpha );

      SSprite2D_Draw( tex3,
        SetX_ByCenter( col3.cX, param.w ),
        SetY_ByCenter( col3.cY, param.h ),
        param.w,
        param.h,
        param.angle,
        param.alpha );
    end;
  end;
end;

procedure tBuildRocg.DrawInf;
begin
  if kill then exit;
  PR2D_Rect ( col1.cX - col1.Radius * 1.3, col1.cY - col1.Radius * 1.3,
    col1.Radius * 2.6, col1.Radius * 0.2, $000000 );
  PR2D_Rect ( col1.cX - col1.Radius * 1.3, col1.cY - col1.Radius * 1.3,
    col1.Radius * 2.6 * health / def_health, col1.Radius * 0.2, $ffffff,
    160, PR2D_FILL );
end;

procedure tBuildRocg.Updt(param, param2: Pointer);
var ptr : pointer;
    blt : zglTLine;
    dt : single;
    mx, my : single;
    nx, ny : single;
    mr, nr : single;    
begin
  if kill then exit;
  ptr := param;
  while ptr <> nil do begin
    blt.x0 := pBulletCh( ptr ).data.lx;
    blt.x1 := pBulletCh( ptr ).data.x;
    blt.y0 := pBulletCh( ptr ).data.ly;
    blt.y1 := pBulletCh( ptr ).data.y;
    if col2d_LineVsCircle( blt, col1 ) and
       not pBulletCh(ptr).data.side then begin
      pBulletCh( ptr ).data.kill := true;
      health := health - pBulletCh( ptr ).data.damage;
      if health <= 0 then kill := true;
    end;
    ptr := pBulletCh( ptr ).prew;
  end;

  dt := -last_tm + timer_GetTicks;
  if dt > atk_dtm then begin
    ptr := param2;
    mx := 100500;
    my := 100500;
    while ptr <> nil do begin
      nx := pEnemyCh( ptr ).data.x;
      ny := pEnemyCh( ptr ).data.y;
      nr := sqrt( sqr(col1.cX-nx) + sqr(col1.cY-ny) );
      mr := sqrt( sqr(col1.cX-mx) + sqr(col1.cY-my) );
      if nr < mr then begin
        mx := nx;
        my := ny;
      end;
      ptr := pEnemyCh( ptr ).prew;
    end;

    last_tm := timer_GetTicks;
    map.AddBullet( col1.cX, col1.cY, mx, my, 5, damage, true );
  end;
end;

////////////////////////////////////////////////////////////////////////////////

constructor tBuildLazr.Create(param: Pointer);
begin
  last_tm := timer_GetTicks;
  KILL := false;
  el_type := ME_BUILD;
  gun := true;
  structure := pBuildlazrParam( param ).str;
  cnt := structure.count;
  mx := pBuildLazrParam( param ).x;
  my := pBuildLazrParam( param ).y;
  case pBuildlazrParam( param ).tp of
    1: begin
      tex1 := Resources.GetTex( pBuildLazrParam( param ).tex1 );

      col1.cX := pBuildlazrParam( param ).x *
                 pBuildlazrParam( param ).r * 3/2;
      col1.cY := pBuildlazrParam( param ).r *
                ( pBuildlazrParam( param ).y * sqrt( 3 ) + pBuildlazrParam( param ).x * sqrt( 3 )/2 );
      col1.Radius := pBuildlazrParam( param ).r * sqrt( 3 )/2;

      health := lazr_1_HP;
      use_eng := lazr_1_UsEng;
      use_met := lazr_1_UsMet;
      price_met := lazr_1_Price;

      damage := lazr_1_dmg;
      atk_pr_tm := lazr_1_atk;
      atk_dtm := PROD_DT / atk_pr_tm;
    end;
    2: begin
      tex1 := Resources.GetTex( pBuildlazrParam( param ).tex1 );

      col1.cX := pBuildlazrParam( param ).x *
                 pBuildlazrParam( param ).r * 3/2;
      col1.cY := pBuildlazrParam( param ).r *
                ( pBuildlazrParam( param ).y * sqrt( 3 ) + pBuildlazrParam( param ).x * sqrt( 3 )/2 );
      col1.Radius := pBuildlazrParam( param ).r * sqrt( 3 )/2;

      health := lazr_2_HP;
      use_eng := lazr_2_UsEng;
      use_met := lazr_2_UsMet;
      price_met := lazr_2_Price;

      damage := Lazr_2_dmg;
      atk_pr_tm := Lazr_2_atk;
      atk_dtm := PROD_DT / atk_pr_tm;
    end;
    3 : begin
      tex1 := Resources.GetTex( pBuildlazrParam( param ).tex1 );

      col1.cX := pBuildlazrParam( param ).x *
                 pBuildlazrParam( param ).r * 3/2;
      col1.cY := pBuildlazrParam( param ).r *
                ( pBuildlazrParam( param ).y * sqrt( 3 ) + pBuildlazrParam( param ).x * sqrt( 3 )/2 );
      col1.Radius := pBuildlazrParam( param ).r * sqrt( 3 )/2;

      health := Lazr_3_HP;
      use_eng := lazr_3_UsEng;
      use_met := lazr_3_UsMet;
      price_met := lazr_3_Price;

      damage := Lazr_3_dmg;
      atk_pr_tm := Lazr_3_atk;
      atk_dtm := PROD_DT / atk_pr_tm;
    end;
  end;
  def_health := health;
  col := col1;
end;

procedure tBuildLazr.Draw(param: pMapElemDrawParam);
begin
  if param = nil then exit;
  if kill then exit;

  case cnt of
    1: begin
      SSprite2D_Draw( tex1,
        SetX_ByCenter( col1.cX, param.w ),
        SetY_ByCenter( col1.cY, param.h ),
        param.w,
        param.h,
        param.angle,
        param.alpha );
    end;
  end;
end;

procedure tBuildLazr.DrawInf;
begin
  if kill then exit;
  PR2D_Rect ( col1.cX - col1.Radius * 1.3, col1.cY - col1.Radius * 1.3,
    col1.Radius * 2.6, col1.Radius * 0.2, $000000 );
  PR2D_Rect ( col1.cX - col1.Radius * 1.3, col1.cY - col1.Radius * 1.3,
    col1.Radius * 2.6 * health / def_health, col1.Radius * 0.2, $ffffff,
    160, PR2D_FILL );
end;

procedure tBuildLazr.Updt(param, param2: Pointer);
var ptr : pointer;
    blt : zglTLine;
    dt : single;
    mx, my : single;
    nx, ny : single;
    mr, nr : single;
begin
  if kill then exit;
  ptr := param;
  while ptr <> nil do begin
    blt.x0 := pBulletCh( ptr ).data.lx;
    blt.x1 := pBulletCh( ptr ).data.x;
    blt.y0 := pBulletCh( ptr ).data.ly;
    blt.y1 := pBulletCh( ptr ).data.y;
    if col2d_LineVsCircle( blt, col1 ) and
       not pBulletCh(ptr).data.side then begin
      pBulletCh( ptr ).data.kill := true;
      health := health - pBulletCh( ptr ).data.damage;
      if health <= 0 then kill := true;
    end;
    ptr := pBulletCh( ptr ).prew;
  end;

  dt := -last_tm + timer_GetTicks;
  if dt > atk_dtm then begin
    ptr := param2;
    mx := 100500;
    my := 100500;
    while ptr <> nil do begin
      nx := pEnemyCh( ptr ).data.x;
      ny := pEnemyCh( ptr ).data.y;
      nr := sqrt( sqr(col1.cX-nx) + sqr(col1.cY-ny) );
      mr := sqrt( sqr(col1.cX-mx) + sqr(col1.cY-my) );
      if nr < mr then begin
        mx := nx;
        my := ny;
      end;
      ptr := pEnemyCh( ptr ).prew;
    end;

    last_tm := timer_GetTicks;
    map.AddBullet( col1.cX, col1.cY, mx, my, 5, damage, true );
  end;

end;

////////////////////////////////////////////////////////////////////////////////

initialization
  cPosBuilds [ 1 ].count := 1;
  cPosBuilds [ 1 ].points [ 1, 1 ] := cMove [ 0, 1 ];
  cPosBuilds [ 1 ].points [ 1, 2 ] := cMove [ 0, 2 ];

  cPosBuilds [ 2 ].count := 2;
  cPosBuilds [ 2 ].points [ 1, 1 ] := cMove [ 0, 1 ];
  cPosBuilds [ 2 ].points [ 1, 2 ] := cMove [ 0, 2 ];
  cPosBuilds [ 2 ].points [ 2, 1 ] := cMove [ 3, 1 ];
  cPosBuilds [ 2 ].points [ 2, 2 ] := cMove [ 3, 2 ];

  cPosBuilds [ 3 ].count := 3;
  cPosBuilds [ 3 ].points [ 1, 1 ] := cMove [ 0, 1 ];
  cPosBuilds [ 3 ].points [ 1, 2 ] := cMove [ 0, 2 ];
  cPosBuilds [ 3 ].points [ 2, 1 ] := cMove [ 5, 1 ];
  cPosBuilds [ 3 ].points [ 2, 2 ] := cMove [ 5, 2 ];
  cPosBuilds [ 3 ].points [ 3, 1 ] := cMove [ 3, 1 ];
  cPosBuilds [ 3 ].points [ 3, 2 ] := cMove [ 3, 2 ];

  cPosBuilds [ 4 ].count := 3;
  cPosBuilds [ 4 ].points [ 1, 1 ] := cMove [ 0, 1 ];
  cPosBuilds [ 4 ].points [ 1, 2 ] := cMove [ 0, 2 ];
  cPosBuilds [ 4 ].points [ 2, 1 ] := cMove [ 3, 1 ];
  cPosBuilds [ 4 ].points [ 2, 2 ] := cMove [ 3, 2 ];
  cPosBuilds [ 4 ].points [ 3, 1 ] := cMove [ 4, 1 ];
  cPosBuilds [ 4 ].points [ 3, 2 ] := cMove [ 4, 2 ];

  cPosBuilds [ 5 ].count := 4;
  cPosBuilds [ 5 ].points [ 1, 1 ] := cMove [ 0, 1 ];
  cPosBuilds [ 5 ].points [ 1, 2 ] := cMove [ 0, 2 ];
  cPosBuilds [ 5 ].points [ 2, 1 ] := cMove [ 3, 1 ];
  cPosBuilds [ 5 ].points [ 2, 2 ] := cMove [ 3, 2 ];
  cPosBuilds [ 5 ].points [ 3, 1 ] := cMove [ 4, 1 ];
  cPosBuilds [ 5 ].points [ 3, 2 ] := cMove [ 4, 2 ];
  cPosBuilds [ 5 ].points [ 4, 1 ] := cMove [ 5, 1 ];
  cPosBuilds [ 5 ].points [ 4, 2 ] := cMove [ 5, 2 ];

  cPosBuilds [ 6 ].count := 7;
  cPosBuilds [ 6 ].points [ 1, 1 ] := cMove [ 0, 1 ];
  cPosBuilds [ 6 ].points [ 1, 2 ] := cMove [ 0, 2 ];
  cPosBuilds [ 6 ].points [ 2, 1 ] := cMove [ 1, 1 ];
  cPosBuilds [ 6 ].points [ 2, 2 ] := cMove [ 1, 2 ];
  cPosBuilds [ 6 ].points [ 3, 1 ] := cMove [ 2, 1 ];
  cPosBuilds [ 6 ].points [ 3, 2 ] := cMove [ 2, 2 ];
  cPosBuilds [ 6 ].points [ 4, 1 ] := cMove [ 3, 1 ];
  cPosBuilds [ 6 ].points [ 4, 2 ] := cMove [ 3, 2 ];
  cPosBuilds [ 6 ].points [ 5, 1 ] := cMove [ 4, 1 ];
  cPosBuilds [ 6 ].points [ 5, 2 ] := cMove [ 4, 2 ];
  cPosBuilds [ 6 ].points [ 6, 1 ] := cMove [ 5, 1 ];
  cPosBuilds [ 6 ].points [ 6, 2 ] := cMove [ 5, 2 ];
  cPosBuilds [ 6 ].points [ 7, 1 ] := cMove [ 6, 1 ];
  cPosBuilds [ 6 ].points [ 7, 2 ] := cMove [ 6, 2 ];

  cPosBuilds [ 7 ].count := 6;
  cPosBuilds [ 7 ].points [ 1, 1 ] := cMove [ 0, 1 ];
  cPosBuilds [ 7 ].points [ 1, 2 ] := cMove [ 0, 2 ];
  cPosBuilds [ 7 ].points [ 2, 1 ] := cMove [ 1, 1 ];
  cPosBuilds [ 7 ].points [ 2, 2 ] := cMove [ 1, 2 ];
  cPosBuilds [ 7 ].points [ 3, 1 ] := cMove [ 5, 1 ];
  cPosBuilds [ 7 ].points [ 3, 2 ] := cMove [ 5, 2 ];
  cPosBuilds [ 7 ].points [ 4, 1 ] := 2*cMove [ 5, 1 ];
  cPosBuilds [ 7 ].points [ 4, 2 ] := 2*cMove [ 5, 2 ];
  cPosBuilds [ 7 ].points [ 5, 1 ] := cMove [ 3, 1 ];
  cPosBuilds [ 7 ].points [ 5, 2 ] := cMove [ 3, 2 ];
  cPosBuilds [ 7 ].points [ 6, 1 ] := 2*cMove [ 3, 1 ];
  cPosBuilds [ 7 ].points [ 6, 2 ] := 2*cMove [ 3, 2 ];
end.
