unit uLoad;

interface

procedure LoadInit ( patch : string );
procedure LoadDraw;
procedure LoadUpdate;

implementation

uses  zglHeader,
      uGlobalData,
      uResources,
      uINI_Files,
      uLogo,
      uMainMenu;

var DF          : textfile;     //
    DataList    : string;
    Count_AllRes: integer;      //  
    Now_AllRes  : integer;      // .  
    Last_Loaded : string;       //    
    TexSorted   : boolean;      //  
    SndSorted   : boolean;      //  
    FontAssigned: boolean = false;
    Done        : boolean;      // 
    dt          : double;       //
///////////////////////  
var AnimBar : zglPTexture;
    AnimBar_FrameCount : byte;
    AnimBar_NowFrame   : byte;
    AnimBar_LastFrameTm: single;
    AnimBar_DT         : byte;
    AnimBar_Param      : tTexParam;
var ProgressBar       : zglPTexture;
    ProgressBar_WD    : integer;
    ProgressBar_Param : tTexParam;
var Text_X, Text_Y    : integer;
var Textures       : array of zglPTexture;
    Textures_Param : array of tTexParam;
    Count_Textures : integer;

procedure LoadInit ( patch : string );
var s : string;
    dx, dy : integer;
    fc     : integer;
    i      : integer;
    param  : tTexParam;
    t1, t2, t3, t4 : integer;
begin
  AssignFile( DF, patch );
  Reset ( DF );
  Readln( DF, s );
  DataList := s;

  Readln( DF );
  Readln( DF, Text_X, Text_Y );
  if Text_X < 0 then Text_X := DefScrW + Text_X;
  if Text_Y < 0 then Text_Y := DefScrH + Text_Y;

  Readln( DF );
  Readln( DF, s );
  Readln( DF, dx, dy, fc, AnimBar_DT );
  AnimBar_FrameCount := fc;
  if dx < 0 then dx := DefScrW - abs( dx );
  if dy < 0 then dy := DefScrH - abs( dy );
  AnimBar := Tex_LoadFromFile( DataFolder + s, $FF000000, TEX_DEFAULT_2D );
//  Tex_SetFrameSize( AnimBar, fw, fh );
  AnimBar_NowFrame := 1;
  AnimBar_Param.x := dx;
  AnimBar_Param.y := dy;
  AnimBar_Param.w := AnimBar.Width;
  AnimBar_Param.h := AnimBar.Height;

  Readln( DF );
  Readln( DF, s );
  Readln( DF, dx, dy, t1 );
  ProgressBar_WD := DefScrW - 2 * abs( dx );
//  if dx < 0 then dx := DefScrW - abs( dx );
  if dy < 0 then dy := DefScrH - abs( dy );
  ProgressBar := Tex_LoadFromFile( DataFolder + s, $FF000000, TEX_DEFAULT_2D );
  ProgressBar_Param.x := DefScrW - dx;
  ProgressBar_Param.y := dy;
  ProgressBar_Param.w := 0;
  ProgressBar_Param.h := t1;

  Readln( DF );
  Readln( DF, Count_Textures );
  SetLength( Textures, Count_Textures );
  SetLength( Textures_Param, Count_Textures );
  for i := 0 to Count_Textures - 1 do begin
    Readln( DF );
    Readln( DF, s );
    Textures[ i ] := Tex_LoadFromFile( DataFolder + s, $FF000000, TEX_DEFAULT_2D );

    Readln( DF, t1, t2, t3, t4 );
    if t1 = 1 then param.AftText    := true else param.AftText    := false;
    if t2 = 1 then param.AftPrBar   := true else param.AftPrBar   := false;
    if t3 = 1 then param.ByCenter_W := true else param.ByCenter_W := false;
    if t4 = 1 then param.ByCenter_H := true else param.ByCenter_H := false;

    Readln( DF, t1, t2 );
    if t1 = 0       then param.w := Textures[ i ].Width;
    if t1 = 100500  then param.w := DefScrW;
    if t1 < 0       then param.w := DefScrW + t1;

    if t2 = 0       then param.h := Textures[ i ].Height;
    if t2 = 100500  then param.h := DefScrH;
    if t2 < 0       then param.h := DefScrH + t2;

    Readln( DF, t1, t2 );
    if param.ByCenter_W then t3 := round( DefScrW / 2 ) else t3 := 0;
    if param.ByCenter_H then t4 := round( DefScrH / 2 ) else t4 := 0;
    if ( t1 < 0 ) and ( t3 = 0 ) then begin
      t1 := DefScrW + t1;
    end else begin
      if ( t1 < 0 ) and ( t3 <> 0 ) then t1 := t3 + t1
        else if t1 >= 0 then t1 := t3 + t1;
    end;
    if ( t2 < 0 ) and ( t4 = 0 ) then begin
      t2 := DefScrH + t2;
    end else begin
      if ( t2 < 0 ) and ( t4 <> 0 ) then t2 := t4 + t2
        else if t2 >= 0 then t2 := t4 + t2;
    end;

    if param.w = 100200 then param.w := DefScrW - t1;
    if param.h = 100200 then param.h := DefScrH - t2;   

    param.x := t1;
    param.y := t2;

    Readln( DF, t1 );
    param.alph := t1;

    Textures_Param[ i ] := param;
  end;
  CloseFile( DF );

  AssignFile( DF, DataFolder + DataList );
  Reset ( DF );
  Readln( DF, Count_AllRes );
  Now_AllRes  := 0;
  Done        := false;
  TexSorted   := false;
  SndSorted   := false;
  Last_Loaded := '';

  AnimBar_LastFrameTm := timer_GetTicks;
end;

procedure LoadDraw;
var i : integer;
    px, py, pw : single;
    ang : single;
begin
  for i := 0 to Count_Textures - 1 do begin
    if Textures_Param[ i ].AftText  then Continue;
    if Textures_Param[ i ].AftPrBar then Continue;

    SSprite2D_Draw( Textures[ i ], Textures_Param[ i ].x, Textures_Param[ i ].y,
                    Textures_Param[ i ].w, Textures_Param[ i ].h, 0,
                    Textures_Param[ i ].alph );
  end;

  // 
  Text_Draw( Font1, Text_X, Text_Y, Last_Loaded );

  //   
  for i := 0 to Count_Textures - 1 do begin
    if not Textures_Param[ i ].AftText  then Continue;
    if Textures_Param[ i ].AftPrBar then Continue;

    SSprite2D_Draw( Textures[ i ], Textures_Param[ i ].x, Textures_Param[ i ].y,
                    Textures_Param[ i ].w, Textures_Param[ i ].h, 0,
                    Textures_Param[ i ].alph );
  end;

  //  
  pw := ProgressBar_WD - ProgressBar_WD * Now_AllRes / Count_AllRes;
  if pw < 0 then pw := 0;
  
  px := ProgressBar_Param.x - pw;
  py := ProgressBar_Param.y;
  SSprite2D_Draw( ProgressBar, px, py, pw,
                  ProgressBar_Param.h, 0 );

  //    
  for i := 0 to Count_Textures - 1 do begin
    if Textures_Param[ i ].AftText  then Continue;
    if not Textures_Param[ i ].AftPrBar then Continue;

    SSprite2D_Draw( Textures[ i ], Textures_Param[ i ].x, Textures_Param[ i ].y,
                    Textures_Param[ i ].w, Textures_Param[ i ].h, 0,
                    Textures_Param[ i ].alph );
  end;

  //  
  ang := 360 - 360 * ( AnimBar_FrameCount / AnimBar_NowFrame );
  SSprite2D_Draw( AnimBar, AnimBar_Param.x, AnimBar_Param.y,
                  AnimBar_Param.w, AnimBar_Param.h, ang );


end;

procedure LoadUpdate;
var i       : integer;
    tp, pch : string;
begin
  if Done then begin
    //,     
    //    
    if not TexSorted then begin
      Resources.SortAllTex;
      TexSorted := true;
      Exit;
    end;
    if not SndSorted then begin
//      Resources.SortAllSnd;
      SndSorted := true;
      Exit;
    end;
    if not FontAssigned then begin
      {Font1Big.Pages[ 0 ] := Resources.GetTex( 'arial_32_pg0' );
      Font1Big.Pages[ 1 ] := Resources.GetTex( 'arial_32_pg1' );
      Font2.Pages[ 0 ]    := Resources.GetTex( 'comic_16_pg0' );
      Font2Big.Pages[ 0 ] := Resources.GetTex( 'comic_32_pg0' );
      Font2Big.Pages[ 1 ] := Resources.GetTex( 'comic_32_pg1' );}
      FontAssigned := true;
    end;

    
    if ( timer_GetTicks - dt ) > ( Timer_dt-1 ) then begin
      for i := 0 to Count_Textures - 1 do
        tex_Del( Textures[ i ] );
      tex_Del( AnimBar );
      tex_Del( ProgressBar  );        

      Scene  := NextScene;
      GScene := NextGScene;
      NextProc;
    end;
    dt := timer_GetTicks;
    exit;
  end;

  if ( timer_GetTicks - AnimBar_LastFrameTm ) > AnimBar_DT then begin
    AnimBar_LastFrameTm := timer_GetTicks;
    Inc( AnimBar_NowFrame );
    if AnimBar_NowFrame > AnimBar_FrameCount then AnimBar_NowFrame := 1;
  end;


  Last_Loaded := ':' + #10 + #10;
  for i := 1 to 1 do begin
    Inc( Now_AllRes );
    if Now_AllRes > Count_AllRes then begin
      CloseFile( DF );
      Last_Loaded := '  !';
      Done := true;
      dt   := timer_GetTicks;
      break;
    end else begin
      Readln( DF, tp  );
      Readln( DF, pch );
      if tp = 'tex' then begin
        Resources.LoadTexFrom( pch );
      end else begin
//        Resources.LoadSndFrom( pch );
      end;
      Last_Loaded := Last_Loaded+'->  '+pch;
    end;
  end;

end;

end.
