unit uLogo;

interface

procedure LogoFstInit;
procedure LogoInit( sc : byte );
procedure LogoDraw;
procedure LogoUpdate;

implementation

uses  zglHeader,
      uResources,
      uGlobalData,
      uMainMenu;

var UpScrA, DownScrA, BeWait, GoNext: boolean;
    Time, Waiting : integer;
    Logo  : zglPTexture;
    NowSc : byte;
var Textures       : array of zglPTexture;
    Textures_Name  : array of string;
    Textures_Param : array of tTexParam;
    Count_Textures : integer;

procedure LogoFstInit;
var DF     : textfile;
    i      : integer;
    param  : tTexParam;
    s      : string;
    t1, t2, t3, t4 : integer;
begin
  AssignFile( DF, DataFolder + 'scenes\logo.scene' );
  Reset ( DF );

  Readln( DF, Count_Textures );
  SetLength( Textures,       Count_Textures );
  SetLength( Textures_Name,  Count_Textures );
  SetLength( Textures_Param, Count_Textures );
  for i := 0 to Count_Textures - 1 do begin
    Readln( DF );
    Readln( DF, s );
    Textures[ i ] := Resources.GetTex( s );
    Textures_Name[ i ] := s;

    Readln( DF, t1, t2, t3, t4 );
    if t1 = 1 then param.AftText    := true else param.AftText    := false;
    if t2 = 1 then param.AftPrBar   := true else param.AftPrBar   := false;
    if t3 = 1 then param.ByCenter_W := true else param.ByCenter_W := false;
    if t4 = 1 then param.ByCenter_H := true else param.ByCenter_H := false;

    Readln( DF, t1, t2 );
    if t1 = 0       then param.w := Textures[ i ].Width;
    if t1 = 100500  then param.w := DefScrW;
    if t1 < 0       then param.w := DefScrW + t1;
    //////
    if t2 = 0       then param.h := Textures[ i ].Height;
    if t2 = 100500  then param.h := DefScrH;
    if t2 < 0       then param.h := DefScrH + t2;

    Readln( DF, t1, t2 );
    /////
    if t1 = 100500 then begin
      param.x := DefScrW / 2 - Textures[ i ].Width  / 2;
    end else begin
      if param.ByCenter_W then t3 := round( DefScrW / 2 ) else t3 := 0;
      if ( t1 < 0 ) and ( t3 = 0 ) then begin
        t1 := DefScrW + t1;
      end else begin
        if ( t1 < 0 ) and ( t3 <> 0 ) then t1 := t3 + t1
          else if t1 >= 0 then t1 := t3 + t1;
      end;
      ///////
      param.x := t1;
    end;
    /////
    if t2 = 100500 then begin
      param.y := DefScrH / 2 - Textures[ i ].Height / 2;
    end else begin
      if param.ByCenter_H then t4 := round( DefScrH / 2 ) else t4 := 0;
      if ( t2 < 0 ) and ( t4 = 0 ) then begin
        t2 := DefScrH + t2;
      end else begin
        if ( t2 < 0 ) and ( t4 <> 0 ) then t2 := t4 + t2
          else if t2 >= 0 then t2 := t4 + t2;
      end;
      //////
      param.y := t2;
    end;
    /////
    if param.w = 100200 then param.w := DefScrW - param.x;
    if param.h = 100200 then param.h := DefScrH - param.y;

    Readln( DF, t1 );
    param.alph := t1;

    Textures_Param[ i ] := param;
  end;
  CloseFile( DF );

  LogoInit( 1 );
end;

procedure LogoInit( sc : byte );
var i : integer;
begin
  NowSc := sc;

  if NowSc > Count_Textures then begin
    for i := 0 to Count_Textures - 1 do
      Resources.DelTex( Textures_Name[ i ] );
    Resources.SortAllTex;

    Scene := sMenu;
    MainMenuInit;
  end else begin
    GlobScrAlpha := 255;
    DownScrA := true;
    UpScrA   := false;
    BeWait   := false;
    GoNext   := false;  
  end;
end;

procedure LogoDraw;
var t : single;
begin
  SSprite2D_Draw( Textures[ NowSc - 1 ],
                  Textures_Param[ NowSc - 1 ].x,
                  Textures_Param[ NowSc - 1 ].y,
                  Textures_Param[ NowSc - 1 ].w,
                  Textures_Param[ NowSc - 1 ].h,
                  0 );
  t := Text_GetWidth( Font2, '   ' )+10;
  PR2D_Rect( DefScrW/2 - t/2, DefScrH-24, t, 24, $000000, 128, PR2D_FILL );
  Text_Draw( Font2, DefScrW/2, DefScrH-20, '   ', TEXT_HALIGN_CENTER );
end;

procedure LogoUpdate;
begin
  if Key_Press( K_SPACE ) then begin
    GlobScrAlpha :=0;
    Scene := sMenu;
    MainMenuInit;
    exit;
  end;

  if DownScrA then begin
    Dec( GlobScrAlpha, 5 );
    if GlobScrALpha <= 6 then begin
      GlobScrAlpha := 0;
      DownScrA := false;
      BeWait   := true;
      GoNext   := false;
      Waiting  := 100;
      Time     := 0;
    end;
  end;
  if BeWait then begin
    Inc( Time );
    if Time > Waiting then begin
      BeWait := false;
      if GoNext then begin
        LogoInit( NowSc + 1 );
      end else begin
      UpScrA       := true;
      GlobScrAlpha := 0;
      end;
    end;
  end;
  if UpScrA then begin
    Inc( GlobScrAlpha, 5 );
    if GlobScrALpha >= 249 then begin
      GlobScrAlpha := 255;
      UpScrA  := false;
      BeWait  := true;
      GoNext  := true;
      Waiting := 20;
      Time    := 0
    end;
  end;
end;

end.
