unit uMainMenu;

interface

procedure MainMenuInit;
procedure MainMenuDraw;
procedure MainMenuUpdate;

implementation

uses  zglHeader,
      uGlobalData,
      uMainMenuGUI,
      uGUI,
      uHelp;

procedure HideMenuGUI;
begin
  GUI_SetLayer( 0 );
end;

procedure ShowMenuGUI;
begin
  GUI_SetLayer( MainMenu_GUI );
  MoveButtons := false;
  if GoGame then begin
    Bn_NewGame.GUIMan.LastFocused.Focus := false;
    Bn_NewGame.GUIMan.LastFocused := Bn_NewGame;
    Bn_NewGame.Focus := true;
    GoGame := false;
  end;
  if GoOptions then begin
    Bn_Options.GUIMan.LastFocused.Focus := false;
    Bn_Options.GUIMan.LastFocused := Bn_Options;
    Bn_Options.Focus := true;
    GoOptions := false;
  end;
  if GoHelp then begin
    Bn_Help.GUIMan.LastFocused.Focus := false;
    Bn_Help.GUIMan.LastFocused := Bn_Help;
    Bn_Help.Focus := true;
    GoHelp := false;
  end;
end;

procedure MainMenuInit;
begin
  if not MenuGUICreated then begin
    InitMMGData;
    InitMenuGUI;
    MenuGUICreated := true;
  end;
  ShowMenuGUI;  
end;

procedure MainMenuDraw;
begin
  PR2D_Rect( 0, 0,
             DefScrW, DefScrH, $ffffff,
             255, PR2D_FILL );
  // 
  MMGDraw;
end;

procedure MainMenuUpdate;
begin
///////////////////////////////////////////////////////
/// 
  if GlobScrAlpha > GlobScrAlpha_DownSpeed then begin
    Dec( GlobScrAlpha, GlobScrAlpha_DownSpeed );
    exit;
  end else GlobScrAlpha := 0;
///////////////////////////////////////////////////////

  mGUI_Update;
  MMGUpdt;
end;

end.
