unit uResources;

interface

uses  zglHeader;
//      uBass;

type  pResTex = ^tResTex;
      tResTex = record
        Name : string;        //        
        Tex  : zglPTexture;   // 
      end;

type  pTexParam = ^tTexParam;
      tTexParam = record
        x, y : single;
        w, h : single;
        alph : byte;

        AftText    : boolean;
        AftPrBar   : boolean;
        ByCenter_W : boolean;
        ByCenter_H : boolean;        
      end;

{type  pResSnd = ^tResSnd;
      tResSnd = record
        Name : string;
        Snd  : tSound;
      end;}

type  pResources = ^tResources;
      tResources = class
        public
          constructor Create;

          procedure   LoadTexFromList( patch : string );   //  
          procedure   LoadTexFrom    ( patch : string );   //   
          function    GetTex( TexName : string ) : zglPTexture;  //   
          procedure   DelTex( TexName : string );
          procedure   SortAllTex;   //  

          procedure   LoadSndFromList( patch : string );
//          procedure   LoadSndFrom    ( patch : string );
//          function    GetSnd( SndName : string ) : pSound;
//          procedure   DelSnd( SndName : string );
//          procedure   SortAllSnd;

          function    GetTexCount : integer;
//          function    GetSndCount : integer;
        protected
          AllTex       : array of tResTex;
          Count_AllTex : integer;

//          AllSnd       : array of tResSnd;
//          Count_AllSnd : integer;
      end;

implementation

uses uGlobalData;

constructor tResources.Create;
begin
  Count_AllTex := 0;
  SetLength( AllTex, Count_AllTex );
//  Count_AllSnd := 0;
//  SetLength( AllSnd, Count_AllSnd );
end;

{$REGION '  TEX  '}

procedure tResources.LoadTexFromList( patch: string );
begin
end;

procedure tResources.LoadTexFrom( patch: string );
var tc : cardinal;
    anm, anm_w, anm_h : integer;
    nm, pch : string;
    DF : textfile;
begin
  AssignFile( DF, DataFolder + patch );
  Reset( DF );
  Inc  ( Count_AllTex );
  SetLength( AllTex, Count_AllTex );
  Readln( DF, nm );
  Readln( DF, pch );
  Read  ( DF, tc, anm );
  if anm > 0 then Readln( DF, anm_w, anm_h );
  AllTex[ Count_AllTex-1 ].Name := nm;
  AllTex[ Count_AllTex-1 ].Tex  := Tex_LoadFromFile( DataFolder + pch, tc, TEX_DEFAULT_2D );
  if anm > 0 then Tex_SetFrameSize( AllTex[ Count_AllTex-1 ].Tex, anm_w, anm_h );
  CloseFile( DF );
end;

function tResources.GetTex( texname: string ) : zglPTexture;
var i : integer;
begin
  if Count_AllTex = 0 then begin
    result := ErrorTex;
    exit;
  end;
  result := ErrorTex;
  for i:=0 to Count_AllTex-1 do begin
    if AllTex[ i ].Name = texname then begin
      result := AllTex[ i ].Tex;
      break;
    end;
  end;
end;

procedure tResources.DelTex( TexName: string );
begin

end;

procedure tResources.SortAllTex;
begin
end;

{$ENDREGION}

{$REGION '  SND  '}

procedure tResources.LoadSndFromList;
begin
end;

{procedure tResources.LoadSndFrom( patch: string );
var nm, pch : string;
    DF : textfile;
begin
  AssignFile( DF, DataFolder + patch );
  Reset( DF );
  Inc  ( Count_AllSnd );
  SetLength( AllSnd, Count_AllSnd );
  Readln( DF, nm );
  Readln( DF, pch );
  AllSnd[ Count_AllSnd-1 ].Name := nm;
  Load_Sound( AllSnd[ Count_AllSnd-1 ].Snd, DataFolder+pch );
  CloseFile( DF );
end;

function  tResources.GetSnd(SndName: string) : pSound;
var i : integer;
begin
  if Count_AllSnd = 0 then begin
    result := nil;
    exit;
  end;
  result := nil;
  for i:=0 to Count_AllSnd-1 do begin
    if AllSnd[ i ].Name = SndName then begin
      result := @AllSnd[ i ].Snd;
      break;
    end;
  end;
end;

procedure tResources.DelSnd( SndName: string );
begin

end;

procedure tResources.SortAllSnd;
begin

end;}

{$ENDREGION}

function tResources.GetTexCount;
begin
  result := Count_AllTex;
end;

{function tResources.GetSndCount;
begin
  result := Count_AllSnd;
end;}

end.
