{
\file		DGLE2.h
\author		Korotkov Andrey aka DRON
\version	Beta 1 RC4 Fix
\date		22.03.2010 (c)Korotkov Andrey

\brief		Main DGLE2 engine header.

To use engine you should just include this header to your project.
This header is a part of DGLE2_SDK.
}

unit DGLE2;

interface

{$IFDEF FPC}
  {$MODE DELPHI}
{$ENDIF}

uses Windows, DGLE2_types;

const
		_DGLE2_VER_						= 'Beta 1 RC4';
		_DGLE2_SDK_VER_					= 1;
		_DGLE2_PLUGIN_SDK_VER_			= _DGLE2_SDK_VER_;

{Engine SubSystem interface flags}

    //E_ENGINE_SUB_SYSTEM
		ESS_RENDER						= 0;
		ESS_INPUT						= 1;
		ESS_SOUND						= 2;
		ESS_RESOURCE_MANAGER			= 3;
		ESS_FILESYSTEM					= 4;

{Engine Base Object interface flags}

    //E_ENG_OBJ_TYPE
		EOT_UNKNOWN 					= 0;
		EOT_3DNODE						= 1;
		EOT_TEXTURE						= 2;
		EOT_MESH						= 3;
		EOT_MODEL						= 4;
		EOT_SHADER						= 5;
		EOT_PROGRAM						= 6;
		EOT_BITMAP_FONT					= 7;
		EOT_PARTICLE_EFFECT				= 8;
		EOT_SOUND_SAMPLE				= 9;
		EOT_MUSIC						= 10;

{Events Interfaces flags}

    //E_EVENT_TYPE
		ET_UNKNOWN						= 0;
		ET_BEFORE_INIT					= 1;
		ET_BEFORE_RENDER				= 2;
		ET_AFTER_RENDER					= 3;
		ET_ON_PROFILER_DRAW				= 4;
		ET_ON_WIN_MESSAGE				= 5;
		ET_ON_GET_SSYSTEM				= 6;

 {Main Engine System flags}

	//E_ENGINE_PROCEDURE_TYPE
		EPT_PROCESS						= 0;
		EPT_RENDER						= 1;
		EPT_INIT 						= 2;
		EPT_FREE 						= 3;

	//E_LOG_TYPE
		LT_INFO							= 0;
		LT_WARNING						= 1;
		LT_ERROR						= 2;
		LT_FATAL						= 3;

	//E_ENGINE_INIT_FLAGS
		EIF_DEFAULT						= $00000000;
		EIF_CATCH_UNHANDLED				= $00000001;
		EIF_FORCE_NO_SOUND				= $00000002;
 		EIF_LOAD_ALL_PLUGINS			= $00000004;
		EIF_FORCE_API_INPUT				= $00000010;
		EIF_FORCE_LIMIT_FPS				= $00000020;
		EIF_FORCE_16_BIT_COLOR			= $00000040;


{Resource Manager SubSystem flags}

	//E_TEXTURE_CREATION_FLAGS
		TCF_COLOR_RGB					= $00000001;
		TCF_COLOR_RGBA					= $00000002;
		TCF_COLOR_ALPHA					= $00000004;
		TCF_COLOR_BGR					= $00000010;
		TCF_COLOR_BGRA					= $00000020;
		TCF_COLOR_COMPRESSED_RGB		= $00000040;	//DXT1
		TCF_COLOR_COMPRESSED_RGBA		= $00000080;	//DXT5
		TCF_DEPTH_COMPONENT				= $00000008;
		TCF_PIXEL_ALIGNMENT_1			= $00000100;	//use only if your texture input data is not 4 byte aligned
		TCF_MIPMAPS_PRESENTED			= $00001000;	//all mip levels must be presented

    //E_TEXTURE_LOAD_FLAGS
		TLF_FILTERING_NONE				= $00000001;
		TLF_FILTERING_BILINEAR			= $00000002;
		TLF_FILTERING_TRILINEAR			= $00000004;
		TLF_FILTERING_ANISOTROPIC		= $00000008;

		TLF_DECREASE_QUALITY_MEDIUM		= $00000020;
		TLX_DECREASE_QUALITY_HIGH		= $00000040;

		TLX_COMPRESS					= $00000100;

		TLF_COORDS_REPEAT	 			= $00001000;
		TLF_COORDS_CLAMP				= $00002000;

		TLF_GENERATE_MIPMAPS			= $00004000;

		TLF_ANISOTROPY_2X				= $00010000;
		TLF_ANISOTROPY_4X				= $00020000;
		TLF_ANISOTROPY_8X				= $00040000;
		TLF_ANISOTROPY_16X				= $00080000;
		
	//E_SHADER_TYPE
		ST_VERTEX 						= 0;
		ST_PIXEL						= 1;

	//E_MESH_CREATION_FLAGS
        MCF_ONLY_DEFAULT_DATA			= $00000000;//vertex and index arrays must be presented
		MCF_NORMALS_PRESENTED			= $00000001;
		MCF_TEXTURE_COORDS_PRESENTED	= $00000002;
		MCF_TANGENT_SPACE_PRESENTED		= $00000004;
		
	//E_MESH_LOAD_FLAGS
		MLF_EDITABLE					= $00000001;
		MLF_FORCE_NO_VBO				= $00000002;
		MLF_CALCULATE_TANGENT_SPACE 	= $00000004;
		MLF_BUILD_FASET_NORMALS			= $00000008;

		TEXTURE_LOAD_DEFAULT_2D = TLF_FILTERING_BILINEAR	or TLF_COORDS_CLAMP;
		TEXTURE_LOAD_DEFAULT_3D = TLF_FILTERING_TRILINEAR	or TLF_GENERATE_MIPMAPS or TLF_COORDS_REPEAT;

		RES_LOAD_DEFAULT 				= $00000000;	

{Render SubSystem flags}

	//E_GET_POINT3_FLAG
		GP3F_FROM_Z_BUFFER				= $00000000;
		GP3F_FROM_FAR_PLANE				= $00000001;
		GP3F_FROM_NEAR_PLANE			= $00000002;

	//E_RENDER_SUPPORTED_FEATURES
		RSF_TEXTURE_COMPRESSION			= 0;
		RSF_VERTEX_BUFFER_OBJECT		= 1;

{Render2D interface FLAGS}

	//E_PRIMITIVE2D_FLAGS
		PF_DEFAULT						= $00000000;
		PF_FILL							= $00000001;
		PF_SMOOTH						= $00000002;
		PF_VCA							= $00000004;

	//E_EFFECT2D_FLAGS
		EF_DEFAULT						= $00000000;
		EF_BLEND						= $00000001;
		EF_FLIPX						= $00000002;
		EF_FLIPY						= $00000004;
		EF_COLORMIX						= $00000008;
		EF_SCALE						= $00000010;
		EF_VERTICES_OFFSET				= $00000020;
		EF_VERTICES_COLOR				= $00000040;
		EF_ROTATEPT						= $00000080;

	//E_EFFECT2D_BLENDING_FLAGS
		EBF_NONE						= $00000000;
		EBF_NORMAL						= $00000001;
		EBF_ADD							= $00000002;
		EBF_MULT						= $00000004;
		EBF_BLACK						= $00000008;
		EBF_WHITE						= $00000010;
		EBF_MASK						= $00000020;

	//E_BATCH_MODE2D
 		BM_AUTO							= 0;
		BM_DISABLED						= 1;
		BM_ENABLED_UEP					= 2;		//update batches every process tick
		BM_ENABLED_UER					= 3;		//update batches every render frame
		
{Render3D interface FLAGS}

	//E_PUSH_STATES_FLAGS
		PSF_ALL							= $00000000;
		PSF_MATRIX						= $00000001;
		PSF_STATES						= $00000002;


	//E_UNIFORM_TYPE
		UT_FLOAT1						= 0;
		UT_FLOAT2						= 1;
		UT_FLOAT3						= 2;
		UT_FLOAT4						= 3;
		UT_FLOAT2X2						= 4;
		UT_FLOAT3X3						= 5;
		UT_FLOAT4X4						= 6;
		UT_INT1							= 7;
		UT_INT2							= 8;
		UT_INT3							= 9;
		UT_INT4							= 10;
		UT_BOOL1						= 11;
		UT_BOOL2						= 12;
		UT_BOOL3						= 13;
		UT_BOOL4						= 14;
		UT_SAMPLER_1D					= 15;
		UT_SAMPLER_2D					= 16;
		UT_SAMPLER_3D					= 17;
		UT_SAMPLER_CUBE					= 18;
		UT_SAMPLER_1D_SHADOW			= 19;
		UT_SAMPLER_2D_SHADOW			= 20;
		UT_SAMPLER_2D_RECT				= 21;
		UT_SAMPLER_2D_RECT_SHADOW		= 22;

	//E_ATTRIBUTE_TYPE
		AT_FLOAT1						= 0;
		AT_FLOAT2						= 1;
		AT_FLOAT3						= 2;
		AT_FLOAT4						= 3;
		AT_FLOAT2X2						= 4;
		AT_FLOAT3X3						= 5;
		AT_FLOAT4X4						= 6;

{Input Subsystem flags}

	//E_INPUT_CONFIGURATION_FLAGS
		ICF_DEFAULT						= $00000000;
		ICF_FOREGROUND					= $00000001;
		ICF_EXCLUSIVE					= $00000002;
		ICF_BLOCK_WINKEYS				= $00000004;
		ICF_HIDE_CURSOR					= $00000008;
		ICF_CURSOR_BEYOND_SCREEN		= $00000010;

{SoundSample interface}

	//E_SOUND_EFFECTS	
		SE_NONE							= $00000000;
		SE_CHORUS						= $00000001;
		SE_COMPRESSOR					= $00000002;
		SE_DISTORTION					= $00000004;
		SE_ECHO							= $00000008;
		SE_FLANGER						= $00000010;
		SE_GARGLE						= $00000020;
		SE_REVERB						= $00000040;

{FileSystem interfaces flags}

	//E_FIND_FLAGS
		FF_RECURSIVE					= 1;

	//E_FILE_SYSTEM_OPEN_FLAGS
		FSOF_READ						= $00000001;
		FSOF_WRITE						= $00000002;
		FSOF_TRUNK						= $00000004;
		FSOF_BINARY						= $00000008;

	//E_FILE_SYSTEM_SEEK_FLAG
		FSSF_BEGIN						= 0;
		FSSF_CURRENT					= 1;
		FSSF_END						= 2;

type

	IDGLE2_Base = interface(IUnknown)
	['{4D1BFC28-0CE1-408d-94B4-069D8BA36105}']

		function GetGUID(out stGuid : TGUID): HRESULT; stdcall;

	end;

//Engine SubSystem interface//

	IEngineSubSystem = interface(IDGLE2_Base)
	['{C682F875-E0BD-4af9-B79C-E209850025F8}']

		function GetType(out eSubSystemType :{E_ENGINE_SUB_SYSTEM}Integer): HRESULT; stdcall;

	end;

//Engine Plugin interface//

	IPlugin = interface(IDGLE2_Base)
	['{B94E0E40-8885-41dd-8BC5-4CD663AE5709}']

		function GetPluginInfo(out stInfo : TPluginInfo): HRESULT; stdcall;
		function GetPluginInterfaceName(pcName : PAnsiChar; uiCharsCount : Cardinal): HRESULT; stdcall;

	end;

//Engine Base Object interface//

	IEngBaseObj = interface(IDGLE2_Base)
	['{C010239A-6457-40f5-87EF-FAA3156CE6E2}']

		function Free(): HRESULT; stdcall;
		function GetType(out eObjType :{ENG_OBJ_TYPE}Integer): HRESULT; stdcall;

	end;

//Events Interfaces//

	IBaseEvent = interface(IDGLE2_Base)
	['{6DFEF982-AADF-42e9-A369-378BDB31404A}']

		function GetEventType(out eEvType :{E_EVENT_TYPE}Integer): HRESULT; stdcall;

	end;

	IEvBeforeInit = interface(IBaseEvent)
	['{EB735739-3D12-4522-B6D7-EEE3225DF934}']

		function SetEngParams(const stWindowParam : TEngWindow;  eInitFlags :{E_ENGINE_INIT_FLAGS}Integer): HRESULT; stdcall;
		function GetEngParams(out stWindowParam : TEngWindow; eInitFlags :{E_ENGINE_INIT_FLAGS}Integer): HRESULT; stdcall;

	end;

	IEvWinMessage = interface(IBaseEvent)
	['{8D718E48-581D-4cbb-9C40-C04998106F8D}']

		function GetWinMessage(out stWinMsg : TWinMessage): HRESULT; stdcall;

	end;

	IEvGetSubSystem = interface(IBaseEvent)
	['{2B6D2547-716E-490c-B1F1-422CB428738F}']

		function GetSubSystemType(eSubSystem :{E_ENGINE_SUB_SYSTEM}Integer): HRESULT; stdcall;
		function OverrideSubSystem(prSubSystem : IEngineSubSystem): HRESULT; stdcall;

	end;

//Main Engine System//

	TProcedure = Procedure(pParametr : Pointer); stdcall;
	TEventProcedure = Procedure(pParametr : Pointer; const prBaseEvent : IBaseEvent); stdcall;
	TStringProcedure = Procedure(pParametr : Pointer; const pcParam : PAnsiChar); stdcall;
	
	IEngineCore = interface(IDGLE2_Base)
	['{111BB884-2BA6-4e84-95A5-5E4700309CBA}']

		function InitializeEngine(stHandle : TWinHandle; const pcApplicationName : PAnsiChar; const stWindowParam : TEngWindow; uiProcessInterval : Cardinal = 33; eInitFlags :{E_ENGINE_INIT_FLAGS}Integer = EIF_DEFAULT): HRESULT; stdcall;
		function SetProcessInterval(uiProcessInterval : Cardinal): HRESULT; stdcall;	
		function StartEngine(): HRESULT; stdcall;
		function QuitEngine(): HRESULT; stdcall;

		function ConnectPlugin(const pcFileName : PAnsiChar; out prPlugin : IPlugin): HRESULT; stdcall;
		function DisconnectPlugin(pPlugin : IPlugin): HRESULT; stdcall;
		function GetPlugin(const pcPluginName : PAnsiChar; out prPlugin : IPlugin): HRESULT; stdcall;

		function AddProcedure(eProcType :{E_ENGINE_PROCEDURE_TYPE}Integer; pProc : TProcedure; pParametr : Pointer = nil): HRESULT; stdcall;
		function RemoveProcedure(eProcType :{E_ENGINE_PROCEDURE_TYPE}Integer; pProc: TProcedure; pParametr : Pointer = nil): HRESULT; stdcall;

		function AddEventListner(eEventType :{E_EVENT_TYPE}Integer; pListnerProc : TEventProcedure; pParametr : Pointer): HRESULT; stdcall;
		function RemoveEventListner(eEventType :{E_EVENT_TYPE}Integer; pListnerProc : TEventProcedure; pParametr : Pointer): HRESULT; stdcall;

		function GetSubsystem( eSubSystem :{E_ENGINE_SUB_SYSTEM}Integer; out prSubSystem : IEngineSubSystem ): HRESULT; stdcall;

		function RenderProfilerTxt(const pcTxt : PAnsiChar; const stColor : TColor4): HRESULT; stdcall;
		function GetInstanceIdx(out uiIdx : Cardinal): HRESULT; stdcall;
		function GetTimer(out uiTimer : Longword): HRESULT; stdcall;
		function GetSysInfo(out stSysInfo : TSystemInfo): HRESULT; stdcall;
		function GetCurrentWin(out stWin : TEngWindow): HRESULT; stdcall;
		function GetFPS(out uiFPS : Cardinal): HRESULT; stdcall;
		function GetHandle(out stHandle : TWinHandle): HRESULT; stdcall;

		function ChangeWinMode(const stNewWin : TEngWindow): HRESULT; stdcall;
		function AllowPause(bAllow : Boolean): HRESULT; stdcall;

		function AddToLog(const pcTxt : PAnsiChar): HRESULT; stdcall;
		function AddToLogEx(const pcTxt : PAnsiChar;  eType :{E_LOG_TYPE}Integer; const pcSrcFileName : PAnsiChar; iSrcLineNumber : Integer): HRESULT; stdcall;

		function ConsoleVisible(bIsVisible : Boolean): HRESULT; stdcall;
		function ConsoleWrite(const pcTxt : PAnsiChar; bWriteToPreviousLine : Boolean = false): HRESULT; stdcall;
		function ConsoleExec(const pcCommandTxt : PAnsiChar): HRESULT; stdcall;
		function ConsoleRegComProc(const pcCommandName : PAnsiChar; const pcCommandHelp : PAnsiChar; pProc : TStringProcedure; pParametr : Pointer = nil): HRESULT; stdcall;
		function ConsoleRegComValue(const pcCommandName : PAnsiChar; const pcCommandHelp : PAnsiChar; var piValue :Integer; iMinValue : Integer; iMaxValue : Integer; pProc : TStringProcedure; pParametr : Pointer = nil): HRESULT; stdcall;
		function ConsoleUnRegCom(const pcCommandName : PAnsiChar): HRESULT; stdcall;

	end;

//Resource Manager SubSystem//

	IFile		= interface;
	ITexture	= interface;
	IMesh		= interface;
	IShader		= interface;
	IProgram	= interface;

	TFileLoadProcedure = Procedure(out rpFile : IFile; out prObj : IEngBaseObj; uiLoadFlags : Cardinal; pParametr : Pointer); stdcall;

	IResourceManager = interface(IEngineSubSystem)
	['{139505B6-5EFC-4f02-A5E8-18CD1FBD69E3}']

		function CreateTexture(out prTex : ITexture; const pubtData : PByte; uiWidth, uiHeight : Cardinal; eCreationFlags :{E_TEXTURE_CREATION_FLAGS}Integer; eLoadFlags :{E_TEXTURE_LOAD_FLAGS}Integer): HRESULT; stdcall;
		function CreateMesh(out prMesh : IMesh; const pubtData : PByte; uiDataSize, uiNumVerts, uiNumFaces : Cardinal; eCreationFlags :{E_MESH_CREATION_FLAGS}Integer; eLoadFlags :{E_MESH_LOAD_FLAGS}Integer): HRESULT; stdcall;
		function CreateShader(eShaderType :{E_SHADER_TYPE}Integer; out prShader : IShader): HRESULT; stdcall;
		function CreateProgram(out prProgram : IProgram): HRESULT; stdcall;
		
		function RegisterFileFormat(const pcExtension : PAnsiChar; eObjType :{E_ENG_OBJ_TYPE}Integer; const pcDiscription : PAnsiChar; pLoadProc : TFileLoadProcedure; pParametr : Pointer): HRESULT; stdcall;
		function UnregisterFileFormat(const pcExtension : PAnsiChar): HRESULT; stdcall;
		function GetRegisteredExtensions(pcTxt : PAnsiChar; uiCharsCount : Cardinal): HRESULT; stdcall;
		function GetExtensionDescription(const pcExtension : PAnsiChar; pcTxt : PAnsiChar; uiCharsCount : Cardinal): HRESULT; stdcall;
		function GetExtensionType(const pcExtension : PAnsiChar; eType :{E_ENG_OBJ_TYPE}Integer): HRESULT; stdcall;

		function GetDefaultResource(eObjType :{E_ENG_OBJ_TYPE}Integer; out prObj : IEngBaseObj): HRESULT; stdcall;

		function Load(const pcFileName : PAnsiChar; out prObj : IEngBaseObj; uiLoadFlags : Cardinal = RES_LOAD_DEFAULT): HRESULT; stdcall;
		function Load2(pFile : IFile; out prObj : IEngBaseObj; uiLoadFlags : Cardinal = RES_LOAD_DEFAULT): HRESULT; stdcall;

		function FreeResource(var rpOnj : IEngBaseObj): HRESULT; stdcall;
		function AddResource(pObj : IEngBaseObj): HRESULT; stdcall;
		function RemoveResource(pObj : IEngBaseObj; out bCanDelete : Boolean): HRESULT; stdcall;
		
	end;

//Render SubSystem//

	IRender2D = interface;
	IRender3D = interface;

	IRender = interface(IEngineSubSystem)
	['{EA03C661-A334-4225-B5DB-4C45452CCC41}']

		function SetClearColor(const stColor: TColor4): HRESULT; stdcall;
		function ClearDepthBuffer(): HRESULT; stdcall;
		function ShareWith(pRender : IRender): HRESULT; stdcall;
                function UseDefaultPipeline(): HRESULT; stdcall;
		function EnableScissor(const stArea : TRectf): HRESULT; stdcall;
		function DisableScissor(): HRESULT; stdcall;		
		function IsSupported(eFeature :{E_RENDER_SUPPORTED_FEATURES}Integer; out bSupported : Boolean): HRESULT; stdcall;
		function ScreenShotBMP(const pFileName : PAnsiChar): HRESULT; stdcall;

		function GetRender2D(out prRender2D : IRender2D): HRESULT; stdcall;
		function GetRender3D(out prRender3D : IRender3D): HRESULT; stdcall;

	end;

//Render2D interface//

	IRender2D = interface(IDGLE2_Base)
	['{F5F3257A-F8B8-4d91-BA67-451167A8D63F}']

		function Begin2D(): HRESULT; stdcall;
		function End2D(): HRESULT; stdcall;
		//Note: Only one pair Begin2D-End2D per frame is allowed or batching must be disabled.
		function BatchRender(eMode :{E_BATCH_MODE2D} Integer): HRESULT; stdcall;
		function SetResolutionCorrection(uiResX, uiResY : Cardinal; bConstaintProportions : Boolean = true): HRESULT; stdcall; //Set resx and resy to current screen size to turn off correction
		function SetCamera(const stCenter : TPoint2; fAngle : Single; const stScale : TPoint2): HRESULT; stdcall;

		// 2D Primitives
		function LineWidth(uiWidth : Cardinal): HRESULT; stdcall;
		function DrawPoint(const stCoords : TPoint2; const stColor : TColor4; uiSize : Cardinal = 1): HRESULT; stdcall;
		function DrawLine(const stCoords1,  stCoords2 : TPoint2; const stColor : TColor4; eFlags :{E_PRIMITIVE2D_FLAGS}Integer = PF_DEFAULT): HRESULT; stdcall;
		function DrawRect(const stRect : TRectf; const stColor : TColor4; eFlags :{E_PRIMITIVE2D_FLAGS}Integer = PF_DEFAULT): HRESULT; stdcall;
		function DrawCircle(const stCoords : TPoint2; uiRadius, uiQuality : Cardinal; const stColor : TColor4; eFlags :{E_PRIMITIVE2D_FLAGS}Integer = PF_DEFAULT): HRESULT; stdcall;
		function DrawEllipse(const stCoords,  stRadius : TPoint2; uiQuality: Cardinal; const stColor : TColor4; eFlags :{E_PRIMITIVE2D_FLAGS}Integer = PF_DEFAULT): HRESULT; stdcall;
		function DrawPolygon(pTexture : ITexture; const pstVertices : PVertex2; uiVerticesCount : Cardinal; eFlags :{E_PRIMITIVE2D_FLAGS}Integer = PF_DEFAULT): HRESULT; stdcall;

		// 2D Sprites
		function DrawSpriteS(pTexture : ITexture; const stCoords,  stDimensions :TPoint2; fAngle : Single = 0.; eFlags :{E_EFFECT2D_FLAGS}Integer = EF_DEFAULT): HRESULT; stdcall;
		function DrawSpriteA(pTexture : ITexture; const stCoords,  stDimensions :TPoint2; uiFrame : Cardinal; angle : Single = 0.; eFlags :{E_EFFECT2D_FLAGS}Integer = EF_DEFAULT): HRESULT; stdcall;
		function DrawSpriteC(pTexture : ITexture; const stCoords,  stDimensions :TPoint2; const stRect : TRectf; fAngle : Single = 0.; eFlags :{E_EFFECT2D_FLAGS}Integer = EF_DEFAULT): HRESULT; stdcall;

		// Extra
		function DrawTriangles(pTexture : ITexture; const pstVertices : PVertex2; uiVerticesCount : Cardinal;  eFlags :{PR_FLAGS}Integer = PF_DEFAULT): HRESULT; stdcall;
		function DrawMesh(pMesh : IMesh; pTexture : ITexture; const stCoords : TPoint2; const stDimensions : TPoint3; const stAxis : TPoint3; fAngle : Single; bClip : Boolean = true; fFovY : Single = 90.0; eFlags :{E_EFFECT2D_FLAGS}Integer = EF_DEFAULT): HRESULT; stdcall;

		// Effects
		function SetRotationPoint(const stCoords : TPoint2): HRESULT; stdcall; //In texture stCoords system
		function SetScale(const stScale : TPoint2): HRESULT; stdcall;
		function SetColorMix(const stColor : TColor4): HRESULT; stdcall;
		function SetBlendMode(eMode :{E_EFFECT2D_BLENDING_FLAGS}Integer = EBF_NORMAL): HRESULT; stdcall;
		function SetVerticesOffset(const stCoords1,  stCoords2,  stCoords3,  stCoords4 : TPoint2): HRESULT; stdcall;
		function SetVerticesColors(const stColor1,   stColor2,   stColor3,   stColor4  : TColor4): HRESULT; stdcall;

	end;

//Render3D interface//

	IRender3D = interface(IDGLE2_Base)
	['{5275F43A-4FF9-48b2-B88E-B2F842461AB3}']

 		function SetPerspective(fFovAngle, fZNear, fZFar : Single): HRESULT; stdcall;
		
		function SetColorStates(const stColor : TColor4; eMode :{E_EFFECT2D_BLENDING_FLAGS}Integer = EBF_NONE): HRESULT; stdcall;
		function SetOmniLight(uiLight : Integer; bEnabled : Boolean; const stPos : TPoint3; const stColor : TColor4; fAttenuation : Single): HRESULT; stdcall;
		function SetTexture(pTexture : ITexture{Could be NULL to switch texture off}; uiMTextureLayer : Cardinal = 0): HRESULT;	stdcall;
		function SetMatrix(const stMatrix : TMatrix; bMult : Boolean = true): HRESULT; stdcall;
		function GetMatrix(out stMatrix : TMatrix): HRESULT; stdcall;

		function DrawAxes(fSize : Single = 1.0; bNoDepthTest : Boolean = false): HRESULT; stdcall;

		function PushStates(eStates :{E_PUSH_STATES_FLAGS}Integer = PSF_MATRIX): HRESULT; stdcall;
		function PopStates(): HRESULT; stdcall;

		function GetPoint3(const stPointOnScreen : TPoint2; out stResultPoint : TPoint3; eFlag :{E_GET_POINT3_FLAG}Integer = GP3F_FROM_Z_BUFFER): HRESULT; stdcall;
		function GetPoint2(const stPoint : TPoint3; out stResultPointOnScreen : TPoint2): HRESULT; stdcall;
		
		function FrustumSetup(): HRESULT; stdcall;
		function CullPoint(const stCoords : TPoint3; out bCull : Boolean): HRESULT; stdcall;
		function CullSphere(const stCoords: TPoint3; fRadius : Single; out bCull : Boolean): HRESULT; stdcall;
		function CullBox(const stCenterCoords, stExtents : TPoint3; out bCull : Boolean): HRESULT; stdcall;

	end;

//Texture interface//

	ITexture = interface(IEngBaseObj)
	['{85BDDBC2-F126-4cae-946D-7D6B079E5CCE}']

		function GetDimension(out irWidth, irHeight : Cardinal): HRESULT; stdcall;
		function SetFrameSize(uiFrameWidth, uiFrameHeight : Cardinal): HRESULT; stdcall;
		function GetFrameSize(out uiFrameWidth, uiFrameHeight : Cardinal): HRESULT; stdcall;
		function GetGLTexIdent(out irIdent : Cardinal): HRESULT; stdcall;

		function Draw2D_Simple(iX, iY : Integer): HRESULT; stdcall;
		function Draw2D( iX, iY : Integer; uiWidth, uiHeight : Cardinal; fAngle : Single = 0.0; uiFrameIndex : Cardinal = 0): HRESULT; stdcall;
		function Draw3D(uiFrameIndex : Cardinal = 0): HRESULT; stdcall;

	end;

	//Shader interface//
{!!!!!Dummies To Do!!!!!}
	IUniform = interface(IDGLE2_Base)
	['{03688B6E-A231-4125-97EA-620C3B7FCEA1}']

		function SetF(): HRESULT; stdcall;
		function SetI(): HRESULT; stdcall;
		function SetM(): HRESULT; stdcall;

		function GetF(): HRESULT; stdcall;
		function GetI(): HRESULT; stdcall;

		function Validate(): HRESULT; stdcall;
		function Free(): HRESULT; stdcall;

	end;
	
	IShader = interface(IEngBaseObj)
	['{600DE9DC-7C00-4f74-82C9-653EA6C7F2B4}']

		function SetSource(): HRESULT; stdcall;
		function GetSource(): HRESULT; stdcall;
		function GetSourceLength(): HRESULT; stdcall;
		function Compile(): HRESULT; stdcall;

	end;

	IProgram = interface(IEngBaseObj)
	['{67AD00B9-E613-43d5-8F35-1606D9A90206}']

		function AttachShader(): HRESULT; stdcall;
		function DetachShader(): HRESULT; stdcall;
		function GetShader(): HRESULT; stdcall;
		function Link(): HRESULT; stdcall;
		function Validate(): HRESULT; stdcall;

		function GetUniformsCount(): HRESULT; stdcall;
		function GetUniformsMaxNameLength(): HRESULT; stdcall;
		function GetUniformInfo(): HRESULT; stdcall;
		function GetUniform(): HRESULT; stdcall;
		function GetAttribInfo(): HRESULT; stdcall;
		function GetAttribsCount(): HRESULT; stdcall;
		function GetAttribsMaxNameLength(): HRESULT; stdcall;
		function GetAttribLocation(): HRESULT; stdcall;
		function BindAttribLocation(): HRESULT; stdcall;
		function Use(): HRESULT; stdcall;

	end;

	//BitmapFont interface//

	IBitmapFont = interface(IEngBaseObj)
	['{0B03E8D7-23A3-4c79-9E82-5BC6E50E1EBA}']

		function GetTexture(out prTexture : ITexture): HRESULT; stdcall;
		function SetScale(fScale : Single): HRESULT; stdcall;
		function GetDimensions(const pcTxt : PAnsiChar; out uiWidth, uiHeight : Cardinal): HRESULT; stdcall;		
		function Draw2D(iX, iY : Integer; const pcTxt : PAnsiChar; const stColor : TColor4; iAngle : Integer = 0; bVerticesColors : Boolean = false): HRESULT; stdcall;
		function Draw3D(const pcTxt : PAnsiChar): HRESULT; stdcall;

	end;
	
// ParticleEffect interface//

	IParticleEmitter = interface(IDGLE2_Base)
	['{1556CB3D-44F9-4f3a-BF1C-D6E5709B42E7}']
	
		function SetPosition(const stPos : TPoint3): HRESULT; stdcall;
		function SetScale(fScale : Single): HRESULT; stdcall;
		function GetPosition(out stPos : TPoint3): HRESULT; stdcall;
		function GetScale(out fScale : Single): HRESULT; stdcall;
		function Reset(): HRESULT; stdcall;
	
	end;

	IParticleEffect = interface(IEngBaseObj)
	['{BA42B3E6-E79A-4b1a-B674-3E18F6DEB58D}']
	
		function CreateEmitter(out prPEmitter : IParticleEmitter; bDeleteIfInactive : Boolean = true): HRESULT; stdcall;
		function Is3D(out b3D : Boolean): HRESULT; stdcall;
		function Draw(): HRESULT; stdcall;
		function KillEmitter(pPEmitter : IParticleEmitter): HRESULT; stdcall;
		function KillAllEmitters(): HRESULT; stdcall;
	
	end;

//3D Objects interfaces//

//3DNode interface//

	I3DNode = interface(IEngBaseObj)
	['{8A75A81C-26AA-4e1c-83F8-7E69175A9513}']

	end;

//Mesh interface//

	IMesh = interface(IEngBaseObj)
	['{85E360A8-07B3-4f22-AA29-07C7FC7C6893}']

		function Draw(): HRESULT; stdcall;
		function GetCenter(out stCenter : TPoint3): HRESULT; stdcall;
		function GetExtents(out stExtents : TPoint3): HRESULT; stdcall;
		function GetTrianglesCount(out uiTriCnt : Cardinal): HRESULT; stdcall;
		function GetGeometryInfo(out uiDataSize : Cardinal; out eCreationFlags :{E_MESH_CREATION_FLAGS}Integer): HRESULT; stdcall;
		function GetGeometry(out pubtData : PByte): HRESULT; stdcall;
		function SetGeometry(const pubtData : PByte): HRESULT; stdcall;

	end;

//Model interface//

	IModel = interface(IMesh)
	['{6107C296-FC07-48d1-B6A7-F88CC2DAE897}']

		function Func1(): HRESULT; stdcall;
		function Func2(): HRESULT; stdcall;
		function Func3(): HRESULT; stdcall;

	end;

//Input Subsystem//

	IInput = interface(IEngineSubSystem)
	['{64DAAF7F-F92C-425f-8B92-3BE40D8C6666}']

		function Configure(eFlags :{E_INPUT_CONFIGURATION_FLAGS}Integer = ICF_DEFAULT): HRESULT; stdcall;

		function GetMouseStates(out stMStates : TMouseStates): HRESULT; stdcall;
		function GetKey(eKeyCode :{E_KEYBOARD_KEY_CODES}Integer; out bPressed : Boolean) : HRESULT; stdcall;
		function GetKeyName(eKeyCode :{E_KEYBOARD_KEY_CODES}Integer; cASCIICode : Char): HRESULT; stdcall;

		function BeginTextInput(out pcBuffer : PAnsiChar; uiBufferSize : Cardinal) : HRESULT; stdcall;
		function EndTextInput() : HRESULT; stdcall;

		function GetJoystickCount(out uiCount : Cardinal): HRESULT; stdcall;
		function GetJoystickStates(uiJoyId : Cardinal; out stJoyStates : TJoystickStates): HRESULT; stdcall;
		function GetJButtonPressed(uiJoyId : Cardinal; uiNumber : Cardinal; out bPressed : Boolean): HRESULT; stdcall; // 128 buttons [uint 0..127]

	end;

//Sound SubSystem interfaces//

	ISound = interface(IEngineSubSystem)
	['{054C07EE-2724-42f2-AC2B-E81FCF5B4ADA}']

		function SetMasterVolume(uiVolume : Cardinal): HRESULT; stdcall;
		function SetDopplerFactor(fFactor : Single): HRESULT; stdcall;
		function PauseAll(bPaused : Boolean): HRESULT; stdcall;
		function StopAll(): HRESULT; stdcall;
		function SetListnerPosition(const stCoords : TPoint3): HRESULT; stdcall;
		function GetListnerPosition(out stCoords : TPoint3): HRESULT; stdcall;
		function SetListnerOrientation(const stDir : TPoint3; const stUp : TPoint3): HRESULT; stdcall;
		function GetListnerOrientation(out stDir : TPoint3; out stUp : TPoint3): HRESULT; stdcall;

	end;

//Music interface//

	IMusic = interface(IEngBaseObj)
	['{81F1E67B-3FEB-4ab1-9AD2-D27C4E662164}']

		function Play(bLooped : Boolean = true): HRESULT; stdcall;
 		function Pause(bPaused : Boolean): HRESULT; stdcall;
		function Stop(): HRESULT; stdcall;
		function IsPlaying(out bIsPlaying : Boolean): HRESULT; stdcall;
		function SetVolume(uiVolume : Cardinal): HRESULT; stdcall;
		function GetVolume(out uiVolume : Cardinal): HRESULT; stdcall;
		function SetCurrentPosition(uiPos : Cardinal): HRESULT; stdcall;
		function GetCurrentPosition(out uiPos : Cardinal): HRESULT; stdcall;
		function GetLength(out uiLength : Cardinal): HRESULT; stdcall;

	end;

//SoundSample interface//

	ISoundSample = interface(IEngBaseObj)
	['{30DD8C94-D3FA-40cf-9C49-649211424919}']

		function Play(bLooped : Boolean = false): HRESULT; stdcall;
		function Stop(): HRESULT; stdcall;
		function IsPlaying(out bIsPlaying : Boolean): HRESULT; stdcall;		
		function SetVolume(uiVolume : Cardinal): HRESULT; stdcall;
		function GetVolume(out uiVolume : Cardinal): HRESULT; stdcall;
		function SetPan(iPan : Integer): HRESULT; stdcall;
		function GetPan(out iPan : Integer): HRESULT; stdcall;
		function SetFrequency(uiFreq : Cardinal): HRESULT; stdcall;
		function GetFrequency(out uiFreq : Cardinal): HRESULT; stdcall;		
		function SetPosition(const stCoords : TPoint3): HRESULT; stdcall;
		function GetPosition(out stCoords : TPoint3): HRESULT; stdcall;
		function SetEffects(eFlags :{E_SOUND_EFFECTS}Integer): HRESULT; stdcall;
	end;

//FileSystem interfaces//

	IFileSystem = interface;

	IMainFileSystem = interface(IEngineSubSystem)
	['{4850286F-4770-4bcf-A90A-33D7BE41E686}']

		function LoadFile(const pcFileName : PAnsiChar; out prFile : IFile): HRESULT; stdcall;// c:\data.zip|img.jpg
		function GetVirtualFileSystem(const pcVFSExtension : PAnsiChar{NULL to get HDD file system}; out prVFS : IFileSystem): HRESULT; stdcall;
		function RegisterVirtualFileSystem(const pcVFSExtension : PAnsiChar; const pcDiscription : PAnsiChar; pVFS : IFileSystem): HRESULT; stdcall;
		function UnregisterVirtualFileSystem(const pcVFSExtension : PAnsiChar): HRESULT; stdcall;
		function GetRegisteredVirtualFileSystems(pcTxt : PAnsiChar; uiCharsCount : Cardinal): HRESULT; stdcall;
		function GetVirtualFileSystemDescription(const pcVFSExtension : PAnsiChar; pcTxt : PAnsiChar; uiCharsCount : Cardinal): HRESULT; stdcall;

	end;

//File interface//

	IFile = interface(IDGLE2_Base)
	['{AE6E8AE7-3E5B-4bc4-A512-42E1CF1DF005}']

		function Read(pBuffer : Pointer; uiCount : Cardinal; out uiRead : Cardinal): HRESULT; stdcall;
		function Write(const pBuffer : Pointer; uiCount : Cardinal; out uiWritten : Cardinal): HRESULT; stdcall;
		function Seek(uiOffset : Cardinal; eWay :{E_FILE_SYSTEM_SEEK_FLAG}Integer; out uiPosition : Cardinal): HRESULT; stdcall;
		function GetSize(out uiSize : Cardinal): HRESULT; stdcall;
		function IsOpen(out bOpened : Boolean): HRESULT; stdcall;
		function GetName(pcName : PAnsiChar; uiCharsCount : Cardinal): HRESULT; stdcall;
		function GetPath(pcPath : PAnsiChar; uiCharsCount : Cardinal): HRESULT; stdcall;
		function Free(): HRESULT; stdcall;

	end;

//FileIterator interface//

	IFileIterator = interface(IDGLE2_Base)
	['{5D73F249-0E74-4cc5-9646-270CB1E22750}']

		function FileName(pcName : PAnsiChar; uiCharsCount : Cardinal): HRESULT; stdcall;
		function Next(): HRESULT; stdcall;
		function Free(): HRESULT; stdcall;

	end;

//FileSystem interface//

	IFileSystem = interface(IDGLE2_Base)
	['{2DAE578E-9636-4fae-BABB-7D835EEA7518}']

		function OpenFile(const pcName : PAnsiChar; eFlags :{E_FILE_SYSTEM_OPEN_FLAGS}Integer; out prFile : IFile): HRESULT; stdcall;
		function DeleteFile(const pcName : PAnsiChar): HRESULT; stdcall;
		function FileExists(const pcName : PAnsiChar; out bExists : Boolean): HRESULT; stdcall;
		function Find(const pcMask : PAnsiChar; eFlags :{E_FIND_FLAGS}Integer; out prIterator : IFileIterator): HRESULT; stdcall;
		function Free(): HRESULT; stdcall;

	end;

var
	hServer			: THandle = 0;  
	pCreateEngine	: Function(out pEngineCore : IEngineCore; eFlags :{E_GET_ENGINE_FLAGS}Integer; ubtSDKVer : byte): Boolean; stdcall;
	pFreeEngine		: Function(pEngineCore : IEngineCore): Boolean; stdcall;

const
  //E_GET_ENGINE_FLAGS
	GEF_DEFAULT				      	= $00000000;
	GEF_FORCE_SINGLE_THREAD 		= $00000001;
	GEF_FORCE_NO_LOG_FILE	  		= $00000002;
	GEF_FORCE_QUIT					= $00000004;

function CreateEngine(out pEngineCore : IEngineCore; eFlags :{E_GET_ENGINE_FLAGS}Integer = GEF_DEFAULT): Boolean;
function GetEngine(pcDllFileName : AnsiString; out pEngineCore :IEngineCore; eFlags :{E_GET_ENGINE_FLAGS}Integer = GEF_DEFAULT) : Boolean;
function FreeEngine(pEngineCore : IEngineCore = nil; bFreeDLL : Boolean = true): Boolean;

implementation

function  CreateEngine(out pEngineCore : IEngineCore; eFlags :{E_GET_ENGINE_FLAGS}Integer = GEF_DEFAULT): Boolean;
begin
	Result := false;
	if @pCreateEngine = nil then Exit;
	Result := pCreateEngine(pEngineCore, eFlags, _DGLE2_SDK_VER_);
end;

function FreeEngine(pEngineCore : IEngineCore = nil; bFreeDLL : Boolean = true): Boolean;
begin
	if pEngineCore <> nil then pFreeEngine(pEngineCore);
	if bFreeDLL and(hServer <> 0) then
	begin
		FreeLibrary(hServer);
		hServer := 0;
	end;
	Result := true;	
end;

function GetEngine(pcDllFileName : AnsiString; out pEngineCore : IEngineCore; eFlags :{E_GET_ENGINE_FLAGS}Integer = GEF_DEFAULT) : Boolean;
begin
	Result := false;
	if hServer = 0 then
	begin
		pEngineCore	:= nil;
		
		if hServer = 0 then
		begin
			hServer := LoadLibraryA(PAnsiChar(pcDllFileName));
			if hServer = 0 then Exit;			
		end;
		
		if (@pCreateEngine = nil)and(@pFreeEngine = nil) then
		begin
			pCreateEngine := GetProcAddress(hServer,'CreateEngine');
			pFreeEngine   := GetProcAddress(hServer,'FreeEngine');
			if (@pCreateEngine = nil)or(@pFreeEngine = nil) then
			begin
				FreeLibrary(hServer);
				hServer := 0;
			end;
		end;
	end;
	if hServer <> 0 then Result := CreateEngine(pEngineCore, eFlags);	
end;

begin
  IsMultiThread := True;
end.
