unit Levels;

interface

type
TLevel = array [0..129] of Integer;

{
-1 - 
0 -                   16 -         \
1 -                   17 -          \
2 -                 18 -         \
3 -                19 -         \
4 -                   20 -             \
5 -                 21 -             
6 -                22 -          /
7 -                23 -         /
8 -               24 -       /
9, 10 -     25,26 -   /
11, 12, 13 - 
14 - 
-2 - 
-3 -  
-4 - 
-5 - 
-6 - 
}

const
 LevelData : array[0..18] of TLevel = (
 (//1
 -1, -1, -1, -1, -1, -1, -1, -1, -1,  1, -1, -1, -1,
 -1,  0, -1, -1, -1, -1, -1, -1, -1, -1, -1,  0, -1,
 -1, -1, -1, -4,  6,  6,  6,  6,  3, -1, -1, -1, -1,
  1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
 -1, -1, -1, -3, -1, -2,  7, -4, -1, -1, -1,  0, -1,
 -1, -1,  0, -1, -1,  4,  5, -1,  1, -1, -4, -1, -1,
 -1, -1, -1, -2, -2, -1, -1, -1, -1, -1, -1, -1, -1,
  0, -1, -1, -1, -1, -1, -1, -4, -1,  0, -1, -1, -1,
 -1, -1, -1, -1,  0, -1, -1, -1, -1, -1, -1,  0, -1,
 -1, -1,  1, -1, -1, -1,  1, -1, -1, -1, -1, -1, -1
 ),
 (//2
 -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
 -1,  3,  3,  3,  3, -1, -1,  1,  0, -1, -1,  2, -1,
 -1, -1, -1, -1, -1, -1, -2, -1, -1, -1, -1, -1,  1,
 -1, -1, -1, -1, -1, -3, -4, -1, -2,  6,  6,  6, -1,
  1, -1, -2, -3, -1, -1, -1, -1, -1,  6,  6,  6, -1,
 -1, -2, -1, -1, -2, -2, -1, -2, -1,  6,  6,  6, -1,
 -1,  2, -4, -1, -1, -1, -4, -1, -1,  6,  6,  6, -1,
  0, -1, -1, -1, -4, -1, -2, -1,  1, -1, -1, -1, -1,
 -1, -1, -1, -1, -1, -1,  2, -1, -1, -1, -1, -1, -1,
 -1, -1, -1,  0, -1, -1, -1, -1, -1, -1, -1,  2, -1
 ),
 (//3
  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
  0,  0, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
  0,  0, -1,  2, -1, -2,  2, -2,  1, -1,  1, -1, -1,
  0,  0, -1, -1, -1, -2, -1, -2,  2, -2, -2,  1, -1,
  0,  0, -1, -2, -2,  2, -1, -1, -1,  2, -1,  2, -1,
  0,  0, -2,  2, -1, -1,  2,  2, -2, -1, -2, -1, -1,
  0,  0, -1, -1, -2, -1,  1, -1, -2, -1,  2, -2, -1,
  0,  0, -1, -2, -2, -2, -2, -2, -1, -2, -1, -1, -1,
  0,  0, -1, -1,  1, -1, -1, -1, -1, -1,  2, -1, -1
 ),
 (//4
  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
  -1, -1,  4,  4,  4,  4,  4, -1, -4, -1, -1, -1, -1,
   3, -1,  7,  7,  7,  7,  7, -1, -1,  3, -1, -2, -1,
  -1, -1,  4,  4,  4,  4,  4, -1, -1, -1,  2, -1, -1,
  -1, -1,  7,  7,  7,  7,  7, -4,  0, -1, -1, -1, -1,
   2, -4, -1, -1, -1, -1, -1, -1, -1, -2, -4, -1, -1,
  -1, -1, -1, -1, -4, -1, -1, -2, -1, -1, -1, -1, -1,
  -4, -1, -4, -1, -1, -4, -1,  5, -1,  1, -1, -4, -1,
  -1, -1, -1, -1, -4, -1,  3, -1,  2, -1, -1, -1, -1,
  -1, -1, -2, -1, -1, -2, -1, -1, -1, -1, -1, -1, -1
 ),
 (//5
 -1, -1, -1, -1, -1, -1, -1,  1, -1, -1, -1, -1, -1,
 -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,  3,
 -1,  6,  6,  6,  6,  6, -1, -1, -1,  1, -1, -1, -1,
 -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
 -1, -1, -1, -4, -1, -5,  2, -4, -1,  1, -1, -1, -1,
 -2, -1,  5, -1, -1,  5, -1, -1, -1, -1,  2, -1, -1,
 -1, -2, -1, -1, -2, -1, -4, -3, -1, -1, -1,  0, -1,
  1, -1, -3, -1, -1,  3, -1, -1, -1, -5,  8, -1, -1,
 -1,  0, -1,  2, -4, -1, -1, -4, -1,  0,  8, -1, -1,
 -1, -1, -1, -1, -4, -1, -1, -1,  2, -1, -1, -1, -1
 ),
 (//6
  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
  -1,  3, -5, -1, -1, -5,  3, -1, -1, -2, -1, 1, -1,
  -1, -1, -1, -1, -1, -1, -1, -5, -1, -1, -1, -1, -1,
  8, -5,  0, -5, -1, -1, -1, -1, -1,  6,  2, -1, -1,
  8, 9, 10, -1, -3, -1, -5, -1,  3,  6, -1, -1, 1,
  -1, 8,  4, -1, -1, -1, -1, -1, -1,  22, -1, -1, -1,
  8, 8, -1, -3, -5,  0, -1,  1, -1,  6, -1, -1, -1,
  8, -1, -5, -1, -1, -1, -1, -5, -1,  6, -1, -1, -1,
  -1, -1,  1, -1, -5, -1, -1, -1,  2, -1, -1,  0, -1,
  8, -1, -1,  2, -1, -1, -1, -5, -1, -1, -1, -1, -1
 ),
 (//7
  3,  1,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,
  3, -2, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,  3,
  3,  3,  3,  3, -1,  3,  3,  3,  3,  3,  3, -1,  3,
  3,  3, -1,  3, -1,  3, -1, -1, -1, -1,  3, -2,  3,
  3,  3, -2,  3, -1, -1, -1,  3,  3, -2, -1, -1,  3,
  3,  3, -1,  3, -1,  3, -1,  3, -1,  3,  3, -1,  3,
  3,  3, -1,  3, -2,  3, -1, -1, -2, -1, -1, -1,  3,
  3, -1, -1,  3, -1,  3,  3,  3,  3,  3,  3, -1,  3,
  3, -2, -1, -1, -1, -1, -1, -1, -1, -1, -1, -2,  3,
  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3
 ),
 (//8
 -1, -1, -1, -1, -1, -1, -1, -1,  2, -1, -1, -1, -1,
 -1, -1,  1, -1, -1, -1, -2, -1, -1, -2, -1, -1, -1,
 -1, -3, -1, -5, -1, -1, -1, -3, -1, -1, -1, -1, -1,
 -1, -1, -1, -1, -2, -1, -1, -1, -1, -5,  0, -1, -1,
 -1, -4, -1,  1, -1, -1, -2, -1, 20, -1, -1, -1, -1,
 -1, 24, -1, -5, -1, -4, -1,  2, 21, 22, -1, 17, -1,
 -1,  2, -1, -1, -1,  1, -5, -1, -1, -1, -5, -1, -1,
 -1, -1, -1,  9, 10, -1, -1, -4, -3, -1, -1, -1, -1,
 -1, -1, -3,  1, -1,  9, 10, -1, -1,  8, -4, -1, -1,
 -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1
 ),
 (//9
 -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
 -1,  0, -1, -1, -4, -1, -1, -1,  3,  3, -1,  0, -1,
 -1, -1, -1, -5, -1, -5, -5, -1, -1, -1, 17, -1, -1,
 -1,  1, -3, -4, -5,  4, -5, -1, -6, -1,  2, -1, -1,
 -1, -1, -5, -1, 17,  5, -1, -1, -1, -1, -1, -1, -1,
 -1,  8,  8, -1, -1, -1, -1, -5,  6, 22,  6,  6, -1,
 -1,  9, 10,  2, -4, -1, -5, -1, -1, -1, -1, -1, -1,
 -1, 25, 26, -1, -5, -3, -1, -4,  7,  7,  7,  7, -1,
 -1, -1, -1, -2, -5, -1, -1, -5, -1,  0, -1, -1, -1,
 -1, -1,  1,  1, -1, -1,  2, -1, -1, -1, -1, -1, -1
 ),
 (//10
 25, 26,  3,  3, 19,  3,  3,  9, 10, 17,  3,  3,  3,
  3, -1, -1, -1, -1, -1, -1, -1, -1, -2, -1, -1,  3,
  3, -3,  6,  6,  6,  6,  6,  6,  4, -1,  5, -1,  3,
 19, -1,  0, -1,  3, -1, -1, -1,  3, -1,  7, -1,  3,
  3, -1,  3, -1,  3, -1,  3, -5,  3, -1,  8, -1, 19,
 16, -1, -1, -2, -1, -1, -1, 25, 26, -1,  3, -5,  3,
 19, -1,  3, -1,  3,  3, -3, -1, -1, -1, 19, -1, 18,
  3, -1,  3, -1, -1, 21,  3,  3,  3, -1,  3, -1, 19,
  3, -4,  3, -2, -1, -1, -1, -1, -1, -4, -1, -1,  3,
 19,  3,  3, 19,  3,  3, 19,  3,  3, 19,  3,  3,  3
 ),
 (//11
 -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
 -1, -1, -1, -1, -1, 17, -1, 20, -1, -1, -1, -1, -1,
 -1, 22, -5, -1, -6, -6, -1,  7,  0, -1, -1, 17, -1,
 -1, -1, -1, -1, 18, -5, -2, -1, -1, -1, -1, -1, -1,
 -1, 17, -3, -1, 17, -6, -6, -1, -1, -1,  6, -1, -1,
 -1, -1, -1, -1, -5, -4, -6, -6, -1, -1, -1, -1, -1,
  9, 10, -1, -5, -1, -5, 21, 17, 16, -5, -1, -1, -1,
  9, 10, -1,  4, -1, -1, -1, -1, -1, -1, -6, -1, -1,
 25, 26,  0, 23, -1,  6, -1, -5, -1, -1,  5, -1, -1,
 -1, -1, 17, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1
 ),
 (//12
 -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
 -1, -1, -1, -1, -1, -1, -1, -1,  6, 22,  6,  6, -1,
  8, -1, -1,  8, -1, -6, -6, -1,  4,  4,  4, 20, -1,
 -1, -1, -1, -1, -6, -1, -5, -1, 23,  7, 21,  7, -1,
  8, -1, -1, -4, -6, -2, -1, -6, -1, -1,  8, -1, -1,
 -1, -1, -6, -1, -5, -1, -1, -6, -1, -1, -1, -1, -1,
 -1, -5, -5, -4, -3, -1, -6, -1, -1, 25, 26, -1, -1,
 -1, -1, -1, -6, -3, -1, -2, -5, -1, -1, -1, -1, -1,
 -1, -1,  8, -1, -1, -1, -1, -1, -1, 24, -1, -1, -1,
 -1, -1, -1, -1,  9, 10, -1, -1, -1, -1, -1, -1, -1
 ),
 (//13
  3,  1,  3,  1, 19,  3,  1,  3,  3,  1,  3,  1,  3,
  3, -2, -1, -2, -1, -1, -2, -1, -1, -2, -1, -2,  3,
 19, -1,  3, -1,  3,  3, -1,  3,  3, -1,  3, -1, 19,
  3, -2, -1, -2, -1, -1, -2, -1, -1, -2, -1, -2,  3,
  3, -5,  3, -1,  9, 10, -1, 25, 26, -1,  3, -1,  3,
  3, -1,  3, -1,  3, 19, -5,  4, 22, -1,  3, -1, 16,
  3, -2, -1, -2, -1, -1, -2, -1, -1, -2, -1, -2,  3,
  0, -1,  3, -1,  3,  3, -1,  5,  5, -1,  3, -1,  3,
  3, -2, -1, -2, -1, -1, -2, -1, -1, -2, -1, -2,  3,
  3,  3,  3, 19,  3,  3,  3,  3, 19,  3,  3, 19,  3
 ),
 (//14
 -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
 -1,  3,  3, 19,  3, -1, -1,  1,  0, -1, -1,  2, -1,
 -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,  1,
 -1, -1, -5, -5, -5, -1, -1, -1, -1,  6,  6,  6, -1,
  1, -5, -5, -5, -5, -5, -1, -1, -1,  6, 22,  6, -1,
 -1, -6, -5, -6, -6, -5, -1, -1, -1,  6,  6, 22, -1,
 -1,  2, -1, -6, -5, -5, -1, -1, -1, 22,  6,  6, -1,
 16, -1, -5, -5, -6, -1, -1, -1,  1, -1,  8, -1, -1,
 -1, -1, -1, -1, -1, -1, 18, -1, 25, 26, 24, -1, -1,
 -1, -1, -1,  0, -1, -1, -1, -1, -1, -1, -1,  2, -1
 ),
 (//15
 -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
 -1, 16, 16, -1, -1, 19, 19, -1, -1, 25, 26, -1, -1,
 -1, -1, -1, -6, -6, -1, -1, -1, -1, -1, 17, -1, -1,
 -1, -1, 25, 26, -1, -6, -1, -5, -6, -1, -1, -5, -1,
 -1, -6, -1, -1, -1, -1, -1, -1, -1, 24, -1, -1, -1,
 -1, -1, -6, -5, 17, -6, 21, -1, -6, -1, -1, -1, -1,
 -1, -1, -1, -1, -1, -6, -1, -1, 17, -1, -1, -1, -1,
 -1, 25, 26, -1, -1, -1, -1, -6, -1, 20, 20, 20, -1,
 -1, -1, -1, 17, -1, 16, -1, -1, -1, 23, 23, 23, -1,
 -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1
 ),
(//16
 22, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 25, 26,
 22, -3, -1, -1, -1, -1, -1, -1, -1, -6, -6, 25, 26,
 22, -1, -2, -2, -1, 18, -6, -1, 17, -6, -6, 25, 26,
 22, -1, -2, -1, -1, -1, -1, 16, -1, -1, -1, 25, 26,
 22, -4, -1, -1, -1, 17, -1, -1, -6, -6, -6, 25, 26,
 22, -1, -3, 18, -1, -1, -1, -1, -6, -6, -1, 25, 26,
 22, -2, -1, -1, -1, -1, 21, -1, -6, -6, -6, 25, 26,
 22, -1, -2, -1, -1, -1, -1, -6, -1, -6, -1, 25, 26,
 22, -4, -1, 17, -1, -1, -1, -1, 17, -1, -6, 25, 26,
 22, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 25, 26
 ),
 (//17
 -1, -1, -1, -1, -1, -1, -1, 17, -1, -1, -1, -1, -1,
 -1, 24, -1, -1, 2, -6, -1, -1, -1, -1, 20, -1, -1,
 -1, -1, 11, 11, 11, 11, 11, 11, 11, 11, 11, -1, -1,
 21, -1, 12, 17, -1, -1, 17, -1, -1, -1, 13, -1, -1,
 -1, -1, 12, -2, -4, -2, -4, -2, -3, -4, 13, -1, 16,
 -6, -1, 12, -2, -3, -4, -2, -4, -4, -2, 13, -1, -1,
 -1, -1, 12, -2, -2, -2, -2, -4, -2, -4, 13, -6, -1,
 -1, 14, 12, -2, -4, -3, -3, -2, -4, 18, 13, -1, -1,
 -1, -1, 11, 11, 11, 11, 11, 11, 11, 11, 11, 16, -1,
 -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1
 ),
(//18
 -1, -1, 25, 26, -1, -1, -1, -1, -1, 17, -1, -1, -1,
 -1, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, -1,
 -1, 12, 24, -1, -1, -1, -1, -1, -1, 17, -1, 13, -1,
 -1, 12, -1, -6, -6, -6, -6, -6, -6, -6, -6, 13, -1,
 25, 26, -6, -6, -6, -6, -6, -6, -6, -6, -6, 13,  9,
 -1, 12, -6, -6, -6, -6, -6, -6, -6, -6, -6, 13, -1,
 -1, 12, -6, -6, -6, -6, -6, -6, -6, -6, -6, 13, -1,
 -1, 12, -6, -6, -6, -6, -6, -6, -6, -6, -6, 13, -1,
 14, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, -1,
 -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1
 ),
 (//19
 -1, -1, -1, -1, -1, -1, 19, -1, -1, -1, -1, -1, -1,
 -1, 17, 11, 11, 11, 11, 11, 11, 11, 11, 11, 14, -1,
 24, -1, 12, 17, -1, -1, 17, -1, -1, -1, 13, 11, 12,
 -1, -1, 12, -1, -2, -3, -4, -2, -3, -3, -1, -6, 12,
 -1, -1, 12, -2, -6, -5, -4, -2, -5, -1, -1, 11, 12,
 25, 26, 12, -2, -3, -4, -2, -4, -4, 18, -1, -6, 12,
 -1, -1, 12, -2, -5, -2, -2, -4, -2, -1, -1, 11, 12,
 -1, -1, 12, -2, -4, -3, -3, -2, -4, -1, -1, -6, 12,
 -1, 16, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 12,
 -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1
 )
 );

implementation

end.
