unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, PowerD3D, AGFUnit, e_ParticleEngine, jpeg, dl_text, minifmod;

type
  TForm1 = class(TForm)
    Timer1: TTimer;
    procedure FormCreate(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure PaintBox1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    { Private declarations }
  public
    PG : TPowerGraph;
    PE : TParticleEngine;
    PGF : TDLFont;
    tex_BG : TAGFImage;
    tex_Ball : TAGFImage;
    tex_Particles : TAGFImage;
  end;

  TBall = record
    xpos, ypos : single;
    XVel, YVel : Single;
    color : Cardinal;
    Size : Single;
    Star : Boolean;
    Particle : Integer;
    Dead : Boolean;
  end;

var
  Form1: TForm1;
  bmp : TBitmap;

  Balls : array of TBall;

  count : integer = 64;

  Xgravity, YGravity : Single;

  eXpandable : Integer;
  Hole : Integer;

  Score : Integer = 0;

  Counter : Integer = 3000;


implementation

{$R *.dfm}

{$R r.res}

procedure TForm1.FormCreate(Sender: TObject);
var
  i, j : Integer;
  c : integer;
  jpg : TJPEGImage;
begin
  PG := TPowerGraph.Create(Self);
  pg.Width := 1024;
  PG.Height := 768;
  PG.Initialize(Handle);

  tex_BG := TAGFImage.Create;
  tex_BG.LoadFromFileAuto(PG.D3DDevice8, 'test.jpg', FMT_X8R8G8B8);

  tex_Ball := TAGFImage.Create;
  tex_Ball.LoadFromFileAuto(PG.D3DDevice8, 'ball.tga', FMT_A8R8G8B8);

  tex_Particles := TAGFImage.Create;
  tex_Particles.LoadFromFile(PG.D3DDevice8, 'Particles.jpg', 32, 32, 128, 32, FMT_R5G6B5);

  PE := TParticleEngine.Create(PG, tex_Particles);
  eXpandable := PE.LoadFromFile('eXpendable.pee');
  Hole := PE.LoadFromFile('Hole.pee');


  bmp := TBitmap.Create;
  jpg := TJPEGImage.Create;
  jpg.LoadFromFile('test_Normal.jpg');
  bmp.Assign(jpg);

  PGF := TDLFont.Create(PG);
  PGF.LoadShifts('font\font.rls');
  PGF.LoadImageFromFile('font\font.bmp');  

  Randomize;

  SetLength(Balls, count);
  for i := 0 to count - 1 do
  begin
    Balls[i].xpos := 0;
    Balls[i].Ypos := 0;

    Balls[i].XVel := 0;
    Balls[i].YVel := 0;

    Balls[i].size := 4 + random(10);
    Balls[i].Star := false;
    if Random(50) = 25 then
    Balls[i].Star := True;

    Balls[i].Dead := False;

    Balls[i].Particle := -1;

    if Random(30) = 25 then
    Balls[i].Particle := PE.PlayEmitter(eXpandable, Balls[i].xpos, Balls[i].ypos, true);

    Balls[i].color := Random($FFFFFF) or $FF000000;
  end;

  Xgravity := bmp.Width div 2;
  Ygravity := bmp.Height div 2;

  DoubleBuffered := True;

  XMLoadFromRes(PChar('TITLE'),PChar('MUSIC'));
  XMPlay;
end;

procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
  i : Integer;
  temp1, temp2, temp3 : Single;
begin
  for i := 0 to count - 1 do
  with balls[i] do
  case Key of
    VK_DOWN : YVel := YVel + 1.0 * balls[i].Size / 32;
    VK_UP : YVel := YVel - 1.0 * balls[i].Size / 32;

    VK_LEFT : XVel := XVel - 1.0 * balls[i].Size / 32;
    VK_RIGHT : XVel := XVel + 1.0 * balls[i].Size / 32;

{    VK_SPACE : begin
                 temp1 := bmp.Width div 2 - xpos;
                 temp2 := bmp.Height div 2 - ypos;
                 temp3 := sqrt(temp1*temp1 + temp2*temp2);
                 temp1 := temp1 / temp3;
                 temp2 := temp2 / temp3;

                 XVel := XVel - temp1 * 16;
                 YVel := YVel - temp2 * 16;
               end;}
  end;
end;

procedure TForm1.FormMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  i : Integer;
  temp1, temp2, temp3 : Single;
begin
  for i := 0 to count - 1 do
  with balls[i] do
  begin
    temp1 := X - xpos;
    temp2 := Y - ypos;
    temp3 := sqrt(temp1*temp1 + temp2*temp2);

    temp1 := temp1 / temp3;
    temp2 := temp2 / temp3;

//    temp3 := temp3 / random(10);

    XVel := XVel - temp1 * 1000 / temp3;
    YVel := YVel - temp2 * 1000 / temp3;
  end;
end;

procedure TForm1.PaintBox1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  Xgravity := X;
  Ygravity := Y;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
var
  r, g, b, i, j : Integer;
  dist : Single;
  temp1, temp2, temp3 : Single;
  temp : Cardinal;
begin
  for I := 0 to count - 1 do
  with Balls[i] do
  begin
    if Dead then
    Continue;

    r := (GetRValue(bmp.Canvas.Pixels[trunc(Balls[i].xpos), trunc(Balls[i].ypos)]) - 127);
    g := (GetGValue(bmp.Canvas.Pixels[trunc(Balls[i].xpos), trunc(Balls[i].ypos)]) - 127);
    b := (GetBValue(bmp.Canvas.Pixels[trunc(Balls[i].xpos), trunc(Balls[i].ypos)]));

    if (xpos < 130) and (ypos > 666) then
    begin
      inc(Score);
      Dead := true;
      if Particle >= 0 then
      begin
        PE.KillEmitter(Particle);
        inc(Score, 3);
      end;
      PE.PlayEmitter(Hole, xpos, ypos, false);
    end;


    if b < 10 then
    begin
      Dead := true;
      if Particle >= 0 then
      PE.KillEmitter(Particle);
      PE.PlayEmitter(Hole, xpos, ypos, false);
    end;
    
//    Scale := 1.5 - b/256;

    XVel := XVel - r / 256;
    YVel := YVel - g / 256;

//    back.Canvas.MoveTo(Trunc(xpos), trunc(Ypos));
//    back.Canvas.Pen.Color:= color;
//    back.Canvas.Pen.Width:= Trunc(size);

    xpos := xpos + XVel {+ (Xgravity - xpos)/dist};
    ypos := Ypos + YVel {+ (Ygravity - Ypos)/dist};

//    back.Canvas.LineTo(Trunc(xpos), trunc(Ypos));

    for j := 0 to count - 1 do
    if i <> j then
    begin
      if Balls[j].Dead then
      Continue;

      dist := sqrt(sqr(xpos - balls[j].xpos) + sqr(ypos - balls[j].ypos));
      if dist <= (size + balls[j].Size) then
      begin
        temp1 := balls[j].XVel;
        temp2 := balls[j].YVel;

        // swap vel with bounce
        balls[j].XVel := XVel * (Size / (size + balls[j].Size))*2;
        balls[j].YVel := YVel * (Size / (size + balls[j].Size))*2;

        XVel:= temp1 * (balls[j].Size / (size + balls[j].Size))*2;
        YVel:= temp2 * (balls[j].Size / (size + balls[j].Size))*2;


        //    

        temp1 := balls[j].xpos - xpos;
        temp2 := balls[j].ypos - ypos;
        temp3 := sqrt(temp1*temp1 + temp2*temp2);
        temp1 := temp1 / temp3;
        temp2 := temp2 / temp3;

        xpos := xpos - temp1 * (size + balls[j].Size - dist)/2;
        Ypos := Ypos - temp2 * (size + balls[j].Size - dist)/2;

        balls[j].xpos := balls[j].xpos + temp1 * (size + balls[j].Size - dist)/2;
        balls[j].Ypos := balls[j].Ypos + temp2 * (size + balls[j].Size - dist)/2;
      end;
    end;

//    dist := sqrt(sqr(xpos - Xgravity) + sqr(ypos - Ygravity));

    XVel := XVel * 0.95;
    YVel := YVel * 0.95;

    if (xpos <= 0) then
    begin
      XVel := -XVel;
      xpos := 0;
    end;

    if (xpos >= bmp.Width) then
    begin
      XVel := -XVel;
      xpos := bmp.Width;
    end;

    if (ypos <= 0) then
    begin
      yVel := -yVel;
      ypos := 0;
    end;

    if (ypos >= bmp.Height) then
    begin
      yVel := -yVel;
      ypos := bmp.Height;
    end;

    PE.MoveEmitter(Particle, xpos, ypos);
  end;


  PG.BeginScene;
  PG.RenderEffect(tex_BG, 0 ,0, 0, effectNone);

  PE.Process(3/100);
  PE.Render;

  for i := 0 to count - 1 do
  with balls[i] do
  begin
    if Dead then
    Continue;

    PG.RotateEffect(tex_Ball, xpos, ypos, 64, (256*Size*2)/64, 0, effectSrcAlpha);
  end;

  if Counter > 0 then
  begin
    Dec(Counter, 4);

    temp := (Counter div 12) shl 24;

    PG.Rectangle(150, 280, 700, 170, temp, temp, effectSrcAlpha);

    if Counter >= 1024 then
      temp := $FFFFFFFF
    else
      temp := (Counter div 4) shl 24 + $FFFFFF;

    PGF.TextCentered('Move as many balls as you can', 512, 300, temp);
    PGF.TextCentered('to the arrows, down of the screen.', 512, 332, temp);
    PGF.TextCentered('Fireballs brings 4 points instead of 1.', 512, 364, temp);
    PGF.TextCentered('Use mouse button and arrow keys. Good luck!', 512, 392, temp);
  end;
  

  PGF.Text('Score: ' + inttostr(Score), 5, 5, $FFFFFFFF);

  PG.EndScene;
  PG.Present;

//  PaintBox1.Repaint;
end;

end.
