unit u_const;

interface

  uses IniFiles, OMEGA, PathFind;

const
  // GAME STATE
  gs_mainmenu =               0;
  gs_newgame_difficult =      1;
  gs_newgame_name =           2;
  gs_loadgame =               3;
  gs_game =                   4;
  gs_ok =                     5;
  gs_author =                 6;
  gs_records =                7;
  gs_fail =                   8;
  gs_esc =                    9;
  // GAME DIFFICULT
  gd_count =                  3;
  gd_easy =                   0;
  gd_normal =                 1;
  gd_hard =                   2;
  // OTHER
  noise_time =               20;
  noise_start =             200;
  bg_size =                  96;
  ground_size =              64;
  mapmove_speed =             4;
  connection_time =         100;
  beep_time =               100;
  forms_width =             128;
  track_time =             1024;
  qfirer_time =            1024;
  LEVELS_COUNT =              5;
  ecreation_time =          128;
  see_dist =                  6;
  firer_time =               16;
  bullet_speed =              8;
  explo_time =              128;
  // SHADOW
  ten_size =                128;
  ten_color =           $333333;
  map_coef =                  4;
  // UNITS CLASSES
  uc_count =                  7;
  uc_antenne =                0;
  uc_programmator =           1;
  uc_other =                  2;
  uc_qualificator =           3;
  uc_build =                  4;
  uc_grass =                  5;
  uc_enemy =                  6;
  os_setuptime =            128;
  // ANTENNE STATE
  as_closed =                 0;
  as_plasing =                1;
  as_opened =                 2;
  as_hiding =                 3;
    // OPTIONS
  ao_animspeed =              8;
  ao_basescount =             1;
  grass_time =              128;
  // QUALIFICATOR STATE
  qs_closed =                 0;
  qs_plasing =                1;
  qs_opened =                 2;
  qs_hiding =                 3;
    // OPTIONS
  qo_animspeed =              8;
  // ROBOT QUALIFICATIONS
  q_count =                   1;
  rs_none =                   0;
  rs_firer =                  1;
  // CURSORS STATE
  cs_none =                   0;
  cs_placebase =              1;
  // UNITS OPTIONS
  us_none =                   0;
  us_goto =                   1;
  us_build =                  2;
  us_open =                   3;
  us_qualify =                4;
  us_qualifyset =             5;

  // GAME PLAN
  gp_none =                   0;
  gp_more_units =             1;
  gp_count =                  2;
  // MESSAGES
  msg_sendtime =            64;
  msg_goto =                  1;

type
  TUnit = record
    X,Y:Single;
    toX, toY:Integer;
    Angle,TurrelAngle:Integer;
    BeepCounter:Integer;
    UnitClass:Byte;
    Speed:Single;
    Connecting:byte;
    Enabled:Boolean;
    Health:Integer;
    Detected:Boolean;
    Signal:Byte;
    Destroyed:Boolean;
    IsSendHello:Boolean;
    BildId,BuildTime:Integer;
    PTag,NextState,Piercing,State,Tag,Q,Qualification:integer;
    FireToId,QTag:Integer;
    Tag2:Word;
    Path:TPathGroup;
    PathId:integer;
    Devices:array[1..32] of integer;
    DevicesCount:Integer;
  end;
  TTrack=record
    X,Y,Angle,Time:Integer;
    E:Boolean;
  end;
  TBullet=record
    X,Y:Single;
    Angle:Integer;
    Time,KillId:Integer;
  end;
  TExplosion=record
    X,Y:integer;
    Time:Integer;
  end;
  TRadioTree=record
    Level:Integer;
    Parent:Integer;
    UnitId:Integer;
  end;
  TClassSet=record
    Shadow:Integer;
    Name:string;
    Health:integer;
    FrmH:integer;
    NeedSnd:Boolean;
    sndSelect:PSound;
  end;
  TUnitCell = record
    I:Integer;
    P:Integer;
    B:byte;
    Bt:Integer;
  end;
  TQualification = record
    N:string;
    B:Integer;
  end;
  TPoint = record
    X,Y :Integer;
  end;

var
  ao_bases:array[1..ao_basescount] of TUnitCell = (
    (I:uc_qualificator;P:1000;B:1;Bt:1024)
  );
  q_sets:array[1..q_count] of TQualification = (
    (N:'';B:2)
  );
  gd_names:array[0..gd_count-1] of string = ('','',' ');
  GamePlans:array[0..gp_count-1] of string = ('','');
  GamePlansMore:array[0..gp_count-1] of string =
   ('  .  ' +#13+
    ',  ' +#13+
    '   -'+#13+
    '.',
    '   -'+#13+
    ' . '+#13+
    '  ,'+#13+
    '   '+#13+
    ' ');
  Units:array[1..1000] of TUnit;
  RadioTree:array[1..1000] of TRadioTree;
  RadioTreeCount:Integer=0;
  Bullets:array[1..100] of TBullet;
  BulletsCount:integer=0;
  Explosions:array[1..100] of TExplosion;
  ExplosionsCount:integer=0;
  Tracks:array[1..4000] of TTrack;
  TracksCount:integer=0;
  RescuePoints,EnemyPoints:array[1..100] of TPoint;
  GrassIds:array[1..100] of Integer;
  RescuePointsCount,EnemyPointsCount,GrassIdsCount:Integer;
  LastRadioTreeCount:Integer;
  ClassSets:array[0..uc_count-1] of TClassSet = (
    (Shadow:24;Name:' ';Health:512;FrmH:160;NeedSnd:true),
    (Shadow:16;Name:'Command Center';Health:256;FrmH:256;NeedSnd:true),
    (Shadow:10;Name:'';Health:128;FrmH:118;NeedSnd:true),
    (Shadow:4;Name:' ';Health:196;FrmH:118;NeedSnd:true),
    (Shadow:0;Name:'';Health:196;FrmH:118;NeedSnd:true),
    (Shadow:0;Name:'';Health:1024;FrmH:118;NeedSnd:False),
    (Shadow:0;Name:'';Health:16;FrmH:118;NeedSnd:False)
  );
  UnitsCount:Integer=0;
  ten_x,ten_y,ten_id:integer;
  ten_dx,ten_dy,map_px,map_py:single;

type
  TLoadPlayer=record
    Name:string;
    Progress,Kills:Integer;
    Difficult:Integer;
  end;

  function IniGet(IniFile,IniSection,StringName,DefaultString: string): string;
  function IniSet(IniFile,IniSection,StringName,StringValue: string): Boolean;

implementation

  uses u_game;

  function IniGet(IniFile,IniSection,StringName,DefaultString: string): string;
  var
    TheIni: TIniFile;
  begin
    TheIni := TIniFile.Create(Home+IniFile);
    try
      Result := TheIni.ReadString(IniSection,StringName,DefaultString);
      if Result = '' then Result := DefaultString;
    finally
      TheIni.Free;
    end;
  end;

  function IniSet(IniFile,IniSection,StringName,StringValue: string): Boolean;
  var
    TheIni: TIniFile;
  begin
    TheIni := TIniFile.Create(Home+IniFile);
    try
      try
        TheIni.WriteString(IniSection,StringName,StringValue);
        Result := True;
      except
        Result := False;
      end;
    finally
      TheIni.Free;
    end;
  end;

end.
