unit u_Game;

interface
uses
  zglHeader,u_Particles;

type
  TScene = ( sGame, sMenu, sLogo, sTop );

type
  TMenuScene = ( sMain, sAbout, sOptions, sStart );

type
  TGameScene = ( sGa, sOver, sClear, sCake );
  
type
  TBlock = record
    rect: zglTRect;
    t,d,r,l: boolean;
    s: byte;
  end;

type
  TDirBlock = record
    rect: zglTRect;
    d: byte;
    c, f: boolean;
  end;

type
  TCreature = record
    r,r2: zglTRect;
    d,t,f: byte;
    s: single;
    l: boolean;
  end;

type
  TAnim = record
    x,y,a: single;
    f: byte;
  end;

var
  Field: array[0..11,0..9]of TBlock;
  DField: array[0..11,0..9]of TDirBlock;
  Creatures: array of TCreature;
  lastTimerTicks: Double;
  GameScene: TGameScene;
  animate: array of tanim;
  NCreatures, NAnim, NLevel, NowDir, GameOverT, SheepsN,
  unlockN,Credits, delay: integer;
  Particle1,Particle2: TParticleEngine;
  Music, PopSnd, ClickSnd, LevelSnd, LoseSnd: zglPSound;
  Scene: TScene;
  MenuScene: TMenuScene;
  mX, mY: Single;
  Paused, StopGame, BuyTime, BuyCol, IsSound: Boolean;
  Main_Timer, Move_Timer: zglPTimer;
  procedure Game_Process;
  procedure Game_Paint;

implementation
uses
  u_Init, u_Menu;

procedure Game_Process;
var
i, j, f, k, l: integer;
dt: Double;
begin
  case GameScene of

  sGa:
  begin

  if SheepsN = 0 then
  begin
    if Nlevel = 20 then
    begin
      GameScene := sCake;
      if IsSound then Snd_Play(LevelSnd,false);
      particle1.MoveEmitter(0,-300,-300);
      particle2.MoveEmitter(0,-300,-300);
    end else
    begin
      GameScene := sClear;
      if IsSound then Snd_Play(LevelSnd,false);
      particle1.MoveEmitter(0,-300,-300);
      particle2.MoveEmitter(0,-300,-300);
    end;
  end;

  dt := timer_GetTicks - lastTimerTicks;
  lastTimerTicks := timer_GetTicks;

  Particle1.Process(dt/800);
  Particle2.Process(dt/800);

  for i := 0 to NCreatures-1 do
  begin

    creatures[i].r2.x := creatures[i].r.x + 1;
    creatures[i].r2.y := creatures[i].r.y + 1;
    creatures[i].r2.w := 38;
    creatures[i].r2.h := 38;

    for j := 0 to NCreatures-1 do
    begin
      if i <> j then
      begin
        if  zglheader.col2d_Rect(creatures[i].r2,creatures[j].r2) then
        begin
          if (creatures[i].t = 1) and (creatures[j].t = 2) and creatures[i].l and creatures[j].l then
          begin
            creatures[i].l := false;
            NAnim := NAnim + 1;
            setlength(animate,nanim);
            animate[nanim-1].x := creatures[i].r.x;
            animate[nanim-1].y := creatures[i].r.y;
            animate[nanim-1].f := creatures[i].f;
            animate[nanim-1].a := 255;
            Particle1.PlayEmitter(0,creatures[i].r.x+8,creatures[i].r.y+8,False);
            GameScene := sOver;
            if IsSound then Snd_Play(LoseSnd,false);
            GameOverT := 2;
            particle1.MoveEmitter(0,-300,-300);
            particle2.MoveEmitter(0,-300,-300);
          end;
          if (creatures[i].t = 2) and (creatures[j].t = 1) and creatures[j].l and creatures[i].l then
          begin
            creatures[j].l := false;
            NAnim := NAnim + 1;
            setlength(animate,nanim);
            animate[nanim-1].x := creatures[j].r.x;
            animate[nanim-1].y := creatures[j].r.y;
            animate[nanim-1].f := creatures[j].f;
            animate[nanim-1].a := 255;
            Particle1.PlayEmitter(0,creatures[j].r.x+8,creatures[j].r.y+8,False);
            GameScene := sOver;
            if IsSound then Snd_Play(LoseSnd,false);
            GameOverT := 2;
            particle1.MoveEmitter(0,-300,-300);
            particle2.MoveEmitter(0,-300,-300);
          end;
        end;
      end;
    end;

    if not StopGame then
    begin

    if creatures[i].l then
    begin

    if creatures[i].t = 1 then creatures[i].f := creatures[i].d;
    if creatures[i].t = 2 then creatures[i].f := creatures[i].d + 4;

    for k := 0 to 11 do
    for l := 0 to 9 do
    begin
      if (dfield[k,l].d = 1) and field[k,l].t
      or (dfield[k,l].d = 2) and field[k,l].d
      or (dfield[k,l].d = 3) and field[k,l].l
      or (dfield[k,l].d = 4) and field[k,l].r
      then dfield[k,l].f := true else dfield[k,l].f := false;


      if (creatures[i].r.x = field[k,l].rect.x) and (creatures[i].r.y = field[k,l].rect.y) then
      begin
        if field[k,l].s = 9 then
        begin
          creatures[i].l := false;
          NAnim := NAnim + 1;
          setlength(animate,nanim);
          animate[nanim-1].x := creatures[i].r.x;
          animate[nanim-1].y := creatures[i].r.y;
          animate[nanim-1].f := creatures[i].f;
          animate[nanim-1].a := 255;
          case creatures[i].t of
            1:Particle1.PlayEmitter(0,creatures[i].r.x+8,creatures[i].r.y+8,False);
            2:Particle2.PlayEmitter(0,creatures[i].r.x+8,creatures[i].r.y+8,False);
          end;
          if IsSound then Snd_Play( PopSnd, False );
          if creatures[i].t = 1 then
          begin
            GameScene := sOver;
            if IsSound then Snd_Play(LoseSnd,false);
            GameOverT := 1;
            particle1.MoveEmitter(0,-300,-300);
            particle2.MoveEmitter(0,-300,-300);
          end;
        end;
        if (field[k,l].s = 10) and (creatures[i].t = 1) then
        begin
          if IsSound then Snd_Play( PopSnd, False );
          creatures[i].l := false;
          NAnim := NAnim + 1;
          setlength(animate,nanim);
          animate[nanim-1].x := creatures[i].r.x;
          animate[nanim-1].y := creatures[i].r.y;
          animate[nanim-1].f := creatures[i].f;
          animate[nanim-1].a := 255;
          Particle1.PlayEmitter(0,creatures[i].r.x+8,creatures[i].r.y+8,False);
          SheepsN := SheepsN - 1;
        end;


        if (dfield[k,l].d = 0) or dfield[k,l].f then
        begin

          if creatures[i].t < 3 then
          begin
          
          if dfield[k,l].d = 1 then creatures[i].d := 2;
          if dfield[k,l].d = 2 then creatures[i].d := 1;
          if dfield[k,l].d = 3 then creatures[i].d := 4;
          if dfield[k,l].d = 4 then creatures[i].d := 3;

          end;

          if (creatures[i].d = 3) and field[k,l].r and field[k,l].d and not field[k,l].t then creatures[i].d := 2;
          if (creatures[i].d = 4) and field[k,l].l and field[k,l].t and not field[k,l].d then creatures[i].d := 1;
          if (creatures[i].d = 2) and field[k,l].r and field[k,l].t and not field[k,l].l then creatures[i].d := 4;
          if (creatures[i].d = 1) and field[k,l].l and field[k,l].d and not field[k,l].r then creatures[i].d := 3;

          if (creatures[i].d = 3) and field[k,l].r and field[k,l].t and not field[k,l].d then creatures[i].d := 1;
          if (creatures[i].d = 4) and field[k,l].l and field[k,l].d and not field[k,l].t then creatures[i].d := 2;
          if (creatures[i].d = 2) and field[k,l].l and field[k,l].t and not field[k,l].r then creatures[i].d := 3;
          if (creatures[i].d = 1) and field[k,l].r and field[k,l].d and not field[k,l].l then creatures[i].d := 4;

          if (creatures[i].d = 2) and field[k,l].t and not field[k,l].l and not field[k,l].r then creatures[i].d := 3;
          if (creatures[i].d = 1) and field[k,l].d and not field[k,l].l and not field[k,l].r then creatures[i].d := 4;
          if (creatures[i].d = 3) and field[k,l].r and not field[k,l].t and not field[k,l].d then creatures[i].d := 1;
          if (creatures[i].d = 4) and field[k,l].l and not field[k,l].t and not field[k,l].d then creatures[i].d := 2;

          if (creatures[i].d = 2) and field[k,l].l and field[k,l].r and field[k,l].t then creatures[i].d := 1;
          if (creatures[i].d = 1) and field[k,l].l and field[k,l].r and field[k,l].d then creatures[i].d := 2;
          if (creatures[i].d = 3) and field[k,l].t and field[k,l].d and field[k,l].r then creatures[i].d := 4;
          if (creatures[i].d = 4) and field[k,l].t and field[k,l].d and field[k,l].l then creatures[i].d := 3;

        end;


        if creatures[i].t < 3 then
        begin

        if (dfield[k,l].d = 1) and not field[k,l].t then creatures[i].d := 2;
        if (dfield[k,l].d = 2) and not field[k,l].d then creatures[i].d := 1;
        if (dfield[k,l].d = 3) and not field[k,l].l then creatures[i].d := 4;
        if (dfield[k,l].d = 4) and not field[k,l].r then creatures[i].d := 3;

        end;

      end;
    end;

    case creatures[i].d of
      1:creatures[i].r.y := creatures[i].r.y + 1;
      2:creatures[i].r.y := creatures[i].r.y - 1;
      3:creatures[i].r.x := creatures[i].r.x + 1;
      4:creatures[i].r.x := creatures[i].r.x - 1;
    end;

    end;
    end;
  end;


  for i := 0 to NAnim - 1 do
  begin
    if animate[i].a > 0 then
    begin
      animate[i].a := animate[i].a - 17;
    end;
  end;

  if not BuyTime then
  begin
    Button_Process(@Brun);
    Button_Process(@Bqu);
  end;
  for i := 0 to 3 do SButton_Process(@MoveButtons[i]);

  if mouse_Click(m_bleft)then
  begin
    for i := 0 to 3 do
    begin
      if StopGame then
      begin
        if MoveButtons[i].F = 2 then
        begin
          if IsSound then Snd_Play( ClickSnd, False );
          BuyTime := true;
          NowDir := u_strtoint(MoveButtons[i].T);
        end;
      end;
    end;
  end;

  if mouse_Up(m_bleft)then
  begin
    if not BuyCol then
    begin
      BuyTime := false;
    end;
    if BRun.F = 2 then
    begin
      if IsSound then Snd_Play( ClickSnd, False );
      if BRun.T = 'stop' then
      begin
        StopGame := true;
        calculate;
        BRun.T := 'run';
        exit;
      end;
      if BRun.T = 'run' then
      begin
        StopGame := false;
        BRun.T := 'stop';
      end;
    end;
    if Bqu.F = 2 then
    begin
      if IsSound then Snd_Play( ClickSnd, False );
      Scene := sMenu;
      MenuScene := sMain;
    end;
  end;


  if not BuyTime and StopGame then
  begin
    for i := 0 to 11 do
    for j := 0 to 9 do
    begin
      if zglheader.col2d_PointInRect(mx,my,dfield[i,j].rect) then
      begin
        if zglheader.mouse_Click(m_bright) then
        begin
          if dfield[i,j].d > 0 then
          begin
            if Credits = 0 then Credits := Credits + 1;
            Credits := Credits + 1;
          end;
          dfield[i,j].d := 0;
        end;
      end;
    end;
  end;

  if BuyTime then
  begin
    BuyCol := false;
    for i := 0 to 11 do
    for j := 0 to 9 do
    begin
      if zglheader.col2d_PointInRect(mx,my,dfield[i,j].rect) then
      begin
        if not dfield[i,j].c then BuyCol := true;
        if zglheader.mouse_Up(m_bleft) then
        begin
          if not dfield[i,j].c then
          begin
            if (dfield[i,j].d = 0) then Credits := Credits - 1;
            if Credits < 0 then Credits := 0;
            if (dfield[i,j].d > 0) or (Credits > 0) then dfield[i,j].d := NowDir;
            buytime := false;
          end;
        end;
      end;
    end;
  end;

  end;

  sOver:
  begin
    dt := timer_GetTicks - lastTimerTicks;
    lastTimerTicks := timer_GetTicks;

    Particle1.Process(dt/800);
    Particle2.Process(dt/800);
    Button_Process(@BTry);
    if mouse_Up(m_bleft)then
    begin
      if BTry.F = 2 then
      begin
        if IsSound then Snd_Play( ClickSnd, False );
        calculate;
        BRun.T := 'run';
        Credits := 6;
        StopGame := true;
        for i := 0 to 11 do
        for j := 0 to 9 do
        begin
          dfield[i,j].d := 0;
        end;
      end;
    end;
  end;

  sClear:
  begin
    dt := timer_GetTicks - lastTimerTicks;
    lastTimerTicks := timer_GetTicks;

    Particle1.Process(dt/800);
    Particle2.Process(dt/800);
    Button_Process(@Bne);
    if mouse_Up(m_bleft)then
    begin
      if Bne.F = 2 then
      begin
        if IsSound then Snd_Play( ClickSnd, False );
        GameScene := sGa;
        nlevel := nlevel + 1;
        Load_Level('data\levels\'+u_inttostr(nlevel)+'.lvl');
        if nlevel > UnlockN then unlock(nlevel);
        calculate;
        Credits := 6;
        BRun.T := 'run';
        StopGame := true;
        for i := 0 to 11 do
        for j := 0 to 9 do
        begin
          dfield[i,j].d := 0;
        end;
      end;
    end;
  end;

  sCake:
  begin
    dt := timer_GetTicks - lastTimerTicks;
    lastTimerTicks := timer_GetTicks;

    Particle1.Process(dt/800);
    Particle2.Process(dt/800);
    Button_Process(@Bta);
    if mouse_Up(m_bleft)then
    begin
      if Bta.F = 2 then
      begin
        if IsSound then Snd_Play( ClickSnd, False );
        Scene := sMenu;
        MenuScene := sMain;
      end;
    end;
    delay := delay + 1;
    if delay = 10 then
    begin
      //Particle1.PlayEmitter(0,random(800),random(600),False);
      //Particle2.PlayEmitter(0,random(800),random(600),False);
      delay := 0;
    end;
  end;

  end;
end;

procedure Game_Paint;
var
i, j: Integer;
begin
  for i := 0 to 4 do
  for j := 0 to 3 do
  begin
    ssprite2d_Draw(grass,i*160,j*160,160,160,0,255);
  end;

  for i := 0 to 11 do
  for j := 0 to 9 do
  begin
    //if dfield[i,j].c and BuyTime then zglheader.pr2d_Rect(dfield[i,j].rect.x,dfield[i,j].rect.y,40,40,$FF0000,155,PR2D_FILL);
    //zglheader.pr2d_Rect(field[i,j].rect.x,field[i,j].rect.y,40,40,$000000,255);
    if field[i,j].d then asprite2d_Draw(sprites,field[i,j].rect.x,field[i,j].rect.y+20,40,40,0,11,255);
    if field[i,j].t then asprite2d_Draw(sprites,field[i,j].rect.x,field[i,j].rect.y-20,40,40,0,11,255);
    if field[i,j].l then asprite2d_Draw(sprites,field[i,j].rect.x-20,field[i,j].rect.y,40,40,0,12,255);
    if field[i,j].r then asprite2d_Draw(sprites,field[i,j].rect.x+20,field[i,j].rect.y,40,40,0,12,255);
  end;
  for i := 0 to 11 do
  for j := 0 to 9 do
  begin
    //if field[i,j].s > 0 then asprite2d_Draw(sprites,field[i,j].rect.x,field[i,j].rect.y,40,40,0,field[i,j].s,255);
    if field[i,j].s = 9 then asprite2d_Draw(sprites,field[i,j].rect.x,field[i,j].rect.y,40,40,0,9,255);
    if field[i,j].s = 10 then asprite2d_Draw(sprites,field[i,j].rect.x,field[i,j].rect.y,40,40,0,10,255);

    if (dfield[i,j].d > 0) and not StopGame then asprite2d_Draw(sprites,dfield[i,j].rect.x,dfield[i,j].rect.y,40,40,0,12+dfield[i,j].d,255);
  end;
  for i := 0 to NCreatures-1 do
  begin
    if creatures[i].l then
    asprite2d_Draw(sprites,creatures[i].r.x,creatures[i].r.y,40,40,0,creatures[i].f,255);
    //zglheader.pr2d_Rect(creatures[i].r2.x,creatures[i].r2.y,creatures[i].r2.w,creatures[i].r2.h,$FFFFFF,255);
  end;
  for i := 0 to NAnim - 1 do
  begin
    if animate[i].a > 0 then asprite2d_Draw(sprites,animate[i].x,animate[i].y,40,40,0,animate[i].f,round(animate[i].a));
  end;

  for i := 0 to 11 do
  for j := 0 to 9 do
  begin
    if (dfield[i,j].d > 0) and StopGame then asprite2d_Draw(sprites,dfield[i,j].rect.x,dfield[i,j].rect.y,40,40,0,12+dfield[i,j].d,255);
    if dfield[i,j].c and BuyTime then ssprite2d_Draw(xtex,dfield[i,j].rect.x,dfield[i,j].rect.y,40,40,0,255);
  end;

  Particle1.Render;
  Particle2.Render;


  Button_Paint(@Brun);
  Button_Paint(@Bqu);
  for i := 0 to 3 do SButton_Paint(@MoveButtons[i]);

  if BuyTime then
  begin
    asprite2d_Draw(sprites,mx-20,my-20,40,40,0,12+NowDir,255);
  end;

  if Credits > 1 then zglheader.text_Drawex(font1,53,248,1,1,u_inttostr(Credits-1),255,$000000);
  if Credits < 2 then zglheader.text_Drawex(font1,53,248,1,1,u_inttostr(0),255,$FF0000);

  if GameScene = sOver then
  begin
    pr2d_Rect(0,0,800,600,$000000,155,PR2D_FILL);
    ssprite2d_Draw( Panel, 75, 60, 650, 450, 0 );
    asprite2d_Draw(gameover,200,100,400,250,0,GameOverT,255);
    Button_Paint(@BTry);
  end;

  if GameScene = sClear then
  begin
    pr2d_Rect(0,0,800,600,$000000,155,PR2D_FILL);
    ssprite2d_Draw( Panel, 75, 60, 650, 450, 0 );
    ssprite2d_Draw(clear,200,100,400,250,0,255);
    Button_Paint(@Bne);
  end;

  if GameScene = sCake then
  begin
    pr2d_Rect(0,0,800,600,$000000,155,PR2D_FILL);
    ssprite2d_Draw( Panel, 75, 60, 650, 450, 0 );
    ssprite2d_Draw(cake,200,100,400,250,0,255);
    Button_Paint(@Bta);
    //Particle1.Render;
    //Particle2.Render;
  end;
  //zglheader.text_Draw(font1,10,10,u_inttostr(Credits));
  //text_Drawex(font1,345,10,1,1,'level '+u_inttostr(nlevel),255,$000000);
end;

end.

