unit u_Init;

interface
uses
  zglHeader, sysutils, classes;

var
  FPS, Test: Integer;
  procedure AllInit;
  procedure Load_Level(s:string);
  procedure Load_progress;
  procedure Save_progress;
  procedure unlock(n:integer);
  procedure calculate;

implementation
uses
  u_Game, u_Menu, u_Particles;

procedure Load_progress;
var
f: TFileStream;
begin
  f := TFileStream.Create('data\levels\progress'+'.dat', fmOpenRead);
  f.Read(unlockN,2);
  f.Free;
end;

procedure Save_progress;
var
f: TFileStream;
begin
  f := TFileStream.Create('data\levels\progress'+'.dat', fmCreate);
  f.Write(unlockN,2);
  f.Free;
end;

procedure unlock(n:integer);
var
i: integer;
begin
  for i := 0 to 19 do
  begin
    if (i+1) < (n+1) then levelbuttons[i].L := false;
  end;
  unlockN := n;
end;

procedure calculate;
var
i,j: integer;
begin
  BRun.T := 'run';
  SheepsN := 0;
  GameScene := sGa;
  NCreatures := 0;
  Nanim := 0;
  for i := 0 to 11 do
  for j := 0 to 9 do
  begin
    if (field[i,j].s > 0) and (field[i,j].s < 9) then
    begin
      NCreatures := NCreatures + 1;
      setlength(creatures,ncreatures);
      creatures[ncreatures-1].r.x := field[i,j].rect.x;
      creatures[ncreatures-1].r.y := field[i,j].rect.y;
      creatures[ncreatures-1].r.w := 40;
      creatures[ncreatures-1].r.h := 40;
      creatures[ncreatures-1].f := field[i,j].s;
      case field[i,j].s of
        1:creatures[ncreatures-1].d := 1;
        2:creatures[ncreatures-1].d := 2;
        3:creatures[ncreatures-1].d := 3;
        4:creatures[ncreatures-1].d := 4;
        5:creatures[ncreatures-1].d := 1;
        6:creatures[ncreatures-1].d := 2;
        7:creatures[ncreatures-1].d := 3;
        8:creatures[ncreatures-1].d := 4;
      end;
      if field[i,j].s < 5 then creatures[ncreatures-1].t := 1;
      if field[i,j].s > 4 then creatures[ncreatures-1].t := 2;
      creatures[ncreatures-1].l := true;
      if field[i,j].s < 5 then SheepsN := SheepsN + 1;
    end;
  end;

  for i := 0 to 11 do
  for j := 0 to 9 do
  begin
    dfield[i,j].c := false;
    if (field[i,j].s = 9) or (field[i,j].s = 10) then
    begin
      dfield[i,j].c := true;
    end;
  end;
end;

procedure Load_Level(s:string);
var
i,j: integer;
f: TFileStream;
begin
  f := TFileStream.Create(s, fmOpenRead);
  for i := 0 to 11 do
  for j := 0 to 9 do
  begin
    f.Read(field[i,j].t,1);
    f.Read(field[i,j].d,1);
    f.Read(field[i,j].l,1);
    f.Read(field[i,j].r,1);
    f.Read(field[i,j].s,2);
  end;
  f.Free;
end;

procedure AllInit;
var
i, j, r, x, y: Integer;
begin
  Logo := tex_LoadFromFile( 'data/logo.png', $FF000000, TEX_DEFAULT_2D );
  Back := tex_LoadFromFile( 'data/back.png', $FF000000, TEX_DEFAULT_2D );
  Fox := tex_LoadFromFile( 'data/fox.png', $FF000000, TEX_DEFAULT_2D );
  Sheep := tex_LoadFromFile( 'data/sheep.png', $FF000000, TEX_DEFAULT_2D );
  Menu := tex_LoadFromFile( 'data/menu.png', $FF000000, TEX_DEFAULT_2D );
  Panel := tex_LoadFromFile( 'data/panel.png', $FF000000, TEX_DEFAULT_2D );
  Button := tex_LoadFromFile( 'data/button.png', $FF000000, TEX_DEFAULT_2D );
  Check := tex_LoadFromFile( 'data/check.png', $FF000000, TEX_DEFAULT_2D );
  Sprites := tex_LoadFromFile( 'data/sprites.png', $FF000000, TEX_DEFAULT_2D );
  Grass := tex_LoadFromFile( 'data/grass.png', $FF000000, TEX_DEFAULT_2D );
  Particles := tex_LoadFromFile( 'data/Particles.png', $FF00FF00, TEX_DEFAULT_2D );
  //fence := tex_LoadFromFile( 'data/fence.png', $FF000000, TEX_DEFAULT_2D );
  xtex := tex_LoadFromFile( 'data/x.png', $FF000000, TEX_DEFAULT_2D );
  gameover := tex_LoadFromFile( 'data/gameover.png', $FF000000, TEX_DEFAULT_2D );
  clear := tex_LoadFromFile( 'data/clear.png', $FF000000, TEX_DEFAULT_2D );
  igdc := tex_LoadFromFile( 'data/igdc.png', $FF000000, TEX_DEFAULT_2D );
  cake := tex_LoadFromFile( 'data/cake.png', $FF000000, TEX_DEFAULT_2D );
  tex_SetFrameSize( Button, 200, 75 );
  tex_SetFrameSize( Check, 70, 70 );
  tex_SetFrameSize( sprites, 40, 40 );
  tex_SetFrameSize( particles, 32, 32 );
  tex_SetFrameSize( gameover, 400, 250 );


  Particle1 := TParticleEngine.Create(Particles);
  Particle1.LoadFromFile('data\test.pee');
  Particle2 := TParticleEngine.Create(Particles);
  Particle2.LoadFromFile('data\test2.pee');


  //Font
  Font1 := font_LoadFromFile( 'data/font/font.zfi' );
  Font1.Pages[0] := tex_LoadFromFile( 'data/font/font.png', $FF000000, TEX_DEFAULT_2D );
  //Font2 := font_LoadFromFile( 'data/font/font2.zfi' );
  //Font2.Pages[0] := tex_LoadFromFile( 'data/font/font2.png', $FF000000, TEX_DEFAULT_2D );
  wnd_SetCaption('Sheeps comes home');
  logo_count := 255;
  logo_alpha := 255;
  logoState := 1;
  //Buttons
  BSt.R.x := 0;
  BSt.R.y := 500;
  BSt.R.w := 200;
  BSt.R.h := 75;
  BSt.R2 := BSt.R;
  BSt.R2.y := BSt.R.y + 2;
  BSt.F := 1;
  BSt.T := 'start';
  BOpt.R.x := 200;
  BOpt.R.y := 500;
  BOpt.R.w := 200;
  BOpt.R.h := 75;
  BOpt.R2 := BOpt.R;
  BOpt.R2.y := BOpt.R.y + 2;
  BOpt.F := 1;
  BOpt.T := 'options';
  BAb.R.x := 400;
  BAb.R.y := 500;
  BAb.R.w := 200;
  BAb.R.h := 75;
  BAb.R2 := BAb.R;
  BAb.R2.y := BAb.R.y + 2;
  BAb.F := 1;
  BAb.T := 'about';
  BEx.R.x := 600;
  BEx.R.y := 500;
  BEx.R.w := 200;
  BEx.R.h := 75;
  BEx.R2 := BEx.R;
  BEx.R2.y := BEx.R.y + 2;
  BEx.F := 1;
  BEx.T := 'quit';
  Bbac.R.x := 300;
  Bbac.R.y := 400;
  Bbac.R.w := 200;
  Bbac.R.h := 75;
  Bbac.R2 := Bbac.R;
  Bbac.R2.y := Bbac.R.y + 2;
  Bbac.F := 1;
  Bbac.T := 'back';
  Bok.R.x := 300;
  Bok.R.y := 400;
  Bok.R.w := 200;
  Bok.R.h := 75;
  Bok.R2 := Bok.R;
  Bok.R2.y := Bok.R.y + 2;
  Bok.F := 1;
  Bok.T := 'ok';
  Brun.R.x := 160;
  Brun.R.y := 500;
  Brun.R.w := 200;
  Brun.R.h := 75;
  Brun.R2 := Brun.R;
  Brun.R2.y := Brun.R.y + 2;
  Brun.F := 1;
  Brun.T := 'run';
  Bqu.R.x := 440;
  Bqu.R.y := 500;
  Bqu.R.w := 200;
  Bqu.R.h := 75;
  Bqu.R2 := Bqu.R;
  Bqu.R2.y := Bqu.R.y + 2;
  Bqu.F := 1;
  Bqu.T := 'quit';
  Btry.R.x := 300;
  Btry.R.y := 380;
  Btry.R.w := 200;
  Btry.R.h := 75;
  Btry.R2 := Btry.R;
  Btry.R2.y := Btry.R.y + 2;
  Btry.F := 1;
  Btry.T := 'retry';
  Bne.R.x := 300;
  Bne.R.y := 380;
  Bne.R.w := 200;
  Bne.R.h := 75;
  Bne.R2 := Bne.R;
  Bne.R2.y := Bne.R.y + 2;
  Bne.F := 1;
  Bne.T := 'next';
  Bta.R.x := 300;
  Bta.R.y := 380;
  Bta.R.w := 200;
  Bta.R.h := 75;
  Bta.R2 := Bta.R;
  Bta.R2.y := Bta.R.y + 2;
  Bta.F := 1;
  Bta.T := 'take';
  {for i := 0 to 19 do
  begin
    x := x + 1;
    if (i = 0) or (i = 5) or (i = 10) or (i = 15) then
    begin
     y := y + 1;
     x := 0;
    end;
    LevelButtons[i].R.x := 210 + x*75;
    LevelButtons[i].R.y := -198 + (y-1)*75;
    LevelButtons[i].R.w := 70;
    LevelButtons[i].R.h := 70;
    LevelButtons[i].C.cX := LevelButtons[i].R.x + 35;
    LevelButtons[i].C.cY := LevelButtons[i].R.y + 35;
    LevelButtons[i].C.radius := 30;
    LevelButtons[i].R2 := LevelButtons[i].R;
    LevelButtons[i].R2.y := LevelButtons[i].R2.y + 2;
    LevelButtons[i].R2.x := LevelButtons[i].R2.x + 4;
    LevelButtons[i].T := u_IntToStr(i+1);
    LevelButtons[i].F := 1;
    if i < 1 then LevelButtons[i].L := false else LevelButtons[i].L := true;
  end;}

  for i := 0 to 4 do
  begin
    LevelButtons[i].R.x := 210 + i*75;
    LevelButtons[i].R.y := 102;
    LevelButtons[i].R.w := 70;
    LevelButtons[i].R.h := 70;
    LevelButtons[i].C.cX := LevelButtons[i].R.x + 35;
    LevelButtons[i].C.cY := LevelButtons[i].R.y + 35;
    LevelButtons[i].C.radius := 30;
    LevelButtons[i].R2 := LevelButtons[i].R;
    LevelButtons[i].R2.y := LevelButtons[i].R2.y + 2;
    LevelButtons[i].R2.x := LevelButtons[i].R2.x + 4;
    LevelButtons[i].T := u_IntToStr(i+1);
    LevelButtons[i].F := 1;
    if i < 1 then LevelButtons[i].L := false else LevelButtons[i].L := true;
  end;
  for i := 5 to 9 do
  begin
    LevelButtons[i].R.x := 210 + i*75 -375;
    LevelButtons[i].R.y := 177;
    LevelButtons[i].R.w := 70;
    LevelButtons[i].R.h := 70;
    LevelButtons[i].C.cX := LevelButtons[i].R.x + 35;
    LevelButtons[i].C.cY := LevelButtons[i].R.y + 35;
    LevelButtons[i].C.radius := 30;
    LevelButtons[i].R2 := LevelButtons[i].R;
    LevelButtons[i].R2.y := LevelButtons[i].R2.y + 2;
    LevelButtons[i].R2.x := LevelButtons[i].R2.x + 4;
    LevelButtons[i].T := u_IntToStr(i+1);
    LevelButtons[i].F := 1;
    if i < 1 then LevelButtons[i].L := false else LevelButtons[i].L := true;
  end;
  for i := 10 to 14 do
  begin
    LevelButtons[i].R.x := 210 + i*75 -750;
    LevelButtons[i].R.y := 252;
    LevelButtons[i].R.w := 70;
    LevelButtons[i].R.h := 70;
    LevelButtons[i].C.cX := LevelButtons[i].R.x + 35;
    LevelButtons[i].C.cY := LevelButtons[i].R.y + 35;
    LevelButtons[i].C.radius := 30;
    LevelButtons[i].R2 := LevelButtons[i].R;
    LevelButtons[i].R2.y := LevelButtons[i].R2.y + 2;
    LevelButtons[i].R2.x := LevelButtons[i].R2.x + 4;
    LevelButtons[i].T := u_IntToStr(i+1);
    LevelButtons[i].F := 1;
    if i < 1 then LevelButtons[i].L := false else LevelButtons[i].L := true;
  end;
  for i := 15 to 19 do
  begin
    LevelButtons[i].R.x := 210 + i*75 - 1125;
    LevelButtons[i].R.y := 327;
    LevelButtons[i].R.w := 70;
    LevelButtons[i].R.h := 70;
    LevelButtons[i].C.cX := LevelButtons[i].R.x + 35;
    LevelButtons[i].C.cY := LevelButtons[i].R.y + 35;
    LevelButtons[i].C.radius := 30;
    LevelButtons[i].R2 := LevelButtons[i].R;
    LevelButtons[i].R2.y := LevelButtons[i].R2.y + 2;
    LevelButtons[i].R2.x := LevelButtons[i].R2.x + 4;
    LevelButtons[i].T := u_IntToStr(i+1);
    LevelButtons[i].F := 1;
    if i < 1 then LevelButtons[i].L := false else LevelButtons[i].L := true;
  end;



  for i := 0 to 3 do
  begin
    MoveButtons[i].R.x := 40;
    MoveButtons[i].R.y := 80 + i*40;
    MoveButtons[i].R.w := 40;
    MoveButtons[i].R.h := 40;
    MoveButtons[i].C.cX := MoveButtons[i].R.x + 20;
    MoveButtons[i].C.cY := MoveButtons[i].R.y + 20;
    MoveButtons[i].C.radius := 30;
    MoveButtons[i].R2 := MoveButtons[i].R;
    MoveButtons[i].R2.y := MoveButtons[i].R2.y + 2;
    MoveButtons[i].R2.x := MoveButtons[i].R2.x + 4;
    MoveButtons[i].T := u_inttostr(i+1);
    MoveButtons[i].F := 1;
    MoveButtons[i].M := true;
  end;
  //Checks
  CheckM.R.x := 110;
  CheckM.R.y := 130;
  CheckM.R.w := 70;
  CheckM.R.h := 70;
  CheckM.C.cX := CheckM.R.x + 35;
  CheckM.C.cY := CheckM.R.y + 35;
  CheckM.C.radius := 35;
  CheckM.O := true;
  CheckS.R.x := 110;
  CheckS.R.y := 210;
  CheckS.R.w := 70;
  CheckS.R.h := 70;
  CheckS.C.cX := CheckS.R.x + 35;
  CheckS.C.cY := CheckS.R.y + 35;
  CheckS.C.radius := 35;
  CheckS.O := true;
  CheckF.R.x := 110;
  CheckF.R.y := 290;
  CheckF.R.w := 70;
  CheckF.R.h := 70;
  CheckF.C.cX := CheckF.R.x + 35;
  CheckF.C.cY := CheckF.R.y + 35;
  CheckF.C.radius := 35;
  CheckF.O := false;
  for i := 0 to 11 do
  for j := 0 to 9 do
  begin
    field[i,j].rect.x := 160 + i*40;
    field[i,j].rect.y := 80 + j*40;
    field[i,j].rect.w := 40;
    field[i,j].rect.h := 40;
  end;
  for i := 0 to 11 do
  for j := 0 to 9 do
  begin
    dfield[i,j].rect.x := 160 + i*40;
    dfield[i,j].rect.y := 80 + j*40;
    dfield[i,j].rect.w := 40;
    dfield[i,j].rect.h := 40;
  end;

  load_progress;
  unlock(unlockN);
  //NAnim := 1;
  snd_Init;
  Music := snd_LoadFromFile('data/music.ogg');
  PopSnd := snd_LoadFromFile('data/Pop.ogg');
  ClickSnd := snd_LoadFromFile('data/Click.ogg');
  LevelSnd := snd_LoadFromFile('data/Level.ogg');
  LoseSnd := snd_LoadFromFile('data/lose.ogg');
  Snd_Play( Music, TRUE );
  IsSound := true;
end;

end.
