unit u_Menu;

interface
uses
  zglHeader;

type
  PButton = ^TButton;
  TButton = record
    R,R2: zglTRect;
    F: Byte;
    T: String;
    C: zglTCircle;
    L: boolean;
    M: boolean;
  end;

type
  PChecker = ^TChecker;
  TChecker = record
    R: zglTRect;
    C: zglTCircle;
    F: Byte;
    O: Boolean;
  end;

var
  Logo, Menu, Button, Panel, Back, Fox, Sheep, Check,
  grass,sprites,xtex,Particles,gameover, clear, igdc, cake: zglPTexture;
  LevelButtons: array[0..19]of TButton;
  MoveButtons: array[0..3]of TButton;
  Font1,Font2: zglPFont;
  CheckM, CheckS, CheckF: TChecker;
  BSt, BOpt, BAb, BEx, Bbac, Bok, BRun, BQu, BTry, BNe, Bta: TButton;
  Logo_count, Logo_alpha, Black_alpha: Single;
  LogoState: byte;
  procedure Menu_Process;
  procedure Logo_Process;
  procedure Menu_Paint;
  procedure Logo_Paint;
  procedure Button_Paint(B: PButton);
  procedure Button_Process(B: PButton);
  procedure Check_Paint(C: PChecker);
  procedure Check_Process(C: PChecker);
  procedure SButton_Paint(B: PButton);
  procedure SButton_Process(B: PButton);
  procedure isPause( Activate : Boolean );

implementation
uses
  u_Game, u_Init, u_Particles;

procedure Check_Paint(C: PChecker);
begin
  asprite2d_Draw(check,c.R.x,c.R.y,70,70,0,c.F,255);
  if c.O then asprite2d_Draw(check,c.R.x,c.R.y,70,70,0,3,255);
end;

procedure Check_Process(C: PChecker);
begin
  if col2d_PointInCircle(mx,my,c.C) then c.F := 2 else c.F := 1;
end;

procedure Button_Paint(B: PButton);
begin
  asprite2d_Draw(button,b.R.x,b.R.y,200,75,0,b.F,255);
  text_DrawInRectEx(Font1,B.R2,1,0,B.T,255,$000000,TEXT_HALIGN_CENTER or TEXT_VALIGN_CENTER);
end;

procedure Button_Process(B: PButton);
begin
  if col2d_PointInRect(mx,my,b.R) then b.F := 2 else b.F := 1;
end;

procedure SButton_Paint(B: PButton);
begin
  if Not b.M then
  begin
    asprite2d_Draw(check,b.R.x,b.R.y,70,70,0,b.F,255);
    if not b.L
    then text_DrawInRectEx(Font1,B.R2,1,0,B.T,255,$000000,TEXT_HALIGN_CENTER or TEXT_VALIGN_CENTER)
    else
    begin
      asprite2d_Draw(check,b.R.x,b.R.y,70,70,0,4,255);
      pr2d_Circle(b.R.x+35,b.R.y+35,26,$000000,155,32,PR2D_FILL);
    end;
  end;

  if b.M then
  begin
    asprite2d_Draw(sprites,b.R.x,b.R.y,40,40,0,u_strtoint(b.T)+12,255);
  end;
end;

procedure SButton_Process(B: PButton);
begin
  if not b.L then
  begin
    if col2d_PointInCircle(mx,my,b.C) then b.F := 2 else b.F := 1;
  end;
end;

procedure isPause( Activate : Boolean );
begin
 if (not Activate) and (Scene = sGame) then
  begin
    Paused := True;
  end;
end;

procedure Logo_Process;
var
r: integer;
begin
  logo_count := logo_count - 1;
  if (logo_count <= 0) and (logo_alpha > 0) then logo_alpha := logo_alpha - 5;
  if (logo_alpha = 0) and (LogoState = 2) then
  begin
    Scene := sMenu;
    MenuScene := sMain;
    black_alpha := 255;
  end;
  if (logo_alpha = 0) and (LogoState = 1) then
  begin
    logoState := 2;
    logo_alpha := 255;
    logo_count := 255;
  end;
  if key_Press( K_SPACE ) then logo_count := 0;
  if key_Press( K_ENTER ) then logo_count := 0;
  if key_Press( K_ESCAPE ) then logo_count := 0;
  if mouse_Up( M_BLEFT ) then logo_count := 0;
end;

procedure Logo_Paint;
begin
  if logoState = 1 then
  begin
    ssprite2d_Draw( Logo, 200, 100, 400, 400, 0, round(logo_alpha) );
    ssprite2d_Draw( Igdc, 200, 100, 400, 400, 0, round(255-logo_alpha) );
  end;
  if logoState = 2 then
  begin
    ssprite2d_Draw( Igdc, 200, 100, 400, 400, 0, round(logo_alpha) );
  end;
end;

procedure Menu_Process;
var
i,j,k,l: Integer;
begin
  case MenuScene of
    sMain:
    begin
      Button_Process(@BSt);
      Button_Process(@BOpt);
      Button_Process(@Bab);
      Button_Process(@Bex);
    end;
    sAbout:
    begin
      Button_Process(@Bok);
    end;
    sOptions:
    begin
      Button_Process(@Bok);
      Check_Process(@CheckM);
      Check_Process(@CheckS);
      Check_Process(@CheckF);
    end;
    sStart:
    begin
      Button_Process(@Bbac);
      for i := 0 to 19 do SButton_Process(@LevelButtons[i]);
    end;
  end;
  if mouse_Up(m_bleft)then
  begin
    case MenuScene of
    sMain:
    begin
      if Bex.F = 2 then
      begin
       zgl_Exit;
       if IsSound then Snd_Play( ClickSnd, False );
      end;
      if BOpt.F = 2 then
      begin
       MenuScene := sOptions;
       if IsSound then Snd_Play( ClickSnd, False );
      end;
      if BAb.F = 2 then
      begin
       MenuScene := sAbout;
       if IsSound then Snd_Play( ClickSnd, False );
      end;
      if Bst.F = 2 then
      begin
       MenuScene := sStart;
       if IsSound then Snd_Play( ClickSnd, False );
      end;
    end;
    sAbout:
    begin
      if Bok.F = 2 then
      begin
       MenuScene := sMain;
       if IsSound then Snd_Play( ClickSnd, False );
      end;
    end;
    sOptions:
    begin
      if Bok.F = 2 then
      begin
       MenuScene := sMain;
       if IsSound then Snd_Play( ClickSnd, False );
      end;
      if CheckM.F = 2 then
      begin
        if IsSound then Snd_Play( ClickSnd, False );
        if CheckM.O then
        begin
          CheckM.O := false;
          snd_Stop(Music,0);
        end else
        begin
          CheckM.O := true;
          if IsSound then Snd_Play( Music, TRUE );
        end;
      end;
      if CheckS.F = 2 then
      begin
        if IsSound then Snd_Play( ClickSnd, False );
        if CheckS.O then
        begin
         CheckS.O := false;
         IsSound := false;
        end else
        begin
         CheckS.O := true;
         IsSound := true;
        end;
      end;
      if CheckF.F = 2 then
      begin
        if IsSound then Snd_Play( ClickSnd, False );
        if CheckF.O then
        begin
          CheckF.O := false;
          scr_SetOptions(800, 600, 32, 0, FALSE, FALSE);
        end else
        begin
          CheckF.O := true;
          scr_SetOptions(800, 600, 32, 0, TRUE, FALSE);
        end;
      end;
    end;
    sStart:
    begin
      if Bbac.F = 2 then
      begin
       MenuScene := sMain;
       if IsSound then Snd_Play( ClickSnd, False );
      end;
      for i := 0 to 19 do
      begin
        if LevelButtons[i].F = 2 then
        begin
          if IsSound then Snd_Play( ClickSnd, False );
          Scene := sGame;
          Load_Level('data\levels\'+levelbuttons[i].T+'.lvl');
          calculate;
          StopGame := true;
          Credits := 6;
          NLevel := u_strtoint(levelbuttons[i].T);
          for k := 0 to 11 do
          for l := 0 to 9 do
          begin
            dfield[k,l].d := 0;
          end;
        end;
      end;
    end;
    end;
  end;
end;

procedure Menu_Paint;
var
i: Integer;
begin
  ssprite2d_Draw( Menu, 0, 0, 800, 600, 0 );
  Button_Paint(@BSt);
  Button_Paint(@Bopt);
  Button_Paint(@Bab);
  Button_Paint(@Bex);
  case MenuScene of
    sMain:
    begin
    end;
    sAbout:
    begin
      //pr2d_Rect(0,0,800,600,$000000,155,PR2D_FILL);
      ssprite2d_Draw( Back, 0, 0, 800, 600, 0 );
      ssprite2d_Draw( Panel, 75, 60, 650, 450, 0 );
      //ssprite2d_Draw( Sheep, 80, 80, 100, 100, 0 );
      //ssprite2d_Draw( Sheep, 615, 80, 100, 100, 0 );
      //ssprite2d_Draw( Fox, 80, 393, 100, 100, 0 );
      //ssprite2d_Draw( Fox, 615, 393, 100, 100, 0 );
      //ssprite2d_Draw( Fox, 60, 220, 256, 256, 0 );
      ssprite2d_Draw( Sheep, 45, 125, 256, 256, 0 );
      ssprite2d_Draw( Fox, 492, 130, 256, 256, 0 );
      text_Drawex(Font1,260,150,1,1,'sheeps comes home',255,$000000);
      text_Drawex(Font1,290,225,1,1,'by rhino games',255,$000000);
      text_Drawex(Font1,285,300,1,1,'special for igdc',255,$000000);
      Button_Paint(@Bok);
    end;
    sOptions:
    begin
      //pr2d_Rect(0,0,800,600,$000000,155,PR2D_FILL);
      ssprite2d_Draw( Back, 0, 0, 800, 600, 0 );
      ssprite2d_Draw( Panel, 75, 60, 650, 450, 0 );
      Button_Paint(@Bok);
      Check_Paint(@CheckM);
      Check_Paint(@CheckS);
      Check_Paint(@CheckF);
      text_Drawex(Font1,200,150,1,1,'music',255,$000000);
      text_Drawex(Font1,200,230,1,1,'sounds',255,$000000);
      text_Drawex(Font1,200,310,1,1,'fullscreen',255,$000000);
    end;
    sStart:
    begin
      //pr2d_Rect(0,0,800,600,$000000,155,PR2D_FILL);
      ssprite2d_Draw( Back, 0, 0, 800, 600, 0 );
      ssprite2d_Draw( Panel, 75, 60, 650, 450, 0 );
      for i := 0 to 19 do SButton_Paint(@LevelButtons[i]);
      Button_Paint(@Bbac);
    end;
  end;
end;

end.

