#pragma once

#include <Types/Property/Property.h>
#include <Graphics/Window/Window.h>

#include <_external/glew/glew.h>

#pragma comment(lib, "opengl32.lib")
#pragma comment(lib, "glu32.lib")

namespace Graphics
{
	class OpenGL
	{
		private:
			static Types::Property<const char *> Subsystem;

			Graphics::Window * Wnd;
			HGLRC glRC;
			HDC glDC;

			void SetDefaultParameters();
		public:
			OpenGL();
			~OpenGL();

			static void DumpInfo();

			HDC GetDC();
			HGLRC GetRC();

			bool Init(Graphics::Window & Wnd);

			void Clear();
			void SwapBuffers();

			void Set2D();
	};
};