#pragma once

#include <Types/Property/Property.h>
#include <Graphics/OpenGL/OpenGL.h>

namespace Graphics
{
	class Shader
	{
	private:
		static Types::Property<const char *> Subsystem;

		GLhandleARB Handle;
		bool Initialized;
	public:
		Shader();
		~Shader();

		bool LoadFromString(GLenum ShaderType, const char * Source);
		bool LoadFromFile(GLenum ShaderType, const char * Filename);

		bool IsLoaded();
		GLhandleARB GetHandle();

		void Delete();
	};

	class VertexShader : public Shader
	{
	public:
		bool LoadFromString(const char * Source);
		bool LoadFromFile(const char * Filename);
	};

	class FragmentShader : public Shader
	{
	public:
		bool LoadFromString(const char * Source);
		bool LoadFromFile(const char * Filename);
	};
};