#pragma once

#include <Types/Property/Property.h>
#include <Graphics/Shader/Shader.h>

namespace Graphics
{
	class ShaderProgram
	{
	private:
		static Types::Property<const char *> Subsystem;

		GLhandleARB Handle;
		bool Initialized;
	public:
		ShaderProgram();
		~ShaderProgram();

		GLhandleARB GetHandle();

		bool Attach(Graphics::Shader & Shader);
		bool Link();

		void Delete();

		void Bind();
		static void Unbind();

		bool GetUniformFloat(const char * Name, float * Buf);
		bool GetUniformInt(const char * Name, int * Buf);

		bool SetUniformFloat(const char * Name, int Count, float * Value);
		bool SetUniformInt(const char * Name, int Count, int * Value);

		GLint GetUniformLocation(const char * Name);
	};
};