#pragma once

#include <Types/Property/Property.h>
#include <Graphics/OpenGL/OpenGL.h>

namespace Graphics
{
	class Texture
	{
	private:
		static Types::Property<const char *> Subsystem;

		GLuint TextureId;
		bool TextureIdAssigned;

		int Width;
		int Height;
		int Format;
		int StoreFormat;
	public:
		Texture();
		~Texture();

		void Create(int Width, int Height, int StoreFormat, int Format, void * Data, int DataType = GL_UNSIGNED_BYTE);
		void Delete();
		void Bind();
		void Bind(int Index); // for multitexturing

		int GetWidth();
		int GetHeight();
		int GetFormat();
		int GetStoreFormat();

		static void Unbind();
		static void Unbind(int Index); // for multitexturing

		static void ChangeSlot(int Index); // for multitexturing
		static void SetEnvMode(int EnvMode = GL_REPLACE); // for multitexturing

		static void SetCoord(float U, float V);
		static void SetCoord(int Index, float U, float V); // for multitexturing
	};
};