#pragma once

#include <Windows.h>

#include <Types/Property/Property.h>
#include <System/Threads/CriticalSection/CriticalSection.h>

namespace Graphics
{
	class Window
	{
		private:
			static Types::Property<const char *> Subsystem;
			static unsigned long Instances;

			static ATOM WndClass;

			static System::Threads::CriticalSection CritSection;

			HWND Handle;
		public:
			Window();
			~Window();

			bool Init(int Width, int Height, bool HasTitleBar = true, const char * Title = nullptr, WNDPROC WndProc = DefWindowProc);

			HWND GetHandle();
			HDC GetDC();

			int GetWidth();
			int GetHeight();

			int GetClientWidth();
			int GetClientHeight();
	};
};