#pragma once

#include <deque>

#include <windows.h>

#include <Types/Property/Property.h>
#include <System/Threads/CriticalSection/CriticalSection.h>

namespace System
{
	class Application
	{
	public:
		typedef void Event();
	private:
		static Types::Property<const char *> Subsystem;

		static Types::Property<bool> Running;

		static bool Initialized;
		static bool Finalized;

		static System::Threads::CriticalSection CritSection;

		static std::deque<Event *> OnInitialize;
		static std::deque<Event *> OnFinalize;

		static void CallEventList(std::deque<Event *> EventList);
	public:
		static Types::Property<HMODULE> Handle;

		static Event & RunProc;

		static void DefaultRunProc();

		static void Run(Event & RunProc);
		static void Run();
		static void Terminate();

		static void AddInitializator(Event & Initializator);
		static void AddFinalizator(Event & Finalizator);

		static bool IsRunning();
	};
};