#pragma once

#include <stdio.h>
#include <stdarg.h>
#include <windows.h>

#include <Types/Property/Property.h>
#include <System/Application/Application.h>
#include <System/Threads/CriticalSection/CriticalSection.h>

namespace System
{
	class Log
	{
	private:
		static Types::Property<const char *> Subsystem;

		static char Buffer[16 * 1024];
		static System::Threads::CriticalSection CritSection;

		static void PrintMessage(const char * Subsystem, const char Prefix, const char * Text, va_list Args);
	public:
		class MessageType
		{
		public:
			enum 
			{
				Message			= 0x0001,
				Warning			= 0x0002,
				Error			= 0x0004,
				CriticalError	= 0x0008,
			};
		};

		static unsigned int Level;
		static bool StopOnError;
		static FILE * LogFile;

		static bool AssignLogFile(const char * Filename);
		static void CloseLogFile();

		static void Message(const char * Text, ...);
		static void Warning(const char * Text, ...);
		static void Error(const char * Text, ...);
		static void CriticalError(const char * Text, ...);

		static void Message(const char * Subsystem, const char * Text, ...);
		static void Warning(const char * Subsystem, const char * Text, ...);
		static void Error(const char * Subsystem, const char * Text, ...);
		static void CriticalError(const char * Subsystem, const char * Text, ...);

		static void Message(Types::Property<const char *> Subsystem, const char * Text, ...);
		static void Warning(Types::Property<const char *> Subsystem, const char * Text, ...);
		static void Error(Types::Property<const char *> Subsystem, const char * Text, ...);
		static void CriticalError(Types::Property<const char *> Subsystem, const char * Text, ...);
	};
};