#pragma once

#include <System/Application/Application.h>
#include <System/Info/Info.h>
#include <System/Log/Log.h>
#include <Graphics/Window/Window.h>
#include <Graphics/OpenGL/OpenGL.h>
#include <Graphics/Texture/Texture.h>
#include <Graphics/PNG/PNG.h>
#include <Types/Vector2/Vector2.h>
#include <Types/Vector3/Vector3.h>
#include <Types/Vector4/Vector4.h>
#include <Consts/Consts.h>

#include <Box2D/Box2D.h>

#include "World.h"
#include "Block.h"
#include "Player.h"

#include "Levels.h"

using namespace System;
using namespace Graphics;
using namespace Types;

extern Window MainWnd;
extern OpenGL GL;

extern bool Keys[256];
extern Vector2i CursorPos;

namespace Game
{
	extern class World;
	extern class Block;
	extern class Player;
};

extern Game::World * World;
extern Game::Player * Player;