#include "Levels.h"

#include "Common.h"

const char * Level1Name = "Easywayo";

void Level1()
{
	Game::Block * Block;
	Game::BlockEllipsoid * eBlock;

	World->ClearBlocks();

	Player->Reset();

	eBlock = new Game::BlockEllipsoid();
	eBlock->Radius1 = 500.0f;
	eBlock->Radius2 = 250.0f;
	eBlock->PointsCount = 32;
	eBlock->AngleStart = Consts::Pi;
	eBlock->Pos = Vector2f(-700.0f, -175.0f);
	eBlock->Color = Vector4f(0.45f, 1.0f, 0.45f, 1.0f);
	eBlock->Fixed = true;
	eBlock->DisplayPointsCount = 64;
	World->Blocks.push_back(eBlock);

	Block = new Game::Block();
	Block->Points.push_back(Vector2f(-700.0f, -75.0f));
	Block->Points.push_back(Vector2f(200.0f, -75.0f));
	Block->Points.push_back(Vector2f(200.0f, -175.0f));
	Block->Points.push_back(Vector2f(-700.0f, -175.0f));
	Block->Color = Vector4f(0.45f, 1.0f, 0.45f, 1.0f);
	Block->Fixed = true;
	World->Blocks.push_back(Block);

	eBlock = new Game::BlockEllipsoid();
	eBlock->Radius1 = 175.0f;
	eBlock->Radius2 = 75.0f;
	eBlock->PointsCount = 24;
	eBlock->DisplayPointsCount = 64;
	eBlock->AngleEnd = Consts::Pi;
	eBlock->Pos = Vector2f(200.0f, 0.0f);
	eBlock->Color = Vector4f(0.45f, 1.0f, 0.45f, 1.0f);
	eBlock->Fixed = true;
	World->Blocks.push_back(eBlock);

	Block = new Game::Block();
	Block->Points.push_back(Vector2f(-700.0f, -175.0f));
	Block->Points.push_back(Vector2f(200.0f, -175.0f));
	Block->Points.push_back(Vector2f(200.0f, -275.0f));
	Block->Points.push_back(Vector2f(-700.0f, -275.0f));
	Block->Color = Vector4f(0.45f, 1.0f, 0.45f, 1.0f);
	Block->Fixed = true;
	World->Blocks.push_back(Block);

	eBlock = new Game::BlockEllipsoid();
	eBlock->Radius1 = 175.0f;
	eBlock->Radius2 = 75.0f;
	eBlock->PointsCount = 24;
	eBlock->DisplayPointsCount = 64;
	eBlock->AngleEnd = Consts::Pi;
	eBlock->Pos = Vector2f(200.0f, -350.0f);
	eBlock->Color = Vector4f(0.45f, 1.0f, 0.45f, 1.0f);
	eBlock->Fixed = true;
	World->Blocks.push_back(eBlock);

	eBlock = new Game::BlockEllipsoid();
	eBlock->Radius1 = 75.0f;
	eBlock->PointsCount = 24;
	eBlock->DisplayPointsCount = 64;
	eBlock->AngleEnd = Consts::Pi;
	eBlock->Pos = Vector2f(200.0f, -350.0f);
	eBlock->Color = Vector4f(1.0f, 1.0f, 1.0f, 1.0f);
	eBlock->Type = 10;
	eBlock->Fixed = true;
	World->Blocks.push_back(eBlock);

	Block = new Game::Block();
	Block->Points.push_back(Vector2f(-700.0f, 75.0f));
	Block->Points.push_back(Vector2f(200.0f, 75.0f));
	Block->Points.push_back(Vector2f(200.0f, 175.0f));
	Block->Points.push_back(Vector2f(-700.0f, 325.0f));
	Block->Color = Vector4f(0.45f, 1.0f, 0.45f, 1.0f);
	Block->Fixed = true;
	World->Blocks.push_back(Block);

	Block = new Game::Block();
	Block->Points.push_back(Vector2f(-700.0f, -425.0f));
	Block->Points.push_back(Vector2f(200.0f, -425.0f));
	Block->Points.push_back(Vector2f(200.0f, -525.0f));
	Block->Points.push_back(Vector2f(-700.0f, -675.0f));
	Block->Color = Vector4f(0.45f, 1.0f, 0.45f, 1.0f);
	Block->Fixed = true;
	World->Blocks.push_back(Block);

	World->InitBlocks();
}

const char * Level2Name = "Curvetubetto";

void Level2()
{
	Game::Block * Block;
	Game::BlockEllipsoid * eBlock;

	World->ClearBlocks();

	Player->Reset();

	Block = new Game::Block();
	Block->Points.push_back(Vector2f(0.0f, 250.0f));
	Block->Points.push_back(Vector2f(-1500.0f, 250.0f));
	Block->Points.push_back(Vector2f(-1500.0f, 200.0f));
	Block->Points.push_back(Vector2f(0.0f, 200.0f));
	Block->Color = Vector4f(0.45f, 1.0f, 0.45f, 1.0f);
	World->Blocks.push_back(Block);

	Block = new Game::Block();
	Block->Points.push_back(Vector2f(0.0f, -250.0f));
	Block->Points.push_back(Vector2f(-1500.0f, -250.0f));
	Block->Points.push_back(Vector2f(-1500.0f, -200.0f));
	Block->Points.push_back(Vector2f(0.0f, -200.0f));
	Block->Color = Vector4f(0.45f, 1.0f, 0.45f, 1.0f);
	World->Blocks.push_back(Block);

	eBlock = new Game::BlockEllipsoid();
	eBlock->AngleStart = 0;
	eBlock->AngleEnd = Consts::Pi * 1.5f;
	eBlock->Radius1 = 75.0f;
	eBlock->Radius2 = 74.0f;
	eBlock->PointsCount = 64;
	eBlock->Color = Vector4f(0.45f, 1.0f, 0.45f, 1.0f);
	World->Blocks.push_back(eBlock);

	eBlock = new Game::BlockEllipsoid();
	eBlock->AngleStart = 0;
	eBlock->AngleEnd = Consts::Pi;
	eBlock->Radius1 = 250.0f;
	eBlock->Radius2 = 200.0f;
	eBlock->PointsCount = 64;
	eBlock->DisplayPointsCount = 64;
	eBlock->Color = Vector4f(0.45f, 1.0f, 0.45f, 1.0f);
	World->Blocks.push_back(eBlock);

	eBlock = new Game::BlockEllipsoid();
	eBlock->Pos = Vector2f(-1500.0f, -250.0f);
	eBlock->AngleStart = Consts::Pi;
	eBlock->AngleEnd = Consts::Pi * 2.0f;
	eBlock->Radius1 = 500.0f;
	eBlock->Radius2 = 450.0f;
	eBlock->PointsCount = 64;
	eBlock->DisplayPointsCount = 256;
	eBlock->Color = Vector4f(0.45f, 1.0f, 0.45f, 1.0f);
	World->Blocks.push_back(eBlock);

	eBlock = new Game::BlockEllipsoid();
	eBlock->Pos = Vector2f(-1500.0f, -225.0f);
	eBlock->AngleStart = Consts::Pi * 1.5f;
	eBlock->AngleEnd = Consts::Pi * 3.5f;
	eBlock->Radius1 = 75.0f;
	eBlock->PointsCount = 64;
	eBlock->DisplayPointsCount = 64;
	eBlock->Type = 2;
	eBlock->Color = Vector4f(1.0f, 0.45f, 0.45f, 1.0f);
	World->Blocks.push_back(eBlock);

	Block = new Game::Block();
	Block->Points.push_back(Vector2f(0.0f, -750.0f));
	Block->Points.push_back(Vector2f(-1500.0f, -750.0f));
	Block->Points.push_back(Vector2f(-1500.0f, -700.0f));
	Block->Points.push_back(Vector2f(0.0f, -700.0f));
	Block->Color = Vector4f(0.45f, 1.0f, 0.45f, 1.0f);
	World->Blocks.push_back(Block);

	eBlock = new Game::BlockEllipsoid();
	eBlock->Pos = Vector2f(0.0f, -700.0f);
	eBlock->AngleStart = 0;
	eBlock->AngleEnd = Consts::Pi;
	eBlock->Radius1 = 500.0f;
	eBlock->Radius2 = 450.0f;
	eBlock->PointsCount = 64;
	eBlock->DisplayPointsCount = 64;
	eBlock->Color = Vector4f(0.45f, 1.0f, 0.45f, 1.0f);
	World->Blocks.push_back(eBlock);

	Block = new Game::Block();
	Block->Points.push_back(Vector2f(0.0f, -1200.0f));
	Block->Points.push_back(Vector2f(-1500.0f, -1200.0f));
	Block->Points.push_back(Vector2f(-1500.0f, -1150.0f));
	Block->Points.push_back(Vector2f(0.0f, -1150.0f));
	Block->Color = Vector4f(0.45f, 1.0f, 0.45f, 1.0f);
	World->Blocks.push_back(Block);

	eBlock = new Game::BlockEllipsoid();
	eBlock->Pos = Vector2f(0.0f, -725.0f);
	eBlock->AngleStart = Consts::Pi * 0.5f;
	eBlock->AngleEnd = Consts::Pi * 2.5f;
	eBlock->Radius1 = 75.0f;
	eBlock->PointsCount = 64;
	eBlock->DisplayPointsCount = 64;
	eBlock->Type = 2;
	eBlock->Color = Vector4f(1.0f, 0.45f, 0.45f, 1.0f);
	World->Blocks.push_back(eBlock);

	eBlock = new Game::BlockEllipsoid();
	eBlock->Pos = Vector2f(-1500.0f, -1450.0f);
	eBlock->AngleStart = Consts::Pi;
	eBlock->AngleEnd = Consts::Pi * 2.0f;
	eBlock->Radius1 = 750.0f;
	eBlock->Radius2 = 700.0f;
	eBlock->PointsCount = 64;
	eBlock->DisplayPointsCount = 256;
	eBlock->Color = Vector4f(0.45f, 1.0f, 0.45f, 1.0f);
	World->Blocks.push_back(eBlock);

	Block = new Game::Block();
	Block->Points.push_back(Vector2f(900.0f, -1150.0f));
	Block->Points.push_back(Vector2f(-1500.0f, -2200.0f));
	Block->Points.push_back(Vector2f(-1500.0f, -2150.0f));
	Block->Points.push_back(Vector2f(850.0f, -1100.0f));
	Block->Color = Vector4f(0.45f, 1.0f, 0.45f, 1.0f);
	World->Blocks.push_back(Block);

	eBlock = new Game::BlockEllipsoid();
	eBlock->Pos = Vector2f(-1500.0f, -1175.0f);
	eBlock->AngleStart = Consts::Pi * 1.5f;
	eBlock->AngleEnd = Consts::Pi * 3.5f;
	eBlock->Radius1 = 75.0f;
	eBlock->PointsCount = 24;
	eBlock->DisplayPointsCount = 64;
	eBlock->Type = 2;
	eBlock->Color = Vector4f(1.0f, 0.45f, 0.45f, 1.0f);
	World->Blocks.push_back(eBlock);

	Block = new Game::Block();
	Block->Points.push_back(Vector2f(900.0f, -1150.0f));
	Block->Points.push_back(Vector2f(900.0f, 00.0f));
	Block->Points.push_back(Vector2f(850.0f, 00.0f));
	Block->Points.push_back(Vector2f(850.0f, -1100.0f));
	Block->Color = Vector4f(0.45f, 1.0f, 0.45f, 1.0f);
	World->Blocks.push_back(Block);

	eBlock = new Game::BlockEllipsoid();
	eBlock->Pos = Vector2f(550.0f, 0.0f);
	eBlock->AngleStart = -Consts::Pi * 0.5f;
	eBlock->AngleEnd = Consts::Pi * 0.5f;
	eBlock->Radius1 = 350.0f;
	eBlock->Radius2 = 300.0f;
	eBlock->PointsCount = 48;
	eBlock->DisplayPointsCount = 64;
	eBlock->Color = Vector4f(0.45f, 1.0f, 0.45f, 1.0f);
	World->Blocks.push_back(eBlock);

	eBlock = new Game::BlockEllipsoid();
	eBlock->Pos = Vector2f(400.0f, 0.0f);
	eBlock->AngleStart = Consts::Pi * 1.5f;
	eBlock->AngleEnd = Consts::Pi * 3.0f;
	eBlock->Radius1 = 75.0f;
	eBlock->Radius2 = 74.0f;
	eBlock->PointsCount = 48;
	eBlock->Color = Vector4f(0.45f, 1.0f, 0.45f, 1.0f);
	World->Blocks.push_back(eBlock);

	eBlock = new Game::BlockEllipsoid();
	eBlock->Pos = Vector2f(365.0f, 55.0f);
	eBlock->Radius1 = 5.0f;
	eBlock->PointsCount = 8;
	eBlock->DisplayPointsCount = 32;
	eBlock->Color = Vector4f(1.0f, 1.0f, 1.0f, 1.0f);
	eBlock->Type = 10;
	World->Blocks.push_back(eBlock);

	World->InitBlocks();
}

const char * Level3Name = "Racoonatto";

void Level3()
{
	Game::Block * Block;
	Game::BlockEllipsoid * eBlock;

	World->ClearBlocks();

	Player->Reset();

	eBlock = new Game::BlockEllipsoid();
	eBlock->AngleStart = Consts::Pi * 0.25f;
	eBlock->AngleEnd = Consts::Pi * 1.75f;
	eBlock->Radius1 = 75.0f;
	eBlock->Radius2 = 70.0f;
	eBlock->PointsCount = 32;
	eBlock->Color = Vector4f(0.45f, 1.0f, 0.45f, 1.0f);
	World->Blocks.push_back(eBlock);

	eBlock = new Game::BlockEllipsoid();
	eBlock->AngleStart = Consts::Pi * 1.75f;
	eBlock->AngleEnd = Consts::Pi * 3.5f;
	eBlock->Radius1 = 225.0f;
	eBlock->Radius2 = 220.0f;
	eBlock->PointsCount = 48;
	eBlock->Color = Vector4f(0.45f, 1.0f, 0.45f, 1.0f);
	World->Blocks.push_back(eBlock);

	eBlock = new Game::BlockEllipsoid();
	eBlock->AngleStart = Consts::Pi * 1.2f;
	eBlock->AngleEnd = Consts::Pi * 3.1f;
	eBlock->Radius1 = 375.0f;
	eBlock->Radius2 = 370.0f;
	eBlock->PointsCount = 56;
	eBlock->Color = Vector4f(0.45f, 1.0f, 0.45f, 1.0f);
	World->Blocks.push_back(eBlock);

	eBlock = new Game::BlockEllipsoid();
	eBlock->AngleStart = Consts::Pi * 2.2f;
	eBlock->AngleEnd = Consts::Pi * 4.1f;
	eBlock->Radius1 = 575.0f;
	eBlock->Radius2 = 570.0f;
	eBlock->PointsCount = 60;
	eBlock->Color = Vector4f(0.45f, 1.0f, 0.45f, 1.0f);
	World->Blocks.push_back(eBlock);

	eBlock = new Game::BlockEllipsoid();
	eBlock->Radius1 = 775.0f;
	eBlock->Radius2 = 770.0f;
	eBlock->PointsCount = 64;
	eBlock->Color = Vector4f(0.45f, 1.0f, 0.45f, 1.0f);
	World->Blocks.push_back(eBlock);

	eBlock = new Game::BlockEllipsoid();
	eBlock->Pos = Vector2f(0.0f, 740.0f);
	eBlock->Radius1 = 35.0f;
	eBlock->Radius2 = 25.0f;
	eBlock->AngleStart = Consts::Pi;
	eBlock->AngleEnd = Consts::Pi * 3.0f;
	eBlock->PointsCount = 64;
	eBlock->Color = Vector4f(1.0f, 1.0f, 1.0f, 1.0f);
	eBlock->Type = 10;
	World->Blocks.push_back(eBlock);

	eBlock = new Game::BlockEllipsoid();
	eBlock->Pos = Vector2f(0.0f, 120.0f);
	eBlock->Radius1 = 30.0f;
	eBlock->PointsCount = 64;
	eBlock->Color = Vector4f(1.0f, 0.45f, 0.45f, 1.0f);
	eBlock->Type = 2;
	eBlock->Fixed = false;
	World->Blocks.push_back(eBlock);

	World->InitBlocks();
}

const char * Level4Name = "Meditanno";

void Level4()
{
	Game::Block * Block;
	Game::BlockEllipsoid * eBlock;

	World->ClearBlocks();

	Player->Reset();

	eBlock = new Game::BlockEllipsoid();
	eBlock->Radius1 = 1250.0f;
	eBlock->Radius2 = 1000.0f;
	eBlock->PointsCount = 64;
	eBlock->Color = Vector4f(1.0f, 0.45f, 0.45f, 1.0f);
	eBlock->Type = 2;
	World->Blocks.push_back(eBlock);

	for (int i = 0; i < 50; i++)
	{
		eBlock = new Game::BlockEllipsoid();
		eBlock->Pos = Vector2f(rand() * 2000.0f / RAND_MAX - 1000.0f, rand() * 2000.0f / RAND_MAX - 1000.0f);
		while (eBlock->Pos.Length() < 100.0f)
			eBlock->Pos = Vector2f(rand() * 2000.0f / RAND_MAX - 1000.0f, rand() * 2000.0f / RAND_MAX - 1000.0f);
		eBlock->AngleStart = rand() * Consts::Pi * 2.0f / RAND_MAX;
		eBlock->AngleEnd = eBlock->AngleStart + Consts::Pi * 2.0f;
		eBlock->Radius1 = 10.0f + rand() * 100.0f / RAND_MAX;
		eBlock->PointsCount = 32;
		eBlock->Color = Vector4f(0.45f, 1.0f, 0.45f, 1.0f);
		World->Blocks.push_back(eBlock);
	}

	eBlock = new Game::BlockEllipsoid();
	eBlock->Pos = Vector2f(rand() * 1800.0f / RAND_MAX - 900.0f, rand() * 1800.0f / RAND_MAX - 900.0f);
	while (eBlock->Pos.Length() < 100.0f)
		eBlock->Pos = Vector2f(rand() * 1800.0f / RAND_MAX - 1000.0f, rand() * 1800.0f / RAND_MAX - 900.0f);
	eBlock->AngleStart = rand() * Consts::Pi * 2.0f / RAND_MAX;
	eBlock->AngleEnd = eBlock->AngleStart + Consts::Pi * 2.0f;
	eBlock->Radius1 = 30.0f + rand() * 70.0f / RAND_MAX;
	eBlock->PointsCount = 32;
	eBlock->Color = Vector4f(1.0f, 1.0f, 1.0f, 1.0f);
	eBlock->Type = 10;
	World->Blocks.push_back(eBlock);

	World->InitBlocks();
}