#include "Player.h"

Game::Player::Player()
{
	Block = nullptr;
}

Game::Player::~Player()
{
	if (Block)
	{
		__try
		{
			delete Block;
		}
		__except(EXCEPTION_EXECUTE_HANDLER)
		{
		}
		Block = nullptr;
	}
}

void Game::Player::Reset()
{
	if (Block)
	{
		for (int i = 0; i < ::World->Blocks.size(); i++)
			if (::World->Blocks[i] == Block)
			{
				::World->Blocks.erase(::World->Blocks.begin() + i);
				break;
			}

		// small cute lifehack ^^ sankew tu Ze Gureato Lamubuda Funktionz!
		[&](Game::BlockPlayer ** Block)
		{
			__try
			{
				delete *Block;
			}
			__except(EXCEPTION_EXECUTE_HANDLER)
			{
			}
			*Block = nullptr;
		}(&Block);
	}

	Block = new Game::BlockPlayer();
	Block->Radius1 = 25.0f;
	Block->PointsCount = 48;
	Block->Fixed = false;
	Block->Init();
	::World->Blocks.push_back(Block);

	::World->Down = Vector2f(0.0f, 1.0f) * ::World->Down.Length();
}

void Game::Player::Process(float DeltaTime)
{
	if (!Block)
		return;

	Block->pBody->SetBullet(true);

	if (Block->pBody->GetAngularVelocity() > Consts::Pi * 0.5f)
		Block->pBody->SetAngularVelocity(Consts::Pi * 0.5f);
	if (Block->pBody->GetAngularVelocity() < -Consts::Pi * 0.5f)
		Block->pBody->SetAngularVelocity(-Consts::Pi * 0.5f);
	if (Block->pBody->GetLinearVelocity().Length() > 60.0f)
	{
		b2Vec2 Vel = Block->pBody->GetLinearVelocity();
		Vel.Normalize();
		Vel *= 60.0f;
		Block->pBody->SetLinearVelocity(Vel);
	}

	if (Block->pBody->GetLinearVelocity().Length() < 0.5f && 
		Block->pBody->GetAngularVelocity() < 0.01f &&
		Block->pBody->GetContactList())
	{
		b2Vec2 Impulse(-::World->Down.X * 70.0f, -::World->Down.Y * 70.0f);
		b2Vec2 Point(Block->pBody->GetPosition());
		Block->pBody->ApplyLinearImpulse(Impulse, Point);
		Block->pBody->ApplyAngularImpulse(0.005f);
	}

	for (b2ContactEdge * c = Block->pBody->GetContactList(); c; c = c->next)
	{
		b2Body * ContactBody = nullptr;
		if (c->contact->GetFixtureA()->GetBody() == Block->pBody)
			ContactBody = c->contact->GetFixtureB()->GetBody();
		if (c->contact->GetFixtureB()->GetBody() == Block->pBody)
			ContactBody = c->contact->GetFixtureA()->GetBody();
		if (!ContactBody)
			continue;

		Game::Block * ContactBlock = (Game::Block *)ContactBody->GetUserData();
		if (ContactBlock->Type == 2)
		{
			Reset();
			return;
		} else
		if (ContactBlock->Type == 10)
		{
			::World->NextLevel();
			return;
		}
	}	
}