#pragma once

#include "Common.h"

#include <vector>

using namespace Types;

namespace Game
{
	extern class Block;
	extern class Player;

	typedef void LevelInitFunc();

	struct Level
	{
		const char * Name;
		LevelInitFunc * InitFunc;
	};

	class World
	{
	private:
		void ProcessBlocks(float DeltaTime);
		void RenderBlocks();
	public:
		Vector2f Down;
		float Zoom;

		b2World * pWorld;

		std::vector<Game::Block *> Blocks;
		std::vector<Level *> Levels;

		int CurrLevel;

		World();
		~World();

		void Init();

		void ClearBlocks(bool WithPlayerBlock = false);
		void InitBlocks();

		void Process(float DeltaTime);

		void AddLevel(const char * Name, LevelInitFunc & InitFunc);
		void NextLevel();
	};
}