//      cdmlex (Setup v2)
unit Setup;
// 
interface


procedure LoadSetupFile;
procedure SaveSetupFile;
procedure WindowCenter;
procedure UseOpt;

var
  WinH, WinW                        : Integer;
  WinColors, Music, Sound           : Byte;
  Console,
  FullWin, VSync, ffVSync           : Boolean;

implementation
uses
  Windows, Omega, LexUtils, u_size, u_menu;


procedure CreatSetupfile;
begin
  WinW        := 1024;
  WinH        := 768;
  WinColors   := 32;
  FullWin     := FALSE;
  VSync       := FALSE;
  Music       := 10;
  Sound       := 10;
  Console     := FALSE;
  SaveSetupFile;
end;

procedure SaveSetupFile;
var
  Options : TextFile;
begin
  AssignFile(Options, 'Setup.ini');
  Rewrite(Options);
  writeln(Options, '_cdmLex game_');
  writeln(Options, '--');
  writeln(Options, ':');
  writeln(Options, WinW);
  writeln(Options, ':');
  writeln(Options, WinH);
  writeln(Options, ':');
  writeln(Options, WinColors);
  writeln(Options, ' :');
  writeln(Options, FullWin);
  writeln(Options, ' :');
  writeln(Options, VSync);
  writeln(Options, ' :');
  writeln(Options, Music);
  writeln(Options, ' :');
  writeln(Options, Sound);
  writeln(Options, ' :');
  writeln(Options, Console);
  CloseFile(Options);
end;


procedure LoadSetupFile;
///    .
var
  Options  : TextFile;
  Stringer : string;
begin
  if FileEx('Setup.ini') then
  begin
    assignfile(Options, 'Setup.ini');
    reset(Options);
    readln(Options, Stringer);
    if Stringer='_cdmLex game_' then
    begin
      readln(Options);
      readln(Options);
      readln(Options, WinW);
      readln(Options);
      readln(Options, WinH);
      readln(Options);
      readln(Options, WinColors);
      readln(Options);
      readln(Options, Stringer);
      FullWin := S2Bool(Stringer);
      readln(Options);
      readln(Options, Stringer);
      VSync := S2Bool(Stringer);
      readln(Options);
      readln(Options, Music);
      readln(Options);
      readln(Options, Sound);
      readln(Options);
      readln(Options, Stringer);
      Console :=  S2Bool(Stringer);      
      CloseFile(Options);
    end
    else
    begin
      CloseFile(Options);
      CreatSetupfile;
    end;
  end
  else
    CreatSetupfile;
end;

procedure WindowCenter;
begin
  if not FullWin then
    Omega.OE_SetWndPosition((GetSystemMetrics(SM_CXSCREEN) - WinW) div 2,
                            (GetSystemMetrics(SM_CYSCREEN) - WinH) div 2 -20 );
end;

procedure UseOpt;
begin
  OE_ChangeScreenOptions(WinW, WinH, WinColors, 0, FullWin, ffVSync);
  Omega.OE_SetWndPosition((GetSystemMetrics(SM_CXSCREEN) - WinW) div 2,
                          (GetSystemMetrics(SM_CYSCREEN) - WinH) div 2 -20 );
  u_size.SetSize;
  Setup.SaveSetupFile;
end;


end.
