unit u_Button;

interface

type
  T_Button = class
    T, ST : Integer;
    Gl, ifS,
    TX, TY, X2, Y2,
    X, Y, W, H : single;
    S : string;
    constructor Create(inS : string; inT : Integer; inX, inY, inW, inH : single; fS : single = 0.7);
    procedure   SetP(inS : string; inT : Integer; inX, inY, inW, inH : single; fS : single = 0.7);
    function    Work({inX, inY : Integer}) : Boolean;
    procedure   Draw;
  end;
  
const
  BtnColor : array[1..2] of Integer = ( $FFFFFF, $777777);

implementation
uses
  GSound,
  u_Cursor, OMEGA, u_Material;

constructor T_Button.Create;
begin
  SetP(inS, inT, inX, inY, inW, inH, fS);
end;

procedure T_Button.SetP;
begin
  X := inX;
  Y := inY;
  W := inW;
  H := inH;
  S := inS;
  T := inT;
  ST := 1;

  X2 := X + W;
  Y2 := Y + H;
  TX := X + (W - Text_GetWidth(FontA1, PChar(S), fS)) / 2;
  TY := Y + (H - 32) / 2;

  ifS := fS;
end;


function T_Button.Work;
begin
  Result := False;
  if  (Curs.X > X  + 2)
  and (Curs.X < X2 - 2)
  and (Curs.Y > Y  + 2)
  and (Curs.Y < Y2 - 2) then
  begin
    ST := 2;
    if GL < 245 then
    GL := GL + 7
    else
      GL := 255;
    if (Curs.LPDown) then
    begin
      Result := True;
      PlaySound(2);
    end;
  end
  else
  begin
    ST := 1;
    if GL > 7 then
      GL := GL - 7
    else
      GL := 0;
  end;
end;

procedure T_Button.Draw;
begin
  SSPrite_Draw(m_Button[1], X, Y, W, H);
//  if ST > 1 then
  SSPrite_Draw(m_Button[2], X, Y, W, H, trunc(GL));
 // TX := X + (W - Text_GetWidth(FontA1, PChar(S), Fs)) / 2;
  Text_Draw(FontA1, TX, Y + (H - 24)/2, PChar(S), ifS, 0, 225, $110101);
end;

end.
