unit u_Fish;

interface
uses
  Omega, LexUtils;
  
type
  t_Fish = class
    P, MP : TM2DRealPoint;
    F : Integer;
    procedure Work;
    procedure Draw;
    procedure SetPos;
    constructor Create;
  end;

  t_Layer = class
    Fish : array[1..4] of t_Fish;
    Gr   : array[1..4] of TM2DRealPoint;
    procedure Work;
    procedure Draw(A : Integer);
    constructor Create(pX : Integer);
  end;

implementation
uses
  Setup, u_Material;

constructor t_Fish.Create;
begin
  SetPos;
end;

procedure t_Fish.SetPos;
begin
  if random(4) > 1 then
  begin
    P.X := - 148;
    MP.X :=  1.7 + random(11) / 5;
    F := FX_DEFAULT;
  end
  else
  begin
    P.X := WinW + 20;
    MP.X := -1.7 - random(11) / 5;
    F := FX_DEFAULT or FX_FLIPX;
  end;
  MP.Y := (random(3) - 1) / (random(4) + 4);

  P.Y := 16 + random(WinH - 128);
end;

procedure t_Fish.Work;
begin
  M2DPoint_App(P, MP);

  if ((MP.X < 0) and (P.X < - 148))
  or ((MP.X > 0) and (P.X > WinW + 30))  then
    SetPos;
end;

procedure t_Fish.Draw;
begin
  SSprite_Draw(m_Fish, P.X, P.Y, 128, 64, $FF, MP.Y, F);
end;

constructor t_Layer.Create(pX : Integer);
var
  I : Integer;
begin
  for I := 1 to 4 do
  begin
    Gr[I].X := -16 + 64 * pX + (I - 1) * 256 - random(32) * 2;
    Gr[I].Y := WinH - 450 + random(32) + pX * 32 - I * 32;
  end;

  for I := 1 to 4 do
    Fish[I] := t_Fish.Create;
end;

procedure t_Layer.Work;
var
  I : Integer;
begin
  for I := 1 to 4 do
    Fish[I].Work;
end;

procedure t_Layer.Draw(A : Integer);
var
  I : Integer;
begin
  for I := 1 to 4 do
  with Gr[I] do
    SSprite_Draw(m_Gr, X, Y, 64, 512, $FF - A);
  for I := 1 to 4 do
    Fish[I].Draw;
end;

end.
 