unit u_Main;

interface
uses
  u_Game, u_Menu, u_MapEd, u_Records;

procedure m_Init;
procedure m_Work;
procedure m_Draw;
procedure m_Quit;
var
  Game : T_Game;
  Menu : T_Menu;
  MapEd : t_MapEd;
  Rec   : t_Recs;

implementation
uses
  GSound,
  OMEGA, u_Cursor, Intro, u_Material, u_SceneM;

procedure m_Init;
begin
  LoadMaterials;
  Rec   := t_Recs.Create;
  Curs := TCursor.Create;
  Main := TMain.Create;
  Game := T_Game.Create;
  Menu := T_Menu.Create;
  MapEd := t_MapEd.Create;
end;

procedure m_Work;
begin
  Curs.Work;
  if Main.MSWork then
  case Main.Scene of
    tg_intro  : Intro.Work;
    tg_menu   : Menu.Work;
    tg_game   : Game.Work;
    //tg_quit  = 0;
    tg_MapED  : MapEd.Work;
  end;

  DJ;
end;

procedure m_Draw;
begin
  case Main.Scene of
    tg_intro  : Intro.Draw;
    tg_menu   : Menu.Draw;
    tg_game   : Game.Draw;
    tg_MapED  : MapEd.Draw;
    //tg_quit  = 0;
  end;
  Curs.Draw;
  Main.Draw;

end;

procedure m_Quit;
begin

end;

end.
