unit u_MapEd;

interface
uses
  u_Map, u_Button;
type
  t_WiD = record
    T, M : Byte;
  end;

  t_MEButton = class (t_Button)
    WiD : t_WiD;
    procedure Draw;
  end;

  t_MapEd = class(t_Map)
    WiD : t_WiD;
    Level,
    A : Integer;
    MEB : array[1..8] of t_MEButton;
    Btn : array[1..4] of t_Button;

    OpD,
    New : Boolean;
    constructor Create;
    procedure Work;
    procedure Draw;
  end;

implementation
uses
  u_Cursor, u_Main, u_SceneM,
  Setup, LexUtils, Omega, u_Material, u_Size;

const
  BColor : array[1..2] of Integer = ($FFFFFF, $B0B0B0);

procedure t_MEButton.Draw;
begin
  Pr2D_Rect(X, Y, W, H, BColor[St], $A0, 1);
  SSPrite_Draw(m_Et[T, 1], X + 16, Y + 16, W - 32, H - 32);
  Pr2D_Rect(X, Y - 1, W + 1, H, $0, $A0, 0);
end;

const
  BCapt : array[1..4] of string = ('', '', '', '');

  WTs : array[1..8] of Integer = (2, 2, 2, 2, 2, 1, 3, 4);

constructor t_MapEd.Create;
var
  I : Integer;
begin
  for I := 1 to 8 do
  begin
    MEB[I] := t_MEButton.Create('', I, 20 + I * (c_TileS - 16), WinH - c_TileS + 20,
                                            c_TileS - 40, c_TileS - 40);

    MEB[I].WiD.M := I;
    MEB[I].WiD.T := WTs[I];
  end;

  for I := 1 to 4 do
  Btn[I] := t_Button.Create(BCapt[I], 0, 8,
                            WinH - c_TileS + 4 + (I - 1) * 31,
                            c_TileS - 16, 32, 0.5);
  New := True;
  OpD := False;
end;

procedure t_MapEd.Work;
var
  I, IX, IY : Integer;
begin
  if OpD then
  begin
    if Menu.M_Level.Work then
    begin
      OpD := False;
      if Menu.M_Level.Select > 0 then
      begin
        New := False;
        Level := Menu.M_Level.Select;
        Open(Menu.M_Level.LevelS[Level, 2]);
      end;
    end;
    Exit;
  end;

  for I := 1 to 8 do
  if MEB[I].Work then
    WiD := MEB[I].WiD;

  if Curs.RDown then
  begin
    WiD.T := 0;
    WiD.M := 0;
  end;

  if Omega.Mouse_Press(M_MBUTTON)
  or Omega.Key_Press(K_SPACE) then
  begin
    A := A + 90;
    NormAngle(A);
  end;

  if Curs.LPDown then
  begin
    IX := trunc(Curs.X / c_TileS);
    IY := trunc(Curs.Y / c_TileS);
    if  (IX >= 0) and (IX <= 7)
    and (IY >= 0) and (IY <= 4) then
    begin
      Tile[IX, IY].A := A;
      Tile[IX, IY].M := WiD.M;
      Tile[IX, IY].T := WiD.T;
    end;
  end;
  
  for I := 1 to 4 do
  if Btn[I].Work then
  case I of
    1 : begin
          New := True;
          for IX := 0 to 7 do
          for IY := 0 to 4 do
          with Tile[IX, IY] do
          begin
            A := 0;
            H := 0;
            M := 0;
            T := 0;
          end;
        end;
     2 : begin
           if New then
           begin
             New := False;
             Level := Menu.M_Level.Add;
           end;
           Save(Menu.M_Level.LevelS[Level, 2]);
         end;
     3 : OpD := True;
     4 : Main.SetScene(tg_Menu);
  end;
end;

procedure t_MapEd.Draw;
var
  I, IX, IY : Integer;
begin
  STile_Draw(m_W1, 0, 0, c_TileS, c_TileS, k_TileX, k_TileY );

  for IX := 0 to 7 do
  for IY := 0 to 4 do
  if Tile[IX, IY].M > 0 then
  SSPrite_Draw(m_Et[Tile[IX, IY].M, 1], IX * c_TileS,
                                        IY * c_TileS, c_TileS, c_TileS, $FF, Tile[IX, IY].A);

  for IX := 0 to 7 do
  for IY := 0 to 4 do
  begin
    Pr2D_Rect(IX * c_TileS, IY * c_TileS, c_TileS, c_TileS, $FFFFFF, $B0, 0);
    //Text_Draw(FontA1, IX * c_TileS, IY * c_TileS, PChar(Int2S(Tile[IX, IY].T)), 0.5, 0, 225, $FFFFFF);
  end;

  for I := 1 to 8 do
    MEB[I].Draw;

  for I := 1 to 4 do
    Btn[I].Draw;

  if WiD.M > 0 then
  with Curs do
    SSPrite_Draw(m_Et[WiD.M, 1], X, Y, c_TileS/2, c_TileS/2, 220, A);

  if OpD then
    Menu.M_Level.Draw
end;

end.
