unit u_Material;

interface
uses
  LexUtils, OMEGA;

const
  MofTile = 19;
  MBtnColor : array[1..2] of Integer = ( 4534032, 15568643);
  
var
// :
  FontA1  : Omega.PFONT2D;
// :
  T_Cur   : PTexture;
//
  m_Board,
  m_W1,
  m_W2,
  m_Line,
  m_Fish,
  m_Gr,
  m_Logo,
  m_PName  : PTexture;
  m_Cone   : array[1..4, 1..2] of PTexture;
  m_Button : array[1..2] of PTexture;
  m_Et : array[1..8, 1..2] of PTexture;

  
procedure LoadMaterials;
function  TextureO_Load(Texture_Name : string; Mask_Name : string = '') : PTexture;

implementation

function  TextureO_Load;
begin
  if Mask_Name = '' then
    Result := Tex_LoadFromFile(PChar('Data\' + Texture_Name), -1, TEX_DEFAULT_2D)
  else
  begin
    Tex_LoadMaskFromFile(PChar('Data\' + Mask_Name));
    Result := Tex_LoadFromFile(PChar('Data\' + Texture_Name), -1, TEX_DEFAULT_2D or TEX_USEMASK);
    Tex_FreeMask;
  end;
end;

procedure LoadMaterials;
const
  F = TEX_DEFAULT_2D or TEX_USEMASK;
var
  I, J : Integer;
  S : String;
begin
  // :
  //____________________________________________________________________________
  // - :
  Tex_LoadMaskFromFile(PChar('Data\Font2.GIF'));
  FontA1  := Text_LoadFontFromFile( 'Data\w_1024.GIF', 'Data\Font2.OFI', -1, F);
  //____________________________________________________________________________
  // - :
  T_Cur   := TextureO_Load('Cur.JPG','Cur_M.JPG');
  //____________________________________________________________________________
  m_Logo  := TextureO_Load('Logo.JPG','Logo_m.JPG');
  m_PName  := TextureO_Load('Name.GIF','Name_m.GIF');
  //____________________________________________________________________________

  m_Fish  := TextureO_Load('Fish.GIF', 'Fish_m.GIF');
  m_Gr    := TextureO_Load('gr.GIF', 'gr_m.GIF');
  m_Line  := TextureO_Load('Line.GIF');

  m_W1    := TextureO_Load('W1.GIF');
  m_W2    := TextureO_Load('W2.GIF');

  m_Et[1, 1] := TextureO_Load('Et_1.GIF');
  m_Et[1, 2] := TextureO_Load('b_128.GIF');

  for I := 2 to 7 do
  begin
    S := 'Et_' + Int2S(I);
    m_Et[I, 1] := TextureO_Load(S + '.GIF',  S + '_m.GIF');
    m_Et[I, 2] := TextureO_Load('b_128.GIF', S + '_m.GIF');
  end;
  S := 'Et_8';

  m_Et[8, 1] := TextureO_Load(S + '.GIF',  S + '_m.GIF');
  m_Et[8, 2] := TextureO_Load(S + '_b.GIF', S + '_m.GIF');

  m_Button[1] := TextureO_Load('bt.JPG', 'bt_m.JPG');
  m_Button[2] := TextureO_Load('bt_g.JPG', 'bt_g_m.JPG');

  for I := 1 to 4 do
  begin
    S := 'cone_' + Int2S(I);
    m_Cone[I, 1] := TextureO_Load(S + '.JPG',  S + '_m.JPG');
    m_Cone[I, 2] := TextureO_Load(S +'_g.JPG', S + '_m.JPG');
  end;
  m_Board := TextureO_Load('Board.JPG', 'Board_m.JPG');
end;

end.
