unit u_Menu;

interface
uses
  LexUtils, u_Button, u_Fish,
  u_Menu_Name, u_Menu_I, u_Menu_Level;

type
  T_MenuButton = class(T_Button)
    procedure Draw;
  end;

  T_Menu = class
    S : Integer;
    M_Name  : T_M_Name;
    M_I     : T_M_I;
    M_Level : T_M_Level;
    //_________________
    Button : array[1..7] of T_MenuButton;

    Layer : array[1..7] of t_Layer;
    constructor Create;
    procedure Work;
    procedure Draw;
    
  end;

implementation
uses
  Omega,  u_Size, u_SceneM, u_Main, u_Material, Setup;

procedure T_MenuButton.Draw;
begin
  Text_Draw(FontA1, TX, TY, PChar(S), 0.7, 0, 225, MBtnColor[ST]);
end;

var
  SN_Btn : array[1..7] of string = ('', '', '', '',
                                    '', '', '');

constructor T_Menu.Create;
var
  I : Integer;
begin
  M_Name  := T_M_Name.Create;
  M_I     := T_M_I.Create;
  M_Level := T_M_Level.Create;
  S := 1;

  for I := 1 to 7 do
    Button[I] := T_MenuButton.Create(SN_Btn[I], 0, (WinW - 180) / 2, WinH / 2.5 + 36 * I, 180, 32);

  for I := 1 to 7 do
    Layer[I] := t_LAyer.Create(I);  
end;

const
  c_m_Game   = 1;
  c_m_Level  = 2;
  c_m_Name   = 3;
  c_m_Rec    = 4;
  c_m_Editor = 5;
  c_m_I      = 6;
  c_m_Exit   = 7;


procedure T_Menu.Work;
var
  I : Integer;
begin
  for I := 1 to 7 do
    Layer[I].Work;

  case S of
    c_m_Name : M_Name.Work;
    c_m_I    : M_I.Work;
    c_m_Level : if M_Level.Work then
                begin
                  S := 0;
                  if M_Level.Select > 0 then
                    Game.Start(M_Level.Select);
                end;
    c_m_Rec   : Rec.Work;
  else
    begin
      for I := 1 to 7 do
      if Button[I].Work then
      begin
        case I of
          c_m_Game   : Game.Start(1);
          c_m_Editor : Main.SetScene(tg_MapEd);
          c_m_Exit   : OE_Quit;
          c_m_Rec    : begin
                         Rec.Lev := 1;
                         Rec.LoadTRec(M_Level.LevelS[1, 2]);
                       end;
         end;
          S := I;
      end;
    end;
  end;
end;

procedure T_Menu.Draw;
var
  I : Integer;
begin
  STile_Draw(m_Line, 0, 0, 32, WinH, k_mTile, 1);
  for I := 1 to 7 do
    Layer[I].Draw(7 * 4 - I * 4);

  case S of
    c_m_Name : M_Name.Draw;
    c_m_I : M_I.Draw;
    c_m_Level : M_Level.Draw;
    c_m_Rec   : Rec.Draw;
  else
    begin
      Pr2D_Rect(WinW div 2 - 91, trunc(WinH / 2.5) + 1, 182, 340, $FFFFFF, $E5, 1);
      Pr2D_Rect(WinW div 2 - 90, trunc(WinH / 2.5),     182, 340, $000010, $EF, 0);
      SSprite_Draw(m_PName, (WinW - 612) / 2, WinH / 2.5 - 140, 612, 128);
      //SSprite_Draw(m_menu, (WinW - 256) / 2, WinH / 2.5 - 20, 256, 256);
      for I := 1 to 7 do
        Button[I].Draw;
    end;
  end;
end;

end.
