unit u_Menu_Level;

interface
uses
  LexUtils, u_Button;

const
  c_List = 9;
type
  T_LevelButton = class(T_Button)
    LevelN : Integer;
    Text : array[1..2] of String;
    procedure Draw;
  end;

  T_M_Level = class
    NP, P, Sz : TM2DREalPoint;
    Button  : array[1..3] of T_Button;
    LB      : array[1..c_List] of T_LevelButton;
    LevelS  : array of array[1..3] of string;
    MofLevel : Integer;

    Select,
    SListLevel,
    EListLevel : Integer;

    constructor Create;
    procedure Draw;
    function  Work : Boolean;
    procedure List(D : Integer);
    procedure Load;
    procedure Save;
    function  Add : Integer;
  end;

implementation
uses
  Setup, Omega, u_Material, u_Main;
var
  STX     : array[1..2] of Single;

procedure T_LevelButton.Draw;
begin
  Text_Draw(FontA1, STX[1], TY, PChar(Text[1]), ifS, 0, 225, MBtnColor[ST]);
  Text_Draw(FontA1, STX[2], TY, PChar(Text[2]), ifS, 0, 225, MBtnColor[ST]);
end;

const
  c_Btn : array[1..3] of string = ('', '', '');
  x_Btn : array[1..3] of Single =(- 100 * 3, -100, 100);
  c_Name = ' ';

constructor T_M_Level.Create;
var
  I : Integer;
begin
  Sz.X := 620;
  Sz.Y := 512;

  P.X := (WinW - Sz.X) / 2;
  P.Y := (WinH - Sz.Y) / 2;

  NP.X := (WinW - Text_GetWidth(FontA1, PChar(c_Name), 0.8)) / 2;
  NP.Y := P.Y + 32;

  STX[1] := P.X + 40;
  STX[2] := P.X + Sz.X - 225;

  for I := 1 to c_List do
  LB[I] := T_LevelButton.Create('', I, STX[1], P.Y + 86 + 32 * I, Sz.X - 100, 28, 0.6);

  for I := 1 to 3 do
  Button[I] := T_Button.Create(c_Btn[I], 0, P.X + Sz.X / 2 + x_Btn[I] + 20,
                                            P.Y + Sz.Y - 54, 160, 46, 0.5);
  if FileEx('Maps\Maps.TXT') then
    Load
  else
  begin
    SetLength(LevelS, 1);
    Save;
  end;
  List(1);
end;

procedure T_M_Level.Draw;
var
  I : Integer;
begin
  Pr2D_Rect(P.X, P.Y,     Sz.X, Sz.Y, $FFFFFF, $E5, 1);
  Pr2D_Rect(P.X, P.Y - 1, Sz.X + 1, Sz.Y, $000010, $EF, 0);

  Text_Draw(FontA1, NP.X, NP.Y, PChar(c_Name), 0.8, 0, 225, MBtnColor[2]);

  Text_Draw(FontA1, STX[1] + 50, NP.Y + 48, PChar(''), 0.5, 0, 225, MBtnColor[1]);
  Text_Draw(FontA1, STX[2] + 50, NP.Y + 48, PChar(''), 0.5, 0, 225, MBtnColor[1]);


  for I := 1 to c_List do
    LB[I].Draw;
    
  for I := 1 to 3 do
    Button[I].Draw;
end;

function T_M_Level.Work : Boolean;
var
  I : Integer;
begin
  Result := False;
  Select := -1;

  for I := 1 to c_List do
  if  (LB[I].LevelN > 0)
  and (LB[I].Work) then
  begin
    Select := LB[I].LevelN;
    Result := True;
  end;

  for I := 1 to 3 do
  if Button[I].Work then
  case I of
    1 : if SListLevel > 1 then
          List(SListLevel - 1);
    2 : List(SListLevel + 1);
    3 : Result := True;
  end;

end;

procedure T_M_Level.List(D : Integer);
var
  I, L : Integer;
begin
  SListLevel := D;
  EListLevel := SListLevel + c_List - 1;
  if EListLevel > MofLevel then
    EListLevel := MofLevel;

  L := 1;
  for I := SListLevel to EListLevel do
  begin
    LB[L].Text[1] := Int2S(I) + ') ' +LevelS[I, 1];
    LB[L].Text[2] := LevelS[I, 3];
    LB[L].LevelN := I;
    Inc(L);
  end;

  for I := L to c_List do
  with LB[I] do
  begin
   Text[1] := '';
   Text[2] := '';
   LevelN  := -1;
  end;
end;

procedure T_M_Level.Load;
var
  F : TextFile;
  I : Integer;
  S, S2 : string;
begin
  AssignFile(F, 'Maps\Maps.TXT');
  Reset(F);
  SetLength(LevelS, 1);
  while not EoF(F) do
  begin
    Readln(F, S);
    Readln(F, S2);
    {if FileEx(S2) then
    begin    }
      I := Length(LevelS);
      SetLength(LevelS, I + 1);
      LevelS[I, 1] := S;
      LevelS[I, 2] := S2;
      Rec.LoadTRec(LevelS[I, 2]);
      LevelS[I, 3] := Int2S(Rec.RecTable.R[1].P ) + '  (' +
                            Rec.RecTable.R[1].N + ')';
    {end; }
  end;
  CloseFile(F);
  MofLevel := Length(LevelS) - 1;
end;

procedure T_M_Level.Save;
var
  F : TextFile;
  I : Integer;
begin
  AssignFile(F, 'Maps\Maps.TXT');
  Rewrite(F);
  for I := 1 to MofLevel do
  begin
    Writeln(F, LevelS[I, 1]);
    Writeln(F, LevelS[I, 2]);
  end;
  CloseFile(F);
  
end;

function T_M_Level.Add : Integer;
var
  I : Integer;
begin
  I := Length(LevelS);
  SetLength(LevelS, I + 1);
  LevelS[I, 1] := ' ' + Int2S(I);
  LevelS[I, 2] := Int2S(I) + '.map';
  MofLevel := I;
  Save;
  Result := I;
  List(1);
end;

end.
