unit u_Ship;

interface
uses
  LexUtils;

type
  t_Ship = record
    MP, P : TM2DRealPoint;
    MA, A, DA : Single;
    MEP, EP : TM2DPoint;
    Move : Boolean;
  end;

procedure ShipWork(var Ship : t_Ship);
procedure ShipMove(var Ship : t_Ship; pX, pY : Integer);

implementation
uses
  u_Size, u_Main;

procedure ShipWork(var Ship : t_Ship);
begin
   with Ship do
   begin
        if Move then
        begin
          M2DPoint_App(P, MP);
            if MP.X > 0.1 then
            MP.X := MP.X - 0.001
          else
          if MP.X < 0.1 then
            MP.X := MP.X + 0.001;

          if  (    ((MP.X > 0) and (P.X >= MEP.X * c_TileS))
              or ((MP.X < 0) and (P.X <= MEP.X * c_TileS))
              or (MP.X = 0))
          and (    ((MP.Y > 0) and (P.Y >= MEP.Y * c_TileS))
              or ((MP.Y < 0) and (P.Y <= MEP.Y * c_TileS))
              or (MP.Y = 0)) then
          begin
            Move := False;
            EP := MEP;
            P.X := EP.X * c_TileS ;
            P.Y := EP.Y * c_TileS;
          end;
        end;

    if MA > 1 then
      MA := MA - 1
    else
    if MA < -1 then
      MA := MA + 1;
  end;
end;

procedure ShipMove(var Ship : t_Ship; pX, pY : Integer);

  function Move2(Ship : t_Ship) : Boolean;
  var
    J : Integer;
  begin
      with Ship do
      if  (EP.X + pX <= 7)
      and (EP.Y + pY <= 4)
      and (EP.X + pX >= 0)
      and (EP.Y + pY >= 0)
      and (Game.Map.Tile[EP.X + pX, EP.Y + pY].T < 2) then
      begin
        Result := True;
       for J := 0 to Length(Game.Map.Ship) - 1 do
        if  (EP.X + pX = Game.Map.Ship[J].EP.X)
        and (EP.Y + pY = Game.Map.Ship[J].EP.Y)
        and (not Move2(Game.Map.Ship[J])) then
        begin
          Result := False;
          Exit;
        end;
        for J := 0 to Length(Game.Map.Bord) - 1 do
        if  (EP.X + pX = Game.Map.Bord[J].EP.X)
        and (EP.Y + pY = Game.Map.Bord[J].EP.Y)
        and (not Move2(Game.Map.Bord[J])) then
        begin
          Result := False;
          Exit;
        end;
      end
      else
        Result := False;
      //Result := True;
    end;
begin
  with Ship do
  begin
    if Move2(Ship) then
    begin
      MEP.X := EP.X + pX;
      MEP.Y := EP.Y + pY;
      MP.X := pX * 5;
      MP.Y := pY * 5;
      Move := True;

      case pX of
        -1 : dA := 90;
         1 : dA := -90;
      else
        case pY of
        -1 : dA := 180;
         1 : dA := 0;
      end;
      end;
    end
    else
    begin
    //  Map.Tile[EP.X + X, EP.Y + Y].T := 3;
      MEP := EP;
    end;
  end;
end;

end.
