unit main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, DXDraws, DXClass, DXSprite, StdCtrls, u_var, u_str, u_ai, Bass, ExtCtrls,
  Buttons, ComCtrls;

type
  TMainForm = class(TForm)
    Scr: TDXDraw;
    DXSpriteEngine: TDXSpriteEngine;
    DXTimer: TDXTimer;
    DXImageList: TDXImageList;
    BattlePanel: TPanel;
    GridCheckBox: TCheckBox;
    BitBtnUp: TBitBtn;
    BitBtnLeft: TBitBtn;
    BitBtnRight: TBitBtn;
    BitBtnDown: TBitBtn;
    BitBtnFire: TBitBtn;
    BitBtnCenter: TBitBtn;
    BitBtnSides: TBitBtn;
    BitBtnTurnL: TBitBtn;
    BitBtnTurnR: TBitBtn;
    StartPanel: TPanel;
    LevelPanel: TPanel;
    FinPanel: TPanel;
    BitBtnStart: TBitBtn;
    BitBtnLevelStart: TBitBtn;
    LabelLvl: TLabel;
    SpeedTrackBar: TTrackBar;
    SpeesLabel: TLabel;
    VolLabel: TLabel;
    VolTrackBar: TTrackBar;
    DXBgList: TDXImageList;
    procedure DXTimerTimer(Sender: TObject; LagCount: Integer);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure BitBtnStartClick(Sender: TObject);
    procedure BitBtnLevelStartClick(Sender: TObject);
    procedure BitBtnFireClick(Sender: TObject);
    procedure BitBtnUpClick(Sender: TObject);
    procedure BitBtnLeftClick(Sender: TObject);
    procedure BitBtnRightClick(Sender: TObject);
    procedure BitBtnDownClick(Sender: TObject);
    procedure BitBtnCenterClick(Sender: TObject);
    procedure BitBtnSidesClick(Sender: TObject);
    procedure BitBtnTurnLClick(Sender: TObject);
    procedure BitBtnTurnRClick(Sender: TObject);
    procedure SpeedTrackBarChange(Sender: TObject);
    procedure VolTrackBarChange(Sender: TObject);
    procedure EnableButtons(bool:boolean);
  private
    procedure ShowHP(n:integer);

  public
  end;

var
  MainForm: TMainForm;

type
 TBackground = class (TBackgroundsprite)
   public
    constructor Create(AParent: TSprite; n:integer);
    procedure DoMove(MoveCount: Integer); override;
    destructor Destroy; override;
   end;

 TExp = class(TImageSprite)
   public
    Xs,Ys:     real;     // center of sprite
    Kind:      integer;
    constructor Create(AParent: TSprite; xc,yc:integer);
    procedure DoMove(MoveCount: Integer); override;
    destructor Destroy; override;
   end;


 TRobot = class(TImageSpriteEx)
   public
     ID:        integer;
     Kind:      integer;  // 1..7-player 9..$F-enemy
     Xs,Ys:     real;     // center of sprite
     PosX,PosY: integer;  // destination center
     PosXc,PosYc: integer;// destination field
     oldXc,oldYc,Xc,Yc:     integer;
     dAngle:     integer;  // 0-up 64-right 128-down 192-left
     speed:     integer;   // max = 15
     hp,hpp:    integer;
     constructor Create(AParent: TSprite; _xc, _yc, _kind, _Angle: integer; Desc:TRobotDesc);
     destructor  Destroy; override;
     procedure   DoMove(MoveCount: Integer); override;
     procedure   Dead;
     procedure   Send(Px,Py:integer);
   end;

 TBullet = class(TImageSpriteEx)
   public
     ID:        integer;
     Kind:      integer;
     RobNum:    integer;
     Xs,Ys:     real;
     PosX,PosY: integer;
     PosXc,PosYc: integer;
     oldXc,oldYc,Xc,Yc:     integer;
     dAngle:     integer;
     Speed:     integer;
     Power:     integer;
     constructor Create(AParent: TSprite; _kind, dAngle: integer; Desc:TBulletDesc; _Robot:TRobot; TargetX,TargetY: integer);
     destructor  Destroy; override;
     procedure   DoMove(MoveCount: Integer); override;
     procedure   Send(Px,Py:integer);
   end;


var
 bgBitmap:      Graphics.TBitmap;
 hSound:        array [1..3] of HSAMPLE;
 hBass:         array [1..MaxRobot+1] of HCHANNEL;
 hBassMusic:    HSTREAM;
 Robot:         array [1..MaxRobot] of TRobot;
 Bg:            TBackground;

implementation



{$R *.dfm}


procedure LoadSound;
var
 i:integer;
begin
 for i:=1 to 3 do
  hSound[i]:=BASS_SampleLoad(FALSE,PChar('sound/'+itos(i)+'.wav'),0,0,MaxRobot+1,BASS_SAMPLE_OVER_POS);
end;

procedure Play(fn:integer;n,vol: integer);
begin
 if n>MaxRobot+1 then Exit;
 if Bass_channelIsActive(hBass[n])=BASS_ACTIVE_PLAYING then Exit;
// BASS_ChannelStop(hBass[n]);
 hBass[n]:=BASS_SampleGetChannel(hSound[fn],TRUE);
// hBass[n]:=BASS_StreamCreateFile(FALSE,PChar('sound/'+itos(fn)+'.wav'),0,0,BASS_STREAM_AUTOFREE);
 BASS_ChannelSetAttributes(hBass[n],0,vol,0);
 BASS_ChannelPlay(hBass[n],true);
end;

procedure ChangeMusic(nums:string);
begin
 Bass_ChannelStop(hBassMusic);
 hBassMusic:=BASS_MusicLoad(FALSE,PChar('sound/'+nums+'.xm'),0,0,BASS_MUSIC_AUTOFREE or BASS_MUSIC_SURROUND or BASS_SAMPLE_LOOP,0);
 BASS_MusicSetAttribute(hBassMusic,BASS_MUSIC_ATTRIB_VOL_CHAN,optMusicVol);
 BASS_ChannelPlay(hBassMusic,true);
end;

{ TBackground }

constructor TBackground.Create(AParent: TSprite;n:integer);
begin
 inherited Create(AParent);
 image := MainForm.DXBgList.Items[(n-1) mod 16];// .Find('bg');
 image.Transparent:=FALSE;
 Z := -1;
 SetMapSize(1,1);
 Tile := false;
end;

destructor TBackground.Destroy;
begin
 inherited Destroy;
end;

procedure TBackground.DoMove(MoveCount: Integer);
begin
 inherited DoMove(MoveCount);
end;

{procedure LoadOneBG;
var
 i,j,k,w,h: integer;
 bmp:      Graphics.TBitmap;
begin
 bgBitmap:=Graphics.TBitmap.Create;
 bgBitmap.Width:=MainForm.Scr.Width;
 bgBitmap.Height:=MainForm.Scr.Height;
 bgBitmap.Canvas.Brush.Style:=bsSolid;
 bgBitmap.Canvas.Brush.Color:=$20B860;
 bgBitmap.Canvas.FloodFill(1,1,clBlue,fsBorder);
 bmp:=Graphics.TBitmap.Create;
 bmp.Width:=16;
 bmp.Height:=16;
 w := bgBitmap.Width div 16;
 h := bgBitmap.Height div 16;
 for i:=1 to (w div 2) do
  for j:=1 to (h div 2) do
   begin
    k:=random(50);
    k:=k div 10+1;
    bmp.LoadFromFile('images/bgt'+itos(k)+'.bmp');
    bgBitmap.Canvas.Draw((i-1)*32+random(32),(j-1)*32+random(32),bmp);
   end;
  bmp.Free;
  MainForm.DXBgList.Items.Clear;
  MainForm.DXBgList.Items.Add;
  MainForm.DXBgList.Items[MainForm.DXbgList.Items.Count-1].Picture.Assign(bgBitmap);
  MainForm.DXBgList.Items[MainForm.DXbgList.Items.Count-1].Name:='bg';
end;}

procedure LoadMaps;
var
 f: file of smallint;
 a: smallint;
 i,j,k: integer;
begin
 for k:=1 to 16 do
  begin
   assignfile(f,'LEVELS\'+itos(k)+'.lvl');
   reset(f);
   for i:=1 to BattleFieldW do
    for j:=1 to BattleFieldH do
     begin
      read(f,AllMaps[k][i,j]);
     end;
   closefile(f);
  end;


end;

procedure LoadBG;
var
 m,i,j,k,w,h: integer;
 bmp:      Graphics.TBitmap;
begin
 bgBitmap:=Graphics.TBitmap.Create;
 bgBitmap.Width:=MainForm.Scr.Width;
 bgBitmap.Height:=MainForm.Scr.Height;
 for m:=1 to 16 do
 begin
 bgBitmap.Canvas.Brush.Style:=bsSolid;
 bgBitmap.Canvas.Brush.Color:=$20B860;
 bgBitmap.Canvas.FloodFill(1,1,clBlue,fsBorder);
 bmp:=Graphics.TBitmap.Create;
 bmp.Width:=16;
 bmp.Height:=16;
 w := bgBitmap.Width div 16;
 h := bgBitmap.Height div 16;

 for i:=1 to (w div 2) do
  for j:=1 to (h div 2) do
   begin
    k:=random(50);
    k:=k div 10+1;
    bmp.LoadFromFile('images/bgt'+itos(k)+'.bmp');
    bgBitmap.Canvas.Draw((i-1)*32+random(32),(j-1)*32+random(32),bmp);
   end;

  bmp.Width:=32;
  bmp.Height:=32;
  bmp.LoadFromFile('images/bgx2.bmp');

  for i:=1 to BattleFieldW do
   for j:=1 to BattleFieldH do
    if AllMaps[m][i,j]=$A0 then
     begin
      bgBitmap.Canvas.Draw((i-1)*SquareSize,(j-1)*SquareSize,bmp);
     end;


  bmp.Free;

  MainForm.DXBgList.Items[m-1].Picture.Assign(bgBitmap);
 end;
end;




{ TRobot }

constructor TRobot.Create(AParent: TSprite; _xc, _yc, _kind,_Angle: integer; Desc:TRobotDesc);
begin
 inherited Create(AParent);
 inc(RobotCounter);
 ID:=RobotCounter;
 r[RobotCounter]:=ID;
 kind:=_kind;
 inc(PlayerCounter[kind div 8]);
 xc:=_xc;
 yc:=_yc;
 Image := MainForm.DXImageList.Items.Find('tank'+itos(kind)+'_up');
 Width := Image.Width;
 Height := Image.Height;
 AnimPos:=0;
 AnimCount:=Image.PatternCount;
 AnimLooped:=TRUE;
 AnimSpeed:=0;
 dAngle:=_Angle;
 Angle:=_Angle;
 PixelCheck:=FALSE;
 Xs := xc*SquareSize-(SquareSize div 2);
 Ys := yc*SquareSize-(SquareSize div 2);
 X:=Xs-(Width div 2);
 Y:=Ys-(Height div 2);
 Z:=1;
 PosXc:=xc;
 PosYc:=yc;
 oldXc:=xc;
 oldYc:=yc;
 PosX:=trunc(Xs);
 PosY:=trunc(Ys);
 Speed:=0;
 hp:=dRobot[kind]._hp;
 hpp:=dRobot[kind]._hp;
 Map[xc,yc]:=(Map[xc,yc] div $100)*$100+$80+kind;
end;


destructor TRobot.Destroy;
var
 i,n:integer;
begin
  n:=1;
  while (r[n]<>ID) and (r[n]<>0) do inc(n);
  if r[n]=ID then
   begin
    for i:=n to RobotCounter-1 do
     r[i]:=r[i+1];
    r[RobotCounter]:=0;
    dec(RobotCounter);
   end;
  inherited Destroy;
end;

procedure TRobot.DoMove(MoveCount: Integer);
begin

  inherited DoMove(MoveCount);


   if not eps(PosX,Xs,speed){(PosX<>X)} then
    begin
     Speed:=dRobot[Kind]._speed;//*gamespeed;
     if (trunc(Xs)>PosX) then
      begin Xs:=Xs-Speed; dAngle:=192 end
      else begin Xs:=Xs+Speed; dAngle:=64 end;
    end;

   if not eps(PosY,Ys,speed) {(PosY<>Y)}then
    begin
     Speed:=dRobot[Kind]._speed;//*gamespeed;
     if trunc(Ys)>PosY then
      begin Ys:=Ys-Speed; dAngle:=0 end
      else begin Ys:=Ys+Speed; dAngle:=128 end;
    end;

   if speed<>0 then
    begin
     AnimSpeed:=1/5;
     Play(1,ID,50);
     xc:=trunc(Xs / SquareSize)+1;
     yc:=trunc(Ys / SquareSize)+1;
     if (Xc<>OldXc) or (yc<>OldYc) then
      begin
       Map[oldxc,oldyc]:=(Map[oldxc,oldyc] div $100)*$100;
       if (xc in [1..BattlefieldW])
        and (yc in [1..BattlefieldH])
         then Map[xc,yc]:=(Map[xc,yc] div $100)*$100+$80+kind;
       oldxc:=xc; oldyc:=yc;
      end;
    end;


   if eps(PosX,Xs,speed) and eps(PosY,Ys,speed) then
    begin
     Bass_Channelstop(hBass[ID]);
     AnimSpeed:=0;
     speed:=0;
    end;

  Angle:=dAngle;
  X:=Xs-(Width div 2);
  Y:=Ys-(Height div 2);

  if hpp<=0 then
   begin
    Play(3,ID,100);
    Dead;
    TExp.Create(MainForm.DXSpriteEngine.Engine,xc,yc);
   end;

end;

procedure TRobot.Send(Px, Py: integer);
begin
 if (Map[Px,Py] mod $100)<$80 then
  begin
   PosXc:=Px;
   PosYc:=Py;
   PosX := PosXc*SquareSize-(SquareSize div 2);
   PosY := PosYc*SquareSize-(SquareSize div 2);
   Map[Px,Py]:=(Map[Px,Py] div $100)*100+$90+kind;
  end;
end;

procedure TMainForm.ShowHp(n:integer);
var
 a,b,d:integer;
begin
 d:=round(30*Robot[r[n]].hpp/Robot[r[n]].hp);
 if d<0 then d:=0;
 a:=0; b:=0;
 if (Robot[r[n]].Yc=1) then a:=10;
 if (Robot[r[n]].Xc=BattleFieldW) then b:=-20;
 with Scr.Surface.Canvas do
  begin
   brush.Style:=bsSolid;
   brush.Color:=clRed;
   rectangle(round(Robot[r[n]].X+20+b),round(Robot[r[n]].Y+a),round(Robot[r[n]].X+50+b),round(Robot[r[n]].Y+5+a));
   brush.Color:=clLime;
   rectangle(round(Robot[r[n]].X+20+b),round(Robot[r[n]].Y+a),round(Robot[r[n]].X+20+d+b),round(Robot[r[n]].Y+5+a));
  end;
end;

procedure TRobot.Dead;
begin
 Map[xc,yc]:=(Map[xc,yc] div $100)*$100;
 dec(PlayerCounter[kind div 8]);
 inherited Dead;
end;


{ TBullet }

constructor TBullet.Create(AParent: TSprite; _Kind, dAngle: integer; Desc:TBulletDesc; _Robot:TRobot; TargetX,TargetY: integer);
begin
 inherited Create(AParent);
 inc(BulletCounter);
 ID:=BulletCounter;
 kind:=_kind;
 Image := MainForm.DXImageList.Items.Find('missle'+itos(kind)+'_up');
 Width := Image.Width;
 Height := Image.Height;
 AnimPos:=0;
 AnimCount:=Image.PatternCount;
 AnimLooped:=TRUE;
 AnimSpeed:=1/5;
 PixelCheck:=FALSE;
 RobNum:=_Robot.ID;
 xc:=_Robot.Xc;
 yc:=_Robot.Yc;
 Xs := Xc*SquareSize-(SquareSize div 2);
 Ys := Yc*SquareSize-(SquareSize div 2);
 X:=Xs-(Width div 2);
 Y:=Ys-(Height div 2);
 Z:=2;
 PosXc:=xc;
 PosYc:=yc;
 PosX:=trunc(Xs);
 PosY:=trunc(Ys);
 Speed:=dBullet[kind]._speed;//*gamespeed;
 Power:=dBullet[kind]._power;
{ Map[xc,yc]:=(Map[xc,yc] div $100)*$100+$70+kind;}
 case dAngle of
  0:    Send(xc,-1);
  64:   Send(BattleFieldW+2,yc);
  128:  Send(xc,BattleFieldH+2);
  192:  Send(-1,yc);
 end;
// Send(TargetX,TargetY);
 Play(2,MaxRobot+1,100);
end;

destructor TBullet.Destroy;
begin
  inherited Destroy;
end;

procedure TBullet.DoMove(MoveCount: Integer);
var
 i:integer;
 procedure MakebMap;
  var
   i,j,dx,dy:integer;
  begin
   dx:=dA(dAngle).X; dy:=dA(dAngle).Y;
   bMap[oldXc,oldYc]:=FALSE;
   i:=xc; j:=yc;
   while (i in [1..BattleFieldW]) and (j in [1..BattleFieldH]) and ((Map[i,j] mod $100)=0) do
    begin
     bMap[i,j]:=TRUE;
     i:=i+dx;     j:=j+dy;
    end;
    bMap[i,j]:=TRUE;
  end;
begin
  inherited DoMove(MoveCount);

   if not eps(PosX,Xs,speed) then
    begin
     Speed:=dBullet[kind]._speed;//*gamespeed;
     if (trunc(Xs)>PosX) then
      begin Xs:=Xs-speed; dAngle:=192 end
      else begin Xs:=Xs+speed; dAngle:=64 end;
    end;

   if not eps(PosY,Ys,speed) then
    begin
     Speed:=dBullet[kind]._speed;//*gamespeed;
     if trunc(Ys)>PosY then
      begin Ys:=Ys-speed; dAngle:=0 end
      else begin Ys:=Ys+speed; dAngle:=128 end;
    end;

   if speed<>0 then
    begin
     AnimSpeed:=1/5;
     xc:=trunc(Xs / SquareSize)+1;
     yc:=trunc(Ys / SquareSize)+1;
     if (Xc<>OldXc) or (yc<>OldYc) then
      begin
       {Map[oldxc,oldyc]:=(Map[oldxc,oldyc] div $100)*$100;
        if (xc in [1..BattlefieldW])
        and (yc in [1..BattlefieldH])
         then Map[xc,yc]:=(Map[xc,yc] div $100)*$100+$70+kind;}
       MakebMap;
       oldxc:=xc; oldyc:=yc;
       if ((Map[xc,yc] div $10) mod $10) = $8  then
        begin
         for i:=1 to RobotCounter do
          if (RobNum<>Robot[r[i]].ID) and(Robot[r[i]].Xc=xc) and (Robot[r[i]].Yc=yc) then
           begin
            Dead;
            Robot[r[i]].hpp:=Robot[r[i]].hpp-Power;
            bMap[xc,yc]:=FALSE;
            break;
           end;
        end;

      end;
    end;


   if eps(PosX,Xs,speed) and eps(PosY,Ys,speed) then
    begin
     AnimSpeed:=0;
     speed:=0;
    end;

   Angle:=dAngle;
   X:=Xs-(Width div 2);
   Y:=Ys-(Height div 2);

   if (Xc<0) or (Yc<0) or (Xc>BattlefieldW) or (Yc>BattlefieldH) then Dead;
end;

procedure TBullet.Send(Px, Py: integer);
begin
 PosXc:=Px;
 PosYc:=Py;
 PosX := PosXc*SquareSize-(SquareSize div 2);
 PosY := PosYc*SquareSize-(SquareSize div 2);
end;

{ TExp }

constructor TExp.Create(AParent: TSprite; xc,yc:integer);
begin
 inherited Create(AParent);
 Image := MainForm.DXImageList.Items.Find('explode');
 Width := Image.Width;
 Height := Image.Height;
 AnimPos:=0;
 AnimCount:=Image.PatternCount;
 AnimLooped:=FALSE;
 AnimSpeed:=1/5;
 PixelCheck:=FALSE;
 Xs := Xc*SquareSize-(SquareSize div 2);
 Ys := Yc*SquareSize-(SquareSize div 2);
 X:=Xs-(Width div 2);
 Y:=Ys-(Height div 2);
end;

destructor TExp.Destroy;
begin
  inherited Destroy;
end;

procedure TExp.DoMove(MoveCount: Integer);
begin
  inherited DoMove(MoveCount);
  if AnimPos=AnimCount-1 then Dead;
end;

{***end of TSprite***}

procedure FreebMap;
var
 i,j:integer;
begin
 for i:=0 to BattlefieldW+1 do
  for j:=0 to BattlefieldH+1 do
   bMap[i,j]:=FALSE;
end;


procedure LoadMap(lvl:integer);
var
 i,j:integer;
begin
 FreebMap;

 for i:=1 to BattlefieldW do
  for j:=1 to BattlefieldH do
   Map[i,j]:=AllMaps[(lvl-1) mod 16 + 1][i,j];

 for i:=0 to BattlefieldW+1 do
  begin
   Map[i,0]:=$f0; Map[i,BattlefieldH+1]:=$f0;
  end;
 for j:=0 to BattlefieldH+1 do
  begin
   Map[0,j]:=$f0; Map[BattlefieldW+1,j]:=$f0;
  end;
end;

procedure StartLevel(lvl:integer);
var
 i,j,k,x,y,rn,rang,l,extra:integer;
begin
// LoadOneBG;
 wins:=FALSE;
 loses:=FALSE;
 glTime:=0;
 for i:=0 to 1 do
  PlayerCounter[i]:=0;

 RobotCounter:=0;
 BulletCounter:=0;


 LoadMap(lvl);
 for i:=1 to MaxRobot do r[i]:=0;

 bg:=TBackground.Create(MainForm.DXSpriteEngine.Engine,lvl);
 gs:=gsBattle;

 if lvl>2 then i:=random(5) else i:=random(4)+1;
 ChangeMusic(itos(i));

 l:=(lvl-1) mod 16 + 1;
 rn:=lvls_rn[l];
 extra:=((lvl-1) div 16)*2;
 j:=0;
 for i:=1 to rn do
  begin
   inc(j);
   if (lvls[l][i][1]=0) or (lvls[l][i][2]=0) or (lvls[l][i][3]=0) then Exit;
   if lvls[l][i][3]<=7 then rang:=0 else rang:=128;
   if Map[lvls[l][i][1],lvls[l][i][2]]=0 then
     Robot[i]:=TRobot.Create(MainForm.DXSpriteEngine.Engine,lvls[l][i][1],lvls[l][i][2],lvls[l][i][3],rang,dRobot[lvls[l][i][3]])
     else dec(j);
  end;

 while (j<extra+rn) and (j<16+rn) do
  begin
   x:=random(BattleFieldW)+1;
   y:=random(4)+1;   k:=(random(15) div 10)+9;
   if Map[x,y]=0 then
    begin
     inc(j);
     Robot[j]:=TRobot.Create(MainForm.DXSpriteEngine.Engine,x,y,k,128,dRobot[k]);
    end;
  end;
end;

procedure Init;
begin
 dRobot[1]._hp:=100;
 dRobot[1]._speed:=1;
 dRobot[2]._hp:=100;
 dRobot[2]._speed:=1;
 dRobot[3]._hp:=500;
 dRobot[3]._speed:=1;
 dRobot[9]._hp:=100;
 dRobot[9]._speed:=1;
 dRobot[10]._hp:=100;
 dRobot[10]._speed:=1;
 dRobot[11]._hp:=500;
 dRobot[11]._speed:=1;

 dBullet[1]._speed:=3;
 dBullet[1]._power:=10;
 dBullet[2]._speed:=2;
 dBullet[2]._power:=30;
 dBullet[3]._speed:=3;
 dBullet[3]._power:=2;
end;



procedure Win;
begin
 MainForm.DXSpriteEngine.Engine.Clear;
 gs:=gsPreLevel;
 level:=level+1;
 MainForm.LabelLvl.Caption:='LEVEL '+itos(level);
 MainForm.BattlePanel.Hide;
 MainForm.LevelPanel.Show;
end;

procedure Lose;
begin
 MainForm.DXSpriteEngine.Engine.Clear;
 gs:=gsPreLevel;
 MainForm.LabelLvl.Caption:='LEVEL '+itos(level);
 MainForm.BattlePanel.Hide;
 MainForm.LevelPanel.Show;
end;


procedure TMainForm.DXTimerTimer(Sender: TObject; LagCount: Integer);

 procedure DrawMenu;
  var
   i:integer;
  begin
   Scr.Surface.Canvas.Font.Style:=[fsBold];
   Scr.Surface.Canvas.Font.Color:=clWhite;
   Scr.Surface.Canvas.Font.Size:=12;
   Scr.Surface.Canvas.Brush.Color:=clBlack;
   Scr.Surface.Canvas.Font.Name:='Comic Sans MS';
   Scr.Surface.Fill(0);
   for i:=1 to 16 do
    Scr.Surface.Canvas.TextOut(5,32*(i-1),str_0[i]);
  end;

 procedure DrawLevel;
  var
   i:integer;
  begin
   Scr.Surface.Fill(0);
   Scr.Surface.Canvas.Font.Size:=14;
   Scr.Surface.Canvas.Font.Color:=clWhite;
   if level=1 then
    for i:=1 to 4 do
     Scr.Surface.Canvas.TextOut(5,32*(i-1),str_1[i]);
   if level=2 then
    for i:=1 to 4 do
     Scr.Surface.Canvas.TextOut(5,32*(i-1),str_2[i]);
   if level=6 then
    for i:=1 to 4 do
     Scr.Surface.Canvas.TextOut(5,32*(i-1),str_6[i]);
  end;

 procedure DrawBattle;
  var
   i,j:integer;
  begin
   with scr.Surface.Canvas do
    begin
     for i:=1 to RobotCounter do
      ShowHP(i);
     Brush.Style:=bsClear;
     Pen.Color:=clBlack;
     if GridCheckBox.Checked then
     for i:=1 to BattlefieldW do
      for j:=1 to BattlefieldW do
       Rectangle((i-1)*SquareSize,(j-1)*SquareSize,i*SquareSize+1,j*SquareSize+1);



     if wins then
      begin
       Font.Color:=clBlue;
       Font.Size:=30;
       TextOut(50,100,'Round completed');
       Font.Size:=14;
       TextOut(150,200,'Click any button to continue...');
      end;
     if loses then
      begin
       Font.Color:=clRed;
       Font.Size:=30;
       TextOut(50,100,'Round failed');
       Font.Size:=14;
       TextOut(150,200,'Click any button to restart...');
      end;
    end;
  end;

begin
  if not scr.CanDraw then Exit;
  inc(glTime);
  if gs=gsBattle then
    begin
     if PlayerCounter[1]<=0 then wins:=TRUE else
      if PlayerCounter[0]<=0 then loses:=TRUE;
     if ((glTime-timebtn-1)=SquareSize)
     then
      begin
       EnableButtons(TRUE);
       if wins then Win;
       if loses then Lose;
      end;
    end;


  DXSpriteEngine.Move(LagCount);
  DXSpriteEngine.Dead;
  scr.Surface.Fill(0);
  DXSpriteEngine.Draw;

  case gs of
   gsMenu:      DrawMenu;
   gsPreLevel:  DrawLevel;
   gsBattle:    DrawBattle;
  end;

  Scr.Surface.Canvas.Release;
  Scr.Flip;
end;


procedure TMainForm.FormCreate(Sender: TObject);
begin
 Randomize;
 DXImageList.Items.LoadFromFile('data.dxg');
 LoadMaps;
 LoadBG;
 MainForm.DXTimer.Interval:=TimerInterval[2];
 BASS_Init(1,44100,0,Handle,nil);
 hBassMusic:=BASS_MusicLoad(FALSE,PChar('sound/0.xm'),0,0,BASS_MUSIC_AUTOFREE or BASS_MUSIC_SURROUND or BASS_SAMPLE_LOOP,0);
 BASS_MusicSetAttribute(hBassMusic,BASS_MUSIC_ATTRIB_VOL_CHAN,100);
 BASS_ChannelPlay(hBassMusic,true);
 LoadSound;
 Init;
end;


procedure TMainForm.FormDestroy(Sender: TObject);
begin

  DXBgList.Free;
  DXImageList.Free;
  bgBitmap.Free;
end;


procedure TMainForm.EnableButtons(bool: boolean);
var
 i:integer;
begin
 if not BattlePanel.Showing then Exit;
 for i:=1 to ComponentCount do
  if Components[i-1] is TBitBtn then
   (Components[i-1] as TBitBtn).Enabled:=bool;
end;


procedure TMainForm.BitBtnStartClick(Sender: TObject);
begin
 gs:=gsPreLevel;
 level:=1;
 LabelLvl.Caption:='LEVEL '+itos(level);
 StartPanel.Hide;
 LevelPanel.Show;
end;

procedure TMainForm.BitBtnLevelStartClick(Sender: TObject);
begin
 gs:=gsBattle;
 LevelPanel.Hide;
 BattlePanel.Show;
 StartLevel(level);
end;

procedure TMainForm.BitBtnFireClick(Sender: TObject);
var
 i:integer;
begin
 for i:=1 to RobotCounter do
  if (Robot[r[i]].Kind<8) and (random<RadioX) then
   TBullet.Create(DXSpriteEngine.Engine,Robot[r[i]].Kind mod 8,Robot[r[i]].Angle,dBullet[Robot[r[i]].Kind],Robot[r[i]],0,0);
 AIMove;
end;

procedure TMainForm.BitBtnUpClick(Sender: TObject);
var
 i:integer;
begin
 for i:=1 to RobotCounter do
  if (Robot[r[i]].Kind<8) and (random<RadioX) then
   Robot[r[i]].Send(Robot[r[i]].Xc,Robot[r[i]].Yc-1);
 AIMove;
end;

procedure TMainForm.BitBtnLeftClick(Sender: TObject);
var
 i:integer;
begin
 for i:=1 to RobotCounter do
  if (Robot[r[i]].Kind<8) and (random<RadioX) then
   Robot[r[i]].Send(Robot[r[i]].Xc-1,Robot[r[i]].Yc);
 AIMove;
end;


procedure TMainForm.BitBtnRightClick(Sender: TObject);
var
 i:integer;
begin
 for i:=1 to RobotCounter do
  if (Robot[r[i]].Kind<8) and (random<RadioX) then
   Robot[r[i]].Send(Robot[r[i]].Xc+1,Robot[r[i]].Yc);
 AIMove;
end;


procedure TMainForm.BitBtnDownClick(Sender: TObject);
var
 i:integer;
begin
 for i:=1 to RobotCounter do
  if (Robot[r[i]].Kind<8) and (random<RadioX) then
   Robot[r[i]].Send(Robot[r[i]].Xc,Robot[r[i]].Yc+1);
 AIMove;
end;


procedure TMainForm.BitBtnCenterClick(Sender: TObject);
var
 i:integer;
begin
 for i:=1 to RobotCounter do
  if (Robot[r[i]].Kind<8) and (random<RadioX) then
   if Robot[r[i]].Xc<=(BattleFieldW div 2)
    then Robot[r[i]].Send(Robot[r[i]].Xc+1,Robot[r[i]].Yc)
    else Robot[r[i]].Send(Robot[r[i]].Xc-1,Robot[r[i]].Yc);
 AIMove;
end;

procedure TMainForm.BitBtnSidesClick(Sender: TObject);
var
 i:integer;
begin
 for i:=1 to RobotCounter do
  if (Robot[r[i]].Kind<8) and (random<RadioX) then
   if Robot[r[i]].Xc<=(BattleFieldW div 2)
    then Robot[r[i]].Send(Robot[r[i]].Xc-1,Robot[r[i]].Yc)
    else Robot[r[i]].Send(Robot[r[i]].Xc+1,Robot[r[i]].Yc);
 AIMove;
end;

procedure TMainForm.BitBtnTurnLClick(Sender: TObject);
var
 i:integer;
begin
 for i:=1 to RobotCounter do
  if (Robot[r[i]].Kind<8) and (random<RadioX) then
   Robot[r[i]].dAngle:=(Robot[r[i]].dAngle+192) mod 256;
 AIMove;
end;


procedure TMainForm.BitBtnTurnRClick(Sender: TObject);
var
 i:integer;
begin
 for i:=1 to RobotCounter do
  if (Robot[r[i]].Kind<8) and (random<RadioX) then
   Robot[r[i]].dAngle:=(Robot[r[i]].dAngle+64) mod 256;
 AIMove;
end;


procedure TMainForm.SpeedTrackBarChange(Sender: TObject);
begin
 DXTimer.Interval:=TimerInterval[SpeedTrackBar.Position];
end;


procedure TMainForm.VolTrackBarChange(Sender: TObject);
begin
 optMusicVol:=25*VolTrackBar.Position;
 BASS_ChannelSetAttributes(hBassMusic,0,optMusicVol,0);
end;

end.
