unit u_var;

interface

const
 MaxRobot       = 64;
 BattleFieldW   = 16;
 BattleFieldH   = 16;
 SquareSize     = 32;
 RadioX:   real = 0.6; // probability of order recived (0 -> no order received at all) 
 TimerInterval: array [0..4] of integer = (80,40,20,10,5);


type
 TGameState     = (gsMenu,gsPreLevel,gsBattle,gsHiscore,gsFin);
 TMap           = array [0..BattlefieldW+1,0..BattlefieldH+1] of smallint;
 TBulletGoMap   = array [-1..BattlefieldW+2,-1..BattlefieldH+2] of boolean;
 TPoint = record
   X,Y:integer;
  end;
 TRobotDesc = record
   _hp,_power,_speed:integer;
  end;
 TBulletDesc = record
   _hp,_hpp,_power,_speed:integer;
  end;
 TStartRobot = record
  kind:  integer;
  Pos:   TPoint;
 end;
 TStartLevel = record
  robots_num: integer;
  robots:     array [1..MaxRobot] of TStartRobot;
 end; 


var
 gs:    TGameState = gsMenu;
 Map:   TMap;
 //     Map[X,Y] = $ABB
 //     A-relief
 //     BB-kind of object  ''B>$80 non-moveble'': 8x-robot 9x-robotmove Ax-tree FF-end of map

 AllMaps: array [1..16] of TMap;
 bMap: TBulletGoMap;
 BulletCounter: integer = 0;
 RobotCounter:  integer = 0;
 PlayerCounter: array [0..1] of integer;
 dRobot: array [0..15] of TRobotDesc;
 dBullet:array [0..7] of TBulletDesc;
 r:      array [1..MaxRobot] of byte;  // array of live robots id
 glTime:    integer = 0;
 timebtn,timemsg: integer;
 optMusicVol:  integer = 100;
 level:     integer = 0;
 wins,loses: boolean;
 leveload:   array [1..16] of TStartLevel;

function itos(i:integer):string;
function stoi(s:string):integer;
function Max(a,b:integer):integer;
function Min(a,b:integer):integer;
function Eps(a,b,sp:real):boolean;
function dA(ang: integer):TPoint;

implementation

function itos(i:integer):string;
begin
 str(i,Result);
end;

function stoi(s:string):integer;
var
 Code:integer;
begin
 val(s,Result,Code);
 if Code<>0 then Result:=0;
end;

function Max(a,b:integer):integer;
begin
 if b>a then Result:=b else Result:=a;
end;

function Min(a,b:integer):integer;
begin
 if b<a then Result:=b else Result:=a;
end;

function Eps(a,b,sp:real):boolean;
begin
 if abs(a-b)<=sp then Result:=TRUE else Result:=FALSE;
end;

function dA(ang: integer):TPoint;
begin
 Result.X:=0;
 Result.Y:=0;
 case ang of
  0:    Result.Y:=-1;
  64:   Result.X:=1;
  128:  Result.Y:=1;
  192:  Result.X:=-1;
 end;
end;

end.
