program io;

uses
  SysUtils,
  Windows,
  Lapage,
  GameConstr in 'GameConstr.pas',
  GameTypes in 'GameTypes.pas';

var
  Game: TGame;
  Blondy : TLpgList;
begin
  try
    ReportMemoryLeaksOnShutdown := true;

    lpgCreateWindow(Screen_Width, Screen_Height,
      LAPAGE_WINDOWMODE_BORDER or LAPAGE_WINDOWMODE_DOUBLESIZE);

    Game := TGame.Create;
    Game.Area.SetSize((Screen_Width div 20) - 1, (Screen_Height div 20) - 1);

    Blondy := LpgCreateCropList('data\blondy.png', $ff000000, 11, 15, LAPAGE_OBJECT_ROWBUFFER);

    repeat
      lpgWindowBuffer.FillRect(0, 0, Screen_Width, Screen_Height, $FFFFC0FF);
      Game.Draw(lpgWindowBuffer);

      Blondy.Draw(lpgWindowBuffer,
        15 + (GetTickCount div 80 mod 280),
        5,
        (GetTickCount div 200 mod Blondy.Count));

      lpgFlipWindow;
      sleep(20);
    until not IsWindow(lpgWindow);

    Game.Free;

  except
    on E: Exception do
      MessageBox(lpgWindow, Pchar(E.ClassName + ' : ' + E.Message), nil,
        MB_ICONERROR);
  end;

end.
