program io;

uses
  SysUtils,
  Windows,
  Messages,
  Lapage,
  GameConstr in 'GameConstr.pas',
  GameTypes in 'GameTypes.pas',
  BaseFile in 'BaseFile.pas';

var
  Game: TGame;

function MouseEventProc(var MouseEvent : TMouseEventRec) : bool; stdcall;
begin
  case MouseEvent.Event of
    WM_LBUTTONDOWN:
    begin
      Game.Click(MouseEvent.X, MouseEvent.Y);
    end;
  end;
  Result := true;
end;

begin
  try
    ReportMemoryLeaksOnShutdown := true;

    lpgSetMouseEvent(@MouseEventProc);

    lpgCreateWindow(Screen_Width, Screen_Height,
      LAPAGE_WINDOWMODE_BORDER or LAPAGE_WINDOWMODE_DOUBLESIZE);

    Game := TGame.Create;
    //Game.Area.SetSize((Screen_Width div 20) - 1, (Screen_Height div 20) - 1);
    Game.LoadLevel('.\data\level\1.txt');

    TGirl.Create(Game);

    repeat
      Game.Action;

      lpgWindowBuffer.FillRect(0, 0, Screen_Width, Screen_Height, $FF406080);
      Game.Draw(lpgWindowBuffer);

      lpgFlipWindow;
      sleep(40);
    until not IsWindow(lpgWindow);

    Game.Free;

  except
    on E: Exception do
      MessageBox(lpgWindow, Pchar(E.ClassName + ' : ' + E.Message), nil,
        MB_ICONERROR);
  end;

end.
