unit Main;

interface

uses OpenGL, Windows, eXgine, myGUI, uVar, uSprite, game_mex, enemy;

type
  TGameStatus = (gsMenu, gsGame, gsTitle, gsAuthors);


var
  gs: TGameStatus;

  Spr: TSprite;
  Ani: TAnimation;
  AniTex: TAnimatedTexture;




procedure GameInit;
procedure GameRender;
procedure GameUpdate;
procedure GameFree;

implementation

procedure GameInit;
var i, j: integer;
begin
  Randomize;
  LoadRes;
  InitGui;
  CreateMap;
  gs:=gsTitle;
  
  cam.Pos:=vec.Create(0,0,-302);
  cam.ang:=vec.Create(0, 1.57 , 3.14);


  AniTex.W:=128;
  AniTex.H:=64;
  AniTex.Texture:=tex.Load('Data\textures\test.bmp');

  Ani.Name:='Test';
  Ani.FPS:=1;
  Ani.FrameCount:=8;
  Ani.fWidth:=32;
  Ani.fHeight:=32;
  Ani.Atex:=AniTex;

  Spr:=TSprite.Create(1, 100, 100);
  Spr.AddAnimation(Ani);
  spr.pos.X:=100;
  spr.pos.Y:=100;
  Spr.PlayAnim('Test');

  ind_food:=TSprite.Create(5, 16, 16);
  ind_food.AddAnimation(Anims[2]);
  ind_food.pos.X:=788;
  ind_food.pos.Y:=20;
  ind_food.PlayAnim('food');

  ind_wood:=TSprite.Create(5, 16, 16);
  ind_wood.AddAnimation(Anims[3]);
  ind_wood.pos.X:=888;
  ind_wood.pos.Y:=20;
  ind_wood.PlayAnim('wood');

  ind_pop:=TSprite.Create(5, 16, 16);
  ind_pop.AddAnimation(Anims[4]);
  ind_pop.pos.X:=788;
  ind_pop.pos.Y:=40;
  ind_pop.PlayAnim('pop');

  ind_wrk:=TSprite.Create(5, 16, 16);
  ind_wrk.AddAnimation(Anims[6]);
  ind_wrk.pos.X:=928;
  ind_wrk.pos.Y:=40;
  ind_wrk.PlayAnim('wrk');

  ind_sld:=TSprite.Create(5, 16, 16);
  ind_sld.AddAnimation(Anims[5]);
  ind_sld.pos.X:=858;
  ind_sld.pos.Y:=40;
  ind_sld.PlayAnim('sld');

  backgr:=TSprite.Create(5, 768, 768);
  backgr.AddAnimation(Anims[7]);
  backgr.pos.X:=384;
  backgr.pos.Y:=384;
  backgr.PlayAnim('back');


  for I := 1 to 4 do
    begin
      Panel[i]:=TSprite.Create(5, 256, 256);
      Panel[i].AddAnimation(Anims[1]);
      Panel[i].pos.X:=896;
      Panel[i].pos.Y:=(i-2)*256+128;
      Panel[i].PlayAnim('1');
    end;
end;

procedure GameRender;
var i,j: integer; S: string;
begin
  case gs of
    gsTitle:
      begin
        // Logotypes
        Tex.Enable(LogoTex[LogoNum]);
        glColor4f(1.0,1.0,1.0,abs(sin(LogoTime/180)));
        glEnable(GL_BLEND);
        glBlendFunc (GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA) ;
        ogl.Set2D(0, 0, wnd.Width, wnd.Height);
        glBegin(GL_TRIANGLE_STRIP);
          glTexCoord2d(0.0,0.0);  glVertex2f(0,0);
          glTexCoord2d(1.0,0.0);  glVertex2f(1024,0);
          glTexCoord2d(0.0,1.0);  glVertex2f(0,768);
          glTexCoord2d(1.0,1.0);  glVertex2f(1024,768);
        glEnd;
        glDisable(GL_BLEND);
        glColor3f(1.0,1.0,1.0);
      end;

    gsMenu :
      begin
        tex.Filter(FT_NONE);
        ogl.Clear(True, True);
        ogl.Set3D(90, 0.1, 1024);
        cam.SetRender;

        for I := 1 to 4 do
          Panel[i].Render;
        Spr.Render;

        ind_wood.Render;
        ind_food.Render;
        ind_pop.Render;
        ind_wrk.Render;
        ind_sld.Render;
       // ind_food.Render;

        backgr.Render;

        plbase.Render;
        aibase.Render;

        for i := 1 to 6 do
          ResPlace[i].Render;

        for I := 1 to 100 do
          plWrks[i].Render;

        for I := 1 to 100 do
          plSlds[i].Render;

        for I := 1 to 100 do
          aiWrks[i].Render;

        for I := 1 to 100 do
          aiSlds[i].Render;

        ogl.Set2D(0,0,wnd.Width,wnd.Height);
        tb[1].Render;
        tb[2].Render;
        tb[3].Render;
        tb[4].Render;
        tb[5].Render;
        tb[6].Render;
        tb[7].Render;
        tb[8].Render;
        tb[9].Render;
        tb[10].Render;
        tb[11].Render;
        tb[12].Render;
        tb[13].Render;
        tb[14].Render;
        tb[15].Render;
        cur.Render;

{     }

        glColor3f(1, 1, 1);
        ogl.TextOut(1, 800, 10, PChar(IntToStr(plr.rsFood)));
        ogl.TextOut(1, 900, 10, PChar(IntToStr(plr.rsWood)));
        ogl.TextOut(1, 810, 30, PChar(IntToStr(plr.popCnt) +'/'+IntToStr(plr.maxCnt)));
        ogl.TextOut(1, 880, 30, PChar(IntToStr(plr.wrkCnt) +'/'+IntToStr(plr.popCnt-plr.SldCnt)));
        ogl.TextOut(1, 950, 30, PChar(IntToStr(plr.SldCnt) +'/'+IntToStr(plr.popCnt-plr.wrkCnt)));

        for I := 1 to 8 do
          case plr.Prod_Line[i] of
             pliNone: S:=S+'---';
             pliWrk : S:=S+'<W>';
             pliHole: S:=S+'<H>';
             pliKZ  : S:=S+'<K>';
             pliSld : S:=S+'<S>';
          end;
        ogl.TextOut(1, 770, 730, PChar(S));
        case plr.Prod_Line[1] of
          pliNone: ogl.TextOut(1, 770, 750, PChar('   '+inttostr(plr.CurrProdTime)));
          pliWrk : ogl.TextOut(1, 770, 750, PChar('  ( '+inttostr(round(plr.CurrProdTime/100*100))+'%'));
          pliHole: ogl.TextOut(1, 770, 750, PChar('  ( '+inttostr(round(plr.CurrProdTime/1000*100))+'%'));
          pliKz  : ogl.TextOut(1, 770, 750, PChar('  ( '+inttostr(round(plr.CurrProdTime/2000*100))+'%'));
          pliSld : ogl.TextOut(1, 770, 750, PChar('  ( '+inttostr(round(plr.CurrProdTime/200*100))+'%'));

        end;
      //  ogl.TextOut(1, 900, 10, PChar(IntToStr(plr.rsWood)));
      end;

  end;

end;

procedure GameUpdate;
var i,j : integer;
begin
  case gs of
    gsGame  :
      begin
        if (inp.lastKey=VK_LEFT) then  ;

      end;
    gsTitle :
      begin
        inc(LogoTime,1);
          if (LogoTime=565)or
             (LogoTime=1130)then inc(LogoNum);
          if LogoTime>1695 then
          begin
            gs:=gsMenu;
            snd.PlayFile('Data/Music/DR_Theme_1.ogg',true);
          end;

          if (inp.lastkey=(VK_SPACE))or(inp.lastkey=(VK_RETURN)) then
            begin
              case logoNum  of
                1: LogoTime:=564;
                2: LogoTime:=1129;
                3: LogoTime:=1694;
              end;
            end;
      end;
      gsMenu :
      begin
        Cam.Update;
        Cam.SetProj;
        tb[1].Update;
        tb[2].Update;
        tb[3].Update;
        tb[4].Update;
        tb[5].Update;
        tb[6].Update;
        tb[7].Update;
        tb[8].Update;
        tb[9].Update;
        tb[10].Update;
        tb[11].Update;
        tb[12].Update;
        tb[13].Update;
        tb[14].Update;
        tb[15].Update;

        for I := 1 to 4 do
           begin
             Panel[i].Update;
           end;

        Spr.Update;
        ind_food.Update;
        ind_wood.Update;
        ind_pop.Update;
        ind_wrk.Update;
        ind_sld.Update;
        //ind_wood.Update;

        backgr.Update;

        CivUpdate;
        MakeAI;

        plbase.Update;
        aibase.Update;

        for i := 1 to 6 do
          ResPlace[i].Update;
      end;
  end;

end;

procedure GameFree;
var i,j: integer;
begin
   Spr.Free;
end;


end.
