unit enemy;

interface

uses uVar, game_mex, uSprite, eXgine;

procedure MakeAI;
function FindNearest(pos: tVector; tg : TTarget): word;
procedure SendToAttSld;

var fail     : boolean;
    wait     : boolean;
    nextWave : integer;

implementation

function Collision(s1, s2: tSprite): boolean;
begin
  result:= false;

   if(s1.Pos.X>s2.pos.X-s2.w/2)and
     (s1.Pos.X<s2.pos.X+s2.w/2)and
     (s1.Pos.Y>s2.pos.Y-s2.h/2)and
     (s1.Pos.Y<s2.pos.Y+s2.h/2)then result:=true;
end;

function FindNearest(pos: tVector; tg : TTarget): word;
var i: integer; res, tmpres: real; ind: word;
begin
  res:=1000000000000;
  case tg of
    tgNone: ;
    tgWood: begin
              ind:=0;
              for I := 4 to 6 do
                begin
                  tmpres:=sqr(pos.X-resplace[i].spr.pos.x)+sqr(pos.Y-resplace[i].spr.pos.Y);
                  if (tmpres<res) and (resplace[i].alive) then
                     begin
                       res:=tmpres;
                       ind:=i;
                     end;
                  result:=ind;
                end;
            end;
    tgFood: begin
              ind:=0;
              for I := 1 to 3 do
                begin
                  tmpres:=sqr(pos.X-resplace[i].spr.pos.x)+sqr(pos.Y-resplace[i].spr.pos.Y);
                  if (tmpres<res) and (resplace[i].alive) then
                     begin
                       res:=tmpres;
                       ind:=i;
                     end;
                  result:=ind;
                end;
            end;
    tgHome: ;
    tgEnSold: begin
                ind:=0;
                for I := 1 to 100 do
                if aiSlds[i].alive then
                begin
                  tmpres:=sqr(pos.X-aislds[i].spr.pos.x)+sqr(pos.Y-aislds[i].spr.pos.Y);
                  if (tmpres<res) and (aiSlds[i].alive) then
                     begin
                       res:=tmpres;
                       ind:=i;
                     end;
                end;
                result:=ind;
              end;
    tgEnWork: begin
                ind:=0;
                for I := 1 to 100 do
                  if plWrks[i].alive then
                     begin
                       tmpres:=sqr(pos.X-plwrks[i].spr.pos.x)+sqr(pos.Y-plwrks[i].spr.pos.Y);
                       if (tmpres<res) and (plWrks[i].alive) then
                       begin
                         res:=tmpres;
                         ind:=i;
                       end;
                     end;
                     result:=ind; ;
              end;
    tgEnBase: ;
  end;
end;

procedure StepLine;
  var i:integer;
begin
    for I := 1 to 7 do
       ai.Prod_Line[i]:=ai.Prod_Line[i+1];
    ai.Prod_Line[8]:=pliNone;
end;

procedure AddWrk;
var i: integer;
begin
  i:=1;
  dec(ai.rsWood, 3);
  fail:=false;

  while ai.Prod_Line[i]<>pliNone do
     begin
       inc(i);
       if i>8 then fail:=true;
       if fail then break;
     end;

  if not fail then
     begin
       ai.Prod_Line[i]:=pliWrk;
       Logout('ai:       '+inttostr(i));
     end else
       Logout('ai:     !');
end;

procedure addKz;
  var i: integer;
begin
  //    
  fail:=false;
  i:=1;
  dec(ai.rsWood, 250);
  dec(ai.popCnt, 10);

  while ai.Prod_Line[i]<>pliNone do
     begin
       inc(i);
       if i>8 then fail:=true;
       if fail then break;
     end;

  if not fail then
     begin
       ai.Prod_Line[i]:=pliKz;
       Logout('ai:       '+inttostr(i));
     end else
       Logout('ai:     ');
end;

procedure AddSld;
  var i: integer;
begin
  //    
  fail:=false;
  i:=1;


  while ai.Prod_Line[i]<>pliNone do
     begin
       inc(i);
       if i>8 then fail:=true;
       if fail then break;
     end;

  if not fail then
     begin
       ai.Prod_Line[i]:=pliSld;
       Logout('ai:       '+inttostr(i));
       dec(ai.rsWood, 10);
     end else
       Logout('ai:     !');
end;

procedure SendToAttWrk;
var i: integer;
begin
   for I := 1 to 100 do
     begin
       if (aiSlds[i].exist) and (aiSlds[i].trg=tgNone) then
         begin
           LogOut('ai:    !');
           aiSlds[i].HP:=10;
           aiSlds[i].atk:=3;
           aiSlds[i].alive:=true;
           aiSlds[i].spr.pos:=vec.Add(aiBase.door,vec.Create(random(32), random(32), 0));
           aiSlds[i].trg:=tgEnWork;
           if FindNearest(aiSlds[i].spr.pos, tgEnWork)<>0 then
              aiSlds[i].ind:=FindNearest(aiSlds[i].spr.pos, tgEnWork)
           else
             aiSlds[i].trg:=tgHome;
         end;
     end;
end;

procedure SendToAttSld;
var i: integer;
begin
   for I := 1 to 100 do
     begin
       if (aiSlds[i].exist) and (aiSlds[i].trg=tgNone) then
         begin
           LogOut('ai:    !');
           aiSlds[i].HP:=10;
           aiSlds[i].atk:=3;
           aiSlds[i].alive:=true;
           aiSlds[i].spr.pos:=vec.Add(aiBase.door,vec.Create(random(32), random(32), 0));
           aiSlds[i].trg:=tgEnSold;
           if FindNearest(plSlds[i].spr.pos, tgEnWork)<>0 then
              aiSlds[i].ind:=FindNearest(plSlds[i].spr.pos, tgEnSold)
           else
             aiSlds[i].trg:=tgHome;
         end;
     end;
end;

procedure MakeAI;
var i,j: integer;
begin

{===========================================================================
      .
===========================================================================}

  if wait=true then
     begin
       inc(nextWave);
       if NextWave>750 then wait:=false;
     end;

  if ai.rsFood<100 then  ai.kof:=2 else ai.kof:=1;

  if (ai.wrkCnt<20)and(ai.rsWood>3)and(ai.popCnt>19) then  AddWrk;

  if (ai.wrkCnt>=20) and (ai.popCnt>ai.wrkCnt+ai.SldCnt+10)and(ai.rsWood>250)and(ai.KzCnt=0) then AddKz;

  if (ai.KzCnt>0) and (ai.popCnt>ai.wrkCnt+ai.SldCnt+1)and (ai.rsWood>=10) then AddSld;

  if (ai.SldCnt>5) and (Wait=false) then
  begin
    SendToAttWrk;
    wait:=true;
    NextWave:=0;
  end;


{============================================================================
        ))))))))))))))))
    ,   ? )))
=============================================================================}
  
  

// 
  inc(ai.CurrBornTime);
  if ai.CurrBornTime>120 then
     begin
       if (ai.popCnt<ai.maxCnt)and(ai.rsFood>=7) then
         begin
           inc(ai.popCnt);
           ai.rsFood:=ai.rsFood-7;
         end;
       ai.CurrBornTime:=0;
     end;

// 
  inc(ai.CurrEatTime);
  if ai.CurrEatTime>600 then
     begin
       for i := 1 to 100 do
         if
           (aiWrks[i].alive)and(ai.rsFood>0) then dec(ai.rsFood)
         else
         if (aiWrks[i].alive) then
         begin
           aiWrks[i].HP:=aiWrks[i].HP-4;
           logout('AI :   '+inttostr(i)+'  '+inttostr(aiWrks[i].HP)+' HP');
         end;

       ai.CurrEatTime:=0;

     end;

  if ai.Prod_Line[1]<>pliNone then
    begin
      inc(ai.CurrProdTime);
      case ai.Prod_Line[1] of
         pliWrk: begin
                   if ai.CurrProdTime>=100 then
                       begin
                          StepLine;
                          LogOut('ai:  ');
                          ai.CurrProdTime:=0;


                          j:=1;
                          while aiWrks[j].alive<>false do inc(j);
                          aiWrks[j].alive:=true;
                          aiWrks[j].trg:=tgNone;
                          aiWrks[j].spr.pos:=aiBase.door;
                          aiWrks[j].HP:=10;


                          inc(ai.wrkCnt);
                       end;
                 end;
          plisld: begin
                   if ai.CurrProdTime>=200 then
                       begin
                          StepLine;
                          LogOut('ai:  ');
                          ai.CurrProdTime:=0;

                          inc(ai.SldCnt);

                          j:=1;
                          while aiSlds[j].exist<>false do inc(j);
                                aislds[j].exist:=true;
                                aislds[j].trg:=tgNone;

                       end;
                 end;
         pliHole: begin
                   if ai.CurrProdTime>=1000 then
                       begin
                          StepLine;
                          LogOut('ai:  ');
                          ai.CurrProdTime:=0;

                          inc(ai.bldCnt);
                          inc(ai.hlCnt);
                       end;
                 end;
         pliKz : begin
                   if ai.CurrProdTime>=2000 then
                       begin
                          StepLine;
                          LogOut('ai:  ');
                          ai.CurrProdTime:=0;

                          inc(ai.KzCnt);
                          inc(ai.bldCnt);
                       end;
                 end;
      end;
    end;


    for i := 1 to 100 do
      begin
        if (aiWrks[i].trg=tgNone) and (aiWrks[i].alive) then
          begin
            if ai.fCnt<=trunc(ai.wCnt*ai.kof) then
              begin
                aiWrks[i].trg:=tgFood;
                if findNearest(aiWrks[i].spr.pos, tgFood)<>0 then
                   begin
                     aiWrks[i].ind:=findNearest(aiWrks[i].spr.pos, tgFood);
                     inc(ai.fCnt);
                   end
                  else
                  begin
                    aiWrks[i].trg:=tgWood;
                    if findNearest(aiWrks[i].spr.pos, tgWood)<>0 then
                       begin
                         aiWrks[i].ind:=findNearest(aiWrks[i].spr.pos, tgWood);
                         inc(ai.wCnt);
                       end
                       else
                         aiWrks[i].trg:=tgHome;
                  end;
              end else
              begin
                aiWrks[i].trg:=tgwood;
                if findNearest(aiWrks[i].spr.pos, tgwood)<>0 then
                   begin
                     aiWrks[i].ind:=findNearest(aiWrks[i].spr.pos, tgwood);
                     inc(ai.wcnt);
                   end
                  else
                  begin
                    aiWrks[i].trg:=tgFood;
                    if findNearest(aiWrks[i].spr.pos, tgFood)<>0 then
                       begin
                         aiWrks[i].ind:=findNearest(aiWrks[i].spr.pos, tgFood);
                         inc(ai.fCnt);
                       end
                       else
                         aiWrks[i].trg:=tgHome;
                  end;
              end;
          end;

        aiWrks[i].Update;
        aiSlds[i].Update;
      end;
end;

end.
