unit game_mex;

interface

uses uSprite, eXgine, openGl, windows;

type
  tTarget = (tgNone, tgWood, tgFood, tgHome, tgEnSold, tgEnWork, tgEnBase);
  TMapObj = (moFood, moWood, moStruct);

  TMapObject = object
     objType: TMapObj;
     count  : word;
     spr    : TSprite;
     alive  : boolean;
    public
      procedure Render;
      procedure Update;
  end;

  TWorker = object
      spr : TSprite;
      trg, lastTrg : TTarget;
      HP, atk : integer;
      _AI  : boolean;
      ind : word;
      res : boolean;
      alive : boolean;
    public
      procedure Render;
      procedure Update;
      procedure SetTarget(New: tTarget);
  end;

  TSoldier = object
      spr             : TSprite;
      trg, lastTrg    : TTarget;
      HP, atk         : integer;
      _AI             : boolean;
      ind,rest        : word;
      alive, exist    : boolean;
    public
      procedure Render;
      procedure Update;
      procedure SetTarget(New: tTarget);
  end;

  TBase = object
      spr  : TSprite;
      door : TVector;
      HP   : integer;
      _AI   : boolean;
      alive: boolean;
    public
      procedure Render;
      procedure Update;
  end;

procedure btnWrkClick;
procedure btnSldClick;

procedure btnChange1;
procedure btnChange2;
procedure btnChange3;

procedure btnSldAtwClick;
procedure btnSldAtsClick;
procedure btnSldAtbClick;
procedure btnSldAtwBClick;
procedure btnSldAtsBClick;
procedure btnSldAtbBClick;

procedure btnHoleClick;
procedure btnKzClick;


procedure CivUpdate;

function Collision(s1, s2 : tSprite): boolean;
function FindNearest(pos: tVector; tg : TTarget): word;

implementation

uses uVar, enemy;

{$REGION 'AddFunc'}

function Collision(s1, s2: tSprite): boolean;
begin
  result:= false;

   if(s1.Pos.X>s2.pos.X-s2.w/2)and
     (s1.Pos.X<s2.pos.X+s2.w/2)and
     (s1.Pos.Y>s2.pos.Y-s2.h/2)and
     (s1.Pos.Y<s2.pos.Y+s2.h/2)then result:=true;
end;

function FindNearest(pos: tVector; tg : TTarget): word;
var i: integer; res, tmpres: real; ind: word;
begin
  res:=1000000000000;
  case tg of
    tgNone: ;
    tgWood: begin
              ind:=0;
              for I := 4 to 6 do
                begin
                  tmpres:=sqr(pos.X-resplace[i].spr.pos.x)+sqr(pos.Y-resplace[i].spr.pos.Y);
                  if (tmpres<res) and (resplace[i].alive) then
                     begin
                       res:=tmpres;
                       ind:=i;
                     end;
                  result:=ind;
                end;
            end;
    tgFood: begin
              ind:=0;
              for I := 1 to 3 do
                begin
                  tmpres:=sqr(pos.X-resplace[i].spr.pos.x)+sqr(pos.Y-resplace[i].spr.pos.Y);
                  if (tmpres<res) and (resplace[i].alive) then
                     begin
                       res:=tmpres;
                       ind:=i;
                     end;
                  result:=ind;
                end;
            end;
    tgHome: ;
    
    tgEnSold: begin
                ind:=0;
                for I := 1 to 100 do
                if aiSlds[i].alive then
                begin
                  tmpres:=sqr(pos.X-aislds[i].spr.pos.x)+sqr(pos.Y-aislds[i].spr.pos.Y);
                  if (tmpres<res) and (aiSlds[i].alive) then
                     begin
                       res:=tmpres;
                       ind:=i;
                     end;
                end;
                result:=ind;
              end;

    tgEnWork: begin
                ind:=0;
                for I := 1 to 100 do
                if aiWrks[i].alive then
                begin
                  tmpres:=sqr(pos.X-aiwrks[i].spr.pos.x)+sqr(pos.Y-aiwrks[i].spr.pos.Y);
                  if (tmpres<res) and (aiWrks[i].alive) then
                     begin
                       res:=tmpres;
                       ind:=i;
                     end;
                end;
                result:=ind;
              end;
    tgEnBase: ;
  end;
end;

procedure StepLine;
  var i:integer;
begin
    for I := 1 to 7 do
       plr.Prod_Line[i]:=plr.Prod_Line[i+1];
    plr.Prod_Line[8]:=pliNone;
end;

{$ENDREGION}

{$REGION 'ButtonClick'}
procedure btnWrkClick;
  var i: integer; fail: boolean;
begin
  //    

  i:=1;
  dec(plr.rsWood, 3);

  while plr.Prod_Line[i]<>pliNone do
     begin
       inc(i);
       if i>8 then fail:=true;
       if fail then break;
     end;

  if not fail then
     begin
       plr.Prod_Line[i]:=pliWrk;
       Logout('pl:       '+inttostr(i));
     end else
       Logout('pl:     !');

end;

procedure btnSldClick;
  var i: integer; fail: boolean;
begin
  //    

  i:=1;
  dec(plr.rsWood, 10);

  while plr.Prod_Line[i]<>pliNone do
     begin
       inc(i);
       if i>8 then fail:=true;
       if fail then break;
     end;

  if not fail then
     begin
       plr.Prod_Line[i]:=pliSld;
       Logout('pl:       '+inttostr(i));
     end else
       Logout('pl:     !');

end;

procedure btnHoleClick;
  var i: integer; fail: boolean;
begin
  //    

  i:=1;
  dec(plr.rsWood, 150);
  dec(plr.popCnt, 5);

  while plr.Prod_Line[i]<>pliNone do
     begin
       inc(i);
       if i>8 then fail:=true;
       if fail then break;
     end;

  if not fail then
     begin
       plr.Prod_Line[i]:=pliHole;
       Logout('pl:       '+inttostr(i));
     end else
       Logout('pl:     !');
end;

procedure btnKzClick;
  var i: integer; fail: boolean;
begin
  //    

  i:=1;
  dec(plr.rsWood, 250);
  dec(plr.popCnt, 10);

  while plr.Prod_Line[i]<>pliNone do
     begin
       inc(i);
       if i>8 then fail:=true;
       if fail then break;
     end;

  if not fail then
     begin
       plr.Prod_Line[i]:=pliKz;
       Logout('pl:       '+inttostr(i));
     end else
       Logout('pl:     ');
end;

procedure BtnSldAtwClick;
var i: integer;
begin
   for I := 1 to 100 do
     begin
       if (PlSlds[i].exist) and (PlSlds[i].trg=tgNone) then
         begin
           LogOut('pl:    !');
           PlSlds[i].HP:=10;
           PlSlds[i].atk:=3;
           PlSlds[i].alive:=true;
           PlSlds[i].spr.pos:=plBase.door;
           PlSlds[i].trg:=tgEnWork;
           if FindNearest(PlSlds[i].spr.pos, tgEnWork)<>0 then
              PlSlds[i].ind:=FindNearest(PlSlds[i].spr.pos, tgEnWork)
           else
             PlSlds[i].trg:=tgHome;
         end;
     end;
end;

procedure BtnSldAtsClick;
var i: integer;
begin
   for I := 1 to 100 do
     begin
       if (PlSlds[i].exist) and (PlSlds[i].trg=tgNone) then
         begin
           LogOut('pl:    !');
           PlSlds[i].HP:=10;
           PlSlds[i].atk:=3;
           PlSlds[i].alive:=true;
           PlSlds[i].spr.pos:=plBase.door;
           PlSlds[i].trg:=tgEnSold;
           if FindNearest(PlSlds[i].spr.pos, tgEnSold)<>0 then
              begin
                PlSlds[i].ind:=FindNearest(PlSlds[i].spr.pos, tgEnSold)
              end
           else
             PlSlds[i].trg:=tgHome;
         end;
     end;
end;

procedure BtnSldAtbClick;
var i: integer;
begin
   for I := 1 to 100 do
     begin
       if (PlSlds[i].exist) and (PlSlds[i].trg=tgNone) then
         begin
           LogOut('pl:    !');
           PlSlds[i].HP:=10;
           PlSlds[i].atk:=3;
           PlSlds[i].alive:=true;
           PlSlds[i].spr.pos:=plBase.door;
           PlSlds[i].trg:=tgEnBase;
         end;
     end;
end;

procedure BtnSldAtsBClick;
var i: integer;
begin
   for I := 1 to 100 do
     begin
       if (PlSlds[i].alive) and (PlSlds[i].trg=tgEnSold) then
         begin
           PlSlds[i].trg:=tgHome;
         end;
     end;
end;

procedure BtnSldAtbBClick;
var i: integer;
begin
   for I := 1 to 100 do
     begin
       if (PlSlds[i].alive) and (PlSlds[i].trg=tgEnBase) then
         begin
           PlSlds[i].trg:=tgHome;
         end;
     end;
end;

procedure BtnSldAtwBClick;
var i: integer;
begin
   for I := 1 to 100 do
     begin
       if (PlSlds[i].alive) and (PlSlds[i].trg=tgEnWork) then
         begin
           PlSlds[i].trg:=tgHome;
         end;
     end;
end;

procedure btnChange1;
var i: integer;
begin
plr.kof:=1;

plr.fCnt:=0;
  plr.wCnt:=0;

  for I := 1 to 100 do
    plWrks[i].trg:=tgNone;
end;

procedure btnChange2;
var i: integer;
begin
  plr.kof:=2;

  plr.fCnt:=0;
  plr.wCnt:=0;

  for I := 1 to 100 do
    plWrks[i].trg:=tgNone;
end;

procedure btnChange3;
var i: integer;
begin
  plr.kof:=0.5;

  plr.fCnt:=0;
  plr.wCnt:=0;

  for I := 1 to 100 do
    plWrks[i].trg:=tgNone;
end;

{$ENDREGION}


procedure CivUpdate;
var i,j: integer;
begin
   case plr.hlCnt of
     0: plr.maxCnt:=50;
     1: plr.maxCnt:=70;
     2: plr.maxCnt:=85;
     3: plr.maxCnt:=95;
     4: plr.maxCnt:=100;
   end;


   if (plr.wrkCnt=0) and (plr.rsWood<=3) then
   begin
      LogOut('==========================================');
      LogOut('----------!-');
      LogOut('==========================================');
      ex.Quit;
   end;

  if (ai.wrkCnt=0) and (ai.rsWood<3) then
   begin
      LogOut('==========================================');
      LogOut('-------!-!-!-!-');
      LogOut('==========================================');
      ex.Quit;
   end;


// 
  inc(plr.CurrBornTime);
  if plr.CurrBornTime>(300-plr.hlCnt*50) then
     begin
       if (plr.popCnt<plr.maxCnt)and(plr.rsFood>=(7-plr.hlCnt)) then
         begin
           inc(plr.popCnt);
           plr.rsFood:=plr.rsFood-7+plr.hlCnt;
         end;
       plr.CurrBornTime:=0;
     end;

// 
  inc(plr.CurrEatTime);
  if plr.CurrEatTime>1500 then
     begin
       for i := 1 to 100 do
         if
           (plWrks[i].alive)and(plr.rsFood>0) then dec(plr.rsFood)
         else
         if (plWrks[i].alive) then
         begin
           plWrks[i].HP:=plWrks[i].HP-4;
           logout('  '+inttostr(i)+'  '+inttostr(plWrks[i].HP)+' HP');
         end;

       plr.CurrEatTime:=0;
         
     end;


  if (plr.popCnt>(plr.wrkCnt+plr.SldCnt)) and
     (plr.rsWood>3) then tb[5].Visible:=true else tb[5].Visible:=false;

  if (plr.popCnt>=(Plr.wrkCnt+plr.SldCnt+10))and
     (plr.bldCnt<4)and
     (plr.rsWood>=250) then tb[1].Visible:=true else tb[1].Visible:=false;

  if (plr.popCnt>=(Plr.wrkCnt+plr.SldCnt+5))and
     (plr.bldCnt<4)and
     (plr.rsWood>=150) then tb[2].Visible:=true else tb[2].Visible:=false;

  if (plr.popCnt>=(Plr.wrkCnt+plr.SldCnt+15))and
     (plr.bldCnt<4)and
     (plr.rsWood>=300) then tb[3].Visible:=true else tb[3].Visible:=false;

  if (plr.popCnt>=(Plr.wrkCnt+plr.SldCnt+10))and
     (plr.bldCnt<4)and
     (plr.rsWood>=200) then tb[4].Visible:=true else tb[4].Visible:=false;

  if (plr.popCnt>(plr.wrkCnt+plr.SldCnt)) and
     (plr.rsWood>10)and
     (plr.KzCnt>0)  then tb[9].Visible:=true else tb[9].Visible:=false;

  if (plr.SldCnt>0) then
    begin
     tb[10].Visible:=true;
     tb[11].Visible:=true;
     tb[12].Visible:=true;
     tb[13].Visible:=true;
     tb[14].Visible:=true;
     tb[15].Visible:=true;
    end else
    begin
      tb[10].Visible:=false;
      tb[11].Visible:=false;
      tb[12].Visible:=false;
      tb[13].Visible:=false;
      tb[14].Visible:=false;
      tb[15].Visible:=false;
    end;
  


  

  if plr.Prod_Line[1]<>pliNone then
    begin
      inc(plr.CurrProdTime);
      case plr.Prod_Line[1] of
         pliWrk: begin
                   if plr.CurrProdTime>=100 then
                       begin
                          StepLine;
                          LogOut('pl:  ');
                          plr.CurrProdTime:=0;


                          j:=1;
                          while plWrks[j].alive<>false do inc(j);
                          plWrks[j].alive:=true;
                          plWrks[j].trg:=tgNone;
                          plWrks[j].spr.pos:=plBase.door;
                          plWrks[j].HP:=10;


                          inc(plr.wrkCnt);
                       end;
                 end;
         plisld: begin
                   if plr.CurrProdTime>=200 then
                       begin
                          StepLine;
                          LogOut('pl:  ');
                          plr.CurrProdTime:=0;

                          inc(plr.SldCnt);

                          j:=1;
                          while plSlds[j].exist<>false do inc(j);
                                plslds[j].exist:=true;
                                plslds[j].trg:=tgNone;
                            
                       end;
                 end;
         pliHole: begin
                   if plr.CurrProdTime>=1000 then
                       begin
                          StepLine;
                          LogOut('pl:  ');
                          plr.CurrProdTime:=0;

                          inc(plr.bldCnt);
                          inc(plr.hlCnt);
                       end;
                 end;
         pliKz : begin
                   if plr.CurrProdTime>=2000 then
                       begin
                          StepLine;
                          LogOut('pl:  ');
                          plr.CurrProdTime:=0;

                          inc(plr.KzCnt);
                          inc(plr.bldCnt);
                       end;
                 end;

      end;
    end;


    for i := 1 to 100 do
      begin
        if (plWrks[i].trg=tgNone) and (plWrks[i].alive) then
          begin
            if plr.fCnt<=trunc(plr.wCnt*plr.kof) then
              begin
                plWrks[i].trg:=tgFood;
                if findNearest(plWrks[i].spr.pos, tgFood)<>0 then
                   begin
                     plWrks[i].ind:=findNearest(plWrks[i].spr.pos, tgFood);
                     inc(plr.fCnt);
                   end
                  else
                  begin
                    plWrks[i].trg:=tgWood;
                    if findNearest(plWrks[i].spr.pos, tgWood)<>0 then
                       begin
                         plWrks[i].ind:=findNearest(plWrks[i].spr.pos, tgWood);
                         inc(plr.wCnt);
                       end
                       else
                         plWrks[i].trg:=tgHome;
                  end;
              end else
              begin
                plWrks[i].trg:=tgwood;
                if findNearest(plWrks[i].spr.pos, tgwood)<>0 then
                   begin
                     plWrks[i].ind:=findNearest(plWrks[i].spr.pos, tgwood);
                     inc(plr.wcnt);
                   end
                  else
                  begin
                    plWrks[i].trg:=tgFood;
                    if findNearest(plWrks[i].spr.pos, tgFood)<>0 then
                       begin
                         plWrks[i].ind:=findNearest(plWrks[i].spr.pos, tgFood);
                         inc(plr.fCnt);
                       end
                       else
                         plWrks[i].trg:=tgHome;
                  end;
              end;
          end;

        plWrks[i].Update;
        plSlds[i].Update;
      end;
end;

{$REGION 'MAPOBJ'}

procedure TMapObject.Render;
begin
  if alive then spr.Render;
end;

procedure TMapObject.Update;
begin
  if alive then spr.Update;
end;

{$ENDREGION}


procedure TWorker.Render;
begin
  if alive then spr.Render;
end;

procedure TWorker.SetTarget(New: tTarget);
begin
  trg:=New;
end;

procedure TWorker.Update;
var b : Tbase;
begin
  if alive then
  begin
    case trg of
      tgWood: begin
                //          .
                if spr.pos.X<ResPlace[ind].spr.pos.X+random(50)-25 then spr.pos.X:=spr.pos.x+1;
                if spr.pos.X>ResPlace[ind].spr.pos.X+random(50)-25 then spr.pos.X:=spr.pos.x-1;
                if spr.pos.Y<ResPlace[ind].spr.pos.Y+random(50)-25 then spr.pos.y:=spr.pos.y+1;
                if spr.pos.Y>ResPlace[ind].spr.pos.Y+random(50)-25 then spr.pos.y:=spr.pos.y-1;

                if Collision(spr, ResPlace[ind].spr) then
                   begin
                     dec(resplace[ind].count);
                     if ResPlace[ind].count<=0 then  ResPlace[Ind].alive:=false;
                     res:=true;
                     LastTrg:=Trg;
                     SetTarget(tgHome);
                   end;

              end;
      tgFood: begin
                //          .
                if spr.pos.X<ResPlace[ind].spr.pos.X+random(50)-25 then spr.pos.X:=spr.pos.x+1;
                if spr.pos.X>ResPlace[ind].spr.pos.X+random(50)-25 then spr.pos.X:=spr.pos.x-1;
                if spr.pos.Y<ResPlace[ind].spr.pos.Y+random(50)-25 then spr.pos.y:=spr.pos.y+1;
                if spr.pos.Y>ResPlace[ind].spr.pos.Y+random(50)-25 then spr.pos.y:=spr.pos.y-1;

                if Collision(spr, ResPlace[ind].spr) then
                   begin
                     dec(resplace[ind].count);
                     if ResPlace[ind].count<=0 then  ResPlace[Ind].alive:=false;
                     res:=true;
                     LastTrg:=Trg;
                     SetTarget(tgHome);
                   end;

              end;
      tgHome: begin
                if _AI then b:=aibase else b:=plbase;

                // 
                if spr.pos.X<b.door.X then spr.pos.X:=spr.pos.x+1;
                if spr.pos.X>b.door.X then spr.pos.X:=spr.pos.x-1;
                if spr.pos.Y<b.door.Y then spr.pos.y:=spr.pos.y+1;
                if spr.pos.Y>b.door.Y then spr.pos.y:=spr.pos.y-1;

                if Collision(spr, b.spr) then
                   begin
                     res:=false;
                     if lastTrg=tgWood then
                         if _ai then inc(ai.rsWood, 3) else inc(plr.rsWood, 3);
                     if lastTrg=tgFood then
                         if _ai then inc(ai.rsFood, 3) else inc(plr.rsFood, 3);

                     if resplace[ind].alive then SetTarget(lastTrg) else
                       begin
                          trg:=tgNone;
                          alive:=false;
                          if _ai then
                             begin
                               inc(ai.rsWood, 2);
                               dec(ai.wrkCnt);
                               if lastTrg=tgWood then dec(ai.wCnt);
                               if lastTrg=tgfood then dec(ai.fCnt);
                             end else
                             begin
                               inc(plr.rsWood, 2);
                               dec(plr.wrkCnt);
                               if lastTrg=tgWood then dec(plr.wCnt);
                               if lastTrg=tgfood then dec(plr.fCnt);
                             end;
                          
                       end;
                   end;


              end;
    end;
    if HP<=0 then
       begin
         alive:=false;
         if not _ai then
            begin
              dec(plr.wrkCnt);
              dec(plr.popCnt);
              if lastTrg=tgWood then dec(plr.wCnt);
              if lastTrg=tgfood then dec(plr.fCnt);
            end else
            begin
              dec(ai.wrkCnt);
              dec(ai.popCnt);
              if lastTrg=tgWood then dec(ai.wCnt);
              if lastTrg=tgfood then dec(ai.fCnt);
            end;
       end;
    
    spr.Update;
  end else
  begin

  end;
end;


procedure TSoldier.Render;
begin
  if alive then spr.Render;
end;

procedure TSoldier.SetTarget(New: tTarget);
begin
  trg:=New;
end;

procedure TSoldier.Update;
var b : Tbase;  i: integer; tmHP, tmAT: integer;
begin
  inc(rest);
  if rest>100 then rest:=101;     //   

  if alive then
  begin
    case trg of
      tgHome :begin
                if _AI then b:=aibase else b:=plbase;
                // 
                if spr.pos.X<b.door.X then spr.pos.X:=spr.pos.x+1;
                if spr.pos.X>b.door.X then spr.pos.X:=spr.pos.x-1;
                if spr.pos.Y<b.door.Y then spr.pos.y:=spr.pos.y+1;
                if spr.pos.Y>b.door.Y then spr.pos.y:=spr.pos.y-1;

                if Collision(spr, b.spr) then
                   begin
                     alive:=false;
                     trg  :=tgNone;
                   end;
              end;
    tgEnWork:begin
                if not _AI then
                  begin
                    if spr.pos.X<aiwrks[ind].spr.pos.X then spr.pos.X:=spr.pos.x+1;
                    if spr.pos.X>aiwrks[ind].spr.pos.X then spr.pos.X:=spr.pos.x-1;
                    if spr.pos.Y<aiwrks[ind].spr.pos.Y then spr.pos.y:=spr.pos.y+1;
                    if spr.pos.Y>aiwrks[ind].spr.pos.Y then spr.pos.y:=spr.pos.y-1;

                    if Collision(spr, aiwrks[ind].spr)and(rest>50) then
                       begin
                         Logout('pl :    '+inttostr(ind));
                         tmAT:=random(atk)+1;

                         Logout('pl :    '+inttostr(ind)+'   '+inttostr(tmAt)+' .');

                         dec(aiwrks[ind].HP, tmAt);
                         rest:=0;
                         if aiwrks[ind].HP<=0 then 
                           if FindNearest(spr.pos, tgEnWork)<>0 then
                              ind:=FindNearest(spr.pos, tgEnWork)
                           else
                              trg:=tgHome;
                       end;
                  end else
                  begin
                    if spr.pos.X<plwrks[ind].spr.pos.X then spr.pos.X:=spr.pos.x+1;
                    if spr.pos.X>plwrks[ind].spr.pos.X then spr.pos.X:=spr.pos.x-1;
                    if spr.pos.Y<plwrks[ind].spr.pos.Y then spr.pos.y:=spr.pos.y+1;
                    if spr.pos.Y>plwrks[ind].spr.pos.Y then spr.pos.y:=spr.pos.y-1;

                    if Collision(spr, plwrks[ind].spr)and(rest>50) then
                       begin
                         Logout('ai :    '+inttostr(ind));
                         tmAT:=random(atk)+1;

                         Logout('ai :    '+inttostr(ind)+'   '+inttostr(tmAt)+' .');

                         dec(plwrks[ind].HP, tmAt);
                         rest:=0;
                         if plwrks[ind].HP<=0 then
                           if enemy.FindNearest(spr.pos, tgEnWork)<>0 then
                              ind:=enemy.FindNearest(spr.pos, tgEnWork)
                           else
                              trg:=tgHome;
                       end;
                  end;
             end;
    tgEnSold:begin
                if not _AI then
                  begin
                    if spr.pos.X<aislds[ind].spr.pos.X then spr.pos.X:=spr.pos.x+1;
                    if spr.pos.X>aislds[ind].spr.pos.X then spr.pos.X:=spr.pos.x-1;
                    if spr.pos.Y<aislds[ind].spr.pos.Y then spr.pos.y:=spr.pos.y+1;
                    if spr.pos.Y>aislds[ind].spr.pos.Y then spr.pos.y:=spr.pos.y-1;

                    if Collision(spr, aislds[ind].spr)and(rest>50) then
                       begin
                         tmAT:=random(atk)+1;

                         Logout('pl :    '+inttostr(ind)+'   '+inttostr(tmAt)+' .');

                         dec(aislds[ind].HP, tmAt);
                         rest:=0;
                         if aislds[ind].HP<=0 then
                           if FindNearest(spr.pos, tgEnSold)<>0 then
                              ind:=FindNearest(spr.pos, tgEnSold)
                           else
                              trg:=tgHome;
                       end;
                  end else
                  begin
                    if spr.pos.X<plslds[ind].spr.pos.X then spr.pos.X:=spr.pos.x+1;
                    if spr.pos.X>plslds[ind].spr.pos.X then spr.pos.X:=spr.pos.x-1;
                    if spr.pos.Y<plslds[ind].spr.pos.Y then spr.pos.y:=spr.pos.y+1;
                    if spr.pos.Y>plslds[ind].spr.pos.Y then spr.pos.y:=spr.pos.y-1;

                    if Collision(spr, plslds[ind].spr)and(rest>50) then
                       begin
                         tmAT:=random(atk)+1;

                         Logout('ai :    '+inttostr(ind)+'   '+inttostr(tmAt)+' .');

                         dec(plslds[ind].HP, tmAt);
                         rest:=0;
                         if plslds[ind].HP<=0 then
                           if enemy.FindNearest(spr.pos, tgEnSold)<>0 then
                              ind:=enemy.FindNearest(spr.pos, tgEnSold)
                           else
                              trg:=tgHome;
                       end;
                  end;
             end;
    tgEnBase:begin
                if not _AI then
                  begin
                    if spr.pos.X<aibase.door.X then spr.pos.X:=spr.pos.x+1;
                    if spr.pos.X>aibase.door.X then spr.pos.X:=spr.pos.x-1;
                    if spr.pos.Y<aibase.door.Y then spr.pos.y:=spr.pos.y+1;
                    if spr.pos.Y>aibase.door.Y then spr.pos.y:=spr.pos.y-1;

                    if Collision(spr, aibase.spr)and(rest>50) then
                       begin
                         tmAT:=random(atk)+1;

                         Logout('pl :    '+inttostr(ind)+'   '+inttostr(tmAt)+' .');
                         SendToAttSld;
                         dec(aibase.HP, tmAt);
                         rest:=0;
                         if aibase.HP<=0 then
                            begin
                              LogOut('==========================================');
                              LogOut('-------!-!-!-!-');
                              LogOut('==========================================');
                              ex.Quit;
                            end;
                       end;
                  end else
                  begin
                    if spr.pos.X<plbase.door.X then spr.pos.X:=spr.pos.x+1;
                    if spr.pos.X>plbase.door.X then spr.pos.X:=spr.pos.x-1;
                    if spr.pos.Y<plbase.door.Y then spr.pos.y:=spr.pos.y+1;
                    if spr.pos.Y>plbase.door.Y then spr.pos.y:=spr.pos.y-1;

                    if Collision(spr, plbase.spr)and(rest>50) then
                       begin
                         tmAT:=random(atk)+1;

                         Logout('ai :    '+inttostr(ind)+'   '+inttostr(tmAt)+' .');

                         dec(plbase.HP, tmAt);
                         rest:=0;
                         if plbase.HP<=0 then
                           begin
                              LogOut('==========================================');
                              LogOut('----------!-');
                              LogOut('==========================================');
                              ex.Quit;
                            end;
                       end;
                  end;
             end;
    end;
    if HP<=0 then
       begin
         alive:=false;
         exist:=false;
         if not _ai then
            begin
              dec(plr.SldCnt);
              dec(plr.popCnt);
            end else
            begin
              dec(ai.SldCnt);
              dec(ai.popCnt);
            end;
       end;
    
    spr.Update;
  end else
  begin

  end;
end;


procedure TBase.Render;
begin
  if alive then
    begin
      spr.Render;
      glColor3f(1, 1, 1);
      if not _ai then
         begin
           ogl.TextOut(0, spr.pos.X-50, spr.pos.Y-50, PChar(' : '+IntToStr(plr.hlCnt)));
           ogl.TextOut(0, spr.pos.X-50, spr.pos.Y-35, PChar(': '+IntToStr(plr.KzCnt)));
           ogl.TextOut(0, spr.pos.X-50, spr.pos.Y-20, PChar(': '+IntToStr(plr.frgCnt)));
           ogl.TextOut(0, spr.pos.X-50, spr.pos.Y-5,  PChar(': '+IntToStr(plr.tmplCnt)));
           ogl.TextOut(0, spr.pos.X-50, spr.pos.Y+10, PChar('HP  : '+IntToStr(plbase.HP)));
         end else
         begin
           ogl.TextOut(0, spr.pos.X-50, spr.pos.Y-50, PChar(' : '+IntToStr(ai.hlCnt)+' ('+inttostr(ai.wrkCnt)+')'));
           ogl.TextOut(0, spr.pos.X-50, spr.pos.Y-35, PChar(': '+IntToStr(ai.KzCnt)+' ('+inttostr(ai.SldCnt)+')'));
           ogl.TextOut(0, spr.pos.X-50, spr.pos.Y-20, PChar(': '+IntToStr(ai.frgCnt)));
           ogl.TextOut(0, spr.pos.X-50, spr.pos.Y-5,  PChar(': '+IntToStr(ai.tmplCnt)));
           ogl.TextOut(0, spr.pos.X-50, spr.pos.Y+10, PChar(': '+IntToStr(ai.rsFood)));
           ogl.TextOut(0, spr.pos.X-50, spr.pos.Y+25, PChar(': '+IntToStr(ai.rsWood)));
           ogl.TextOut(0, spr.pos.X-50, spr.pos.Y+40, PChar('HP  : '+IntToStr(aibase.HP)));
         end;
    end;

end;

procedure TBase.Update;
begin
  if alive then
    begin
      spr.Update;
    end;
end;

end.
