unit uVar;

interface

uses eXgine, Windows, myGUI, camera, uSprite, game_mex;

type
  TPrLnItems = (pliNone, pliWrk, pliSld, pliHole, pliKz);

  TCivilization = record         //  )))
    rsFood, rsWood : word;       // 
    popCnt, wrkCnt, SldCnt, maxCnt : word;    // 
    fCnt, wCnt : word;                        // 
    CurrBornTime : word;  //   .
    CurrEatTime  : word;  //    
    kof          : real;  // 

    bldCnt       : byte;                  //   
    hlCnt, KzCnt, tmplCnt, frgCnt : byte;  //    
    Prod_Line    : array [1..8] of TPrLnItems;
    CurrProdTime : word;
  end;

var

  plr, AI : TCivilization;
{=============================
 
 ============================}

  LogoNum : integer = 1;
  LogoTime: integer;
  LogoTex: array [1..3] of TTexture;


{==============================
 
 =============================}

  AniTex : array [1..50] of TAnimatedTexture;
  Anims  : array [1..150] of TAnimation;

  BackGr : TSprite;
  ind_food, ind_wood, ind_pop, ind_wrk, ind_sld: TSprite;

{==============================
   !!! =)
===============================}
    tb : array [1..20] of TButton;
    hnt: array [1..20] of THint;

    Panel : array [1..7] of TSprite;

    cur: TGCursor;


    cam: Tcamera;

{===============================
   
================================}
  ResPlace : array [1..6] of TMapObject;
  BldPlace : array [1..8] of TMapObject;

  PlBase, AIBase : TBase;

  plWrkSpr : array [1..100] of TSprite;
  plWrks   : array [1..100] of TWorker;

  aiWrkSpr : array [1..100] of TSprite;
  aiWrks   : array [1..100] of TWorker;

  plSldSpr : array [1..100] of TSprite;
  plSlds   : array [1..100] of TSoldier;

  aiSldSpr : array [1..100] of TSprite;
  aiSlds   : array [1..100] of TSoldier;

  ResSpr : array [1..6] of TSprite;

  B1Spr, B2Spr   : TSprite;


procedure LoadRes;
procedure InitGui;

procedure CreateMap;

implementation

procedure CreateMap;
var i: integer;
begin

  //   
  plr.rsFood:=100;
  plr.rsWood:=30;
  plr.maxCnt:=40;
  plr.popCnt:=20;
  plr.kof:=1;

  ai.rsFood:=100;
  ai.rsWood:=30;
  ai.maxCnt:=40;
  ai.popCnt:=20;
  ai.kof:=1;

  //    
  for I := 1 to 8 do
    begin
      plr.Prod_Line[i]:=pliNone;
      ai.Prod_Line[i] :=pliNone;
    end;

  for I := 1 to 6 do
    begin
      if i<4 then
        begin
          ResSpr[i]:=TSprite.Create(5, 128, 128);
          ResSpr[i].AddAnimation(Anims[8]);
          ResSpr[i].PlayAnim('food');

          ResPlace[i].objType:=moFood;
          ResPlace[i].count:=800+random(500);
          ResPlace[i].spr:=ResSpr[i];
          ResPlace[i].alive:=true;
        end else
        begin
          ResSpr[i]:=TSprite.Create(5, 128, 128);
          ResSpr[i].AddAnimation(Anims[9]);
          ResSpr[i].PlayAnim('wood');

          ResPlace[i].objType:=moWood;
          ResPlace[i].count:=500+random(300);
          ResPlace[i].spr:=ResSpr[i];
          ResPlace[i].alive:=true;
        end;
    end;

    ResSpr[1].pos.X:=450+random(100)-50;
    ResSpr[1].pos.Y:=250+random(100)-50;
    ResSpr[2].pos.X:=400+random(100)-50;
    ResSpr[2].pos.Y:=600+random(100)-50;
    ResSpr[3].pos.X:=384+random(100)-50;
    ResSpr[3].pos.Y:=384+random(100)-50;

    ResSpr[4].pos.X:=150+random(100)-50;
    ResSpr[4].pos.Y:=350+random(100)-50;
    ResSpr[5].pos.X:=650+random(100)-50;
    ResSpr[5].pos.Y:=350+random(100)-50;
    ResSpr[6].pos.X:=100+random(100)-50;
    ResSpr[6].pos.Y:=600+random(100)-50;

    b2Spr:=TSprite.Create(5, 128, 128);
    b2Spr.AddAnimation(Anims[10]);
    b2Spr.pos.X:=100;
    b2Spr.pos.Y:=100;
    b2Spr.PlayAnim('base');

    AiBase.spr:=b2spr;
    AiBase.door.X:=Aibase.spr.pos.X;
    AiBase.door.Y:=AIBase.spr.pos.Y+62;
    AiBase.HP:=500;
    Aibase._AI:=true;
    AiBase.alive:=True;

    b1Spr:=TSprite.Create(5, 128, 128);
    b1Spr.AddAnimation(Anims[10]);
    b1Spr.pos.X:=668;
    b1Spr.pos.Y:=668;
    b1Spr.PlayAnim('base');

    plBase.spr:=b1spr;
    plBase.door.X:=plbase.spr.pos.X;
    plBase.door.Y:=plBase.spr.pos.Y+62;
    plBase.HP:=500;
    plbase._AI:=false;
    plBase.alive:=True;

    for i := 1 to 100 do
      begin
        plWrkSpr[i]:=TSprite.Create(5, 32, 32);
        plWrkSpr[i].AddAnimation(Anims[11]);
        plWrkSpr[i].pos.X:=200;
        plWrkSpr[i].pos.Y:=200;
        plWrkSpr[i].PlayAnim('run');

        plWrks[i].spr:=plWrkSpr[i];
        plWrks[i]._ai:=false;

        aiWrkSpr[i]:=TSprite.Create(5, 32, 32);
        aiWrkSpr[i].AddAnimation(Anims[11]);
        aiWrkSpr[i].pos.X:=200;
        aiWrkSpr[i].pos.Y:=200;
        aiWrkSpr[i].PlayAnim('run');

        aiWrks[i].spr:=aiWrkSpr[i];
        aiWrks[i]._ai:=true;

        plSldSpr[i]:=TSprite.Create(5, 32, 32);
        plSldSpr[i].AddAnimation(Anims[12]);
        plSldSpr[i].pos.X:=200;
        plSldSpr[i].pos.Y:=200;
        plSldSpr[i].PlayAnim('run');

        plSlds[i].spr:=plSldSpr[i];
        plSlds[i]._ai:=false;

        aiSldSpr[i]:=TSprite.Create(5, 32, 32);
        aiSldSpr[i].AddAnimation(Anims[12]);
        aiSldSpr[i].pos.X:=200;
        aiSldSpr[i].pos.Y:=200;
        aiSldSpr[i].PlayAnim('run');

        aiSlds[i].spr:=aiSldSpr[i];
        aiSlds[i]._ai:=true;
      end;     
end;

procedure InitGui;
begin

  hnt[1].w:=200;
  hnt[1].h:=100;
  hnt[1].stngs:=3;
  hnt[1].Text[1]:=' .';
  hnt[1].Text[2]:='    .';
  hnt[1].Text[3]:='  ';
  hnt[1].Text[4]:='  .';
  hnt[1].Text[5]:=': 3  .';


  tb[1].X:=896;
  tb[1].Y:=70;
  tb[1].w:=130;
  tb[1].h:=42;
  tb[1].Visible:=true;
  tb[1].SetTexture(tex.Load('Data\textures\GUI\btn_kaz.tga'));
  tb[1].OnClick:=btnKzClick;


  tb[2].X:=896;
  tb[2].Y:=120;
  tb[2].w:=130;
  tb[2].h:=42;
  tb[2].Visible:=true;
  tb[2].SetTexture(tex.Load('Data\textures\GUI\btn_hole.tga'));
  tb[2].OnClick:=btnHoleClick;

  tb[3].X:=896;
  tb[3].Y:=170;
  tb[3].w:=130;
  tb[3].h:=42;
  tb[3].Visible:=true;
  tb[3].SetTexture(tex.Load('Data\textures\GUI\btn_tmp.tga'));

  tb[4].X:=896;
  tb[4].Y:=220;
  tb[4].w:=130;
  tb[4].h:=42;
  tb[4].Visible:=true;
  tb[4].SetTexture(tex.Load('Data\textures\GUI\btn_frg.tga'));

  tb[5].X:=800;
  tb[5].Y:=400;
  tb[5].w:=50;
  tb[5].h:=50;
  tb[5].Visible:=true;
  tb[5].SetTexture(tex.Load('Data\textures\GUI\bt_wrk.bmp'));
  tb[5].OnClick:=btnWrkClick;
  tb[5].SetHint(hnt[1]);

  tb[6].X:=860;
  tb[6].Y:=400;
  tb[6].w:=50;
  tb[6].h:=50;
  tb[6].Visible:=true;
  tb[6].SetTexture(tex.Load('Data\textures\GUI\bt_eq.bmp'));
  tb[6].OnClick:=btnChange1;

  tb[7].X:=920;
  tb[7].Y:=400;
  tb[7].w:=50;
  tb[7].h:=50;
  tb[7].Visible:=true;
  tb[7].SetTexture(tex.Load('Data\textures\GUI\bt_fd_more.bmp'));
  tb[7].OnClick:=btnChange2;

  tb[8].X:=980;
  tb[8].Y:=400;
  tb[8].w:=50;
  tb[8].h:=50;
  tb[8].Visible:=true;
  tb[8].SetTexture(tex.Load('Data\textures\GUI\bt_wd_more.bmp'));
  tb[8].OnClick:=btnChange3;

  tb[9].X:=800;
  tb[9].Y:=460;
  tb[9].w:=50;
  tb[9].h:=50;
  tb[9].Visible:=true;
  tb[9].SetTexture(tex.Load('Data\textures\GUI\bt_sld.bmp'));
  tb[9].OnClick:=btnSldClick;

  tb[10].X:=860;
  tb[10].Y:=460;
  tb[10].w:=50;
  tb[10].h:=50;
  tb[10].Visible:=true;
  tb[10].SetTexture(tex.Load('Data\textures\GUI\bt_sld_atw.bmp'));
  tb[10].OnClick:=btnSldAtwClick;

  tb[11].X:=860;
  tb[11].Y:=520;
  tb[11].w:=50;
  tb[11].h:=50;
  tb[11].Visible:=true;
  tb[11].SetTexture(tex.Load('Data\textures\GUI\bt_sld_ats.bmp'));
  tb[11].OnClick:=btnSldAtsClick;

  tb[12].X:=860;
  tb[12].Y:=580;
  tb[12].w:=50;
  tb[12].h:=50;
  tb[12].Visible:=true;
  tb[12].SetTexture(tex.Load('Data\textures\GUI\bt_sld_atb.bmp'));
  tb[12].OnClick:=btnSldAtbClick;

  tb[13].X:=920;
  tb[13].Y:=460;
  tb[13].w:=50;
  tb[13].h:=50;
  tb[13].Visible:=true;
  tb[13].SetTexture(tex.Load('Data\textures\GUI\bt_sld_atw_back.bmp'));
  tb[13].OnClick:=btnSldAtwBClick;

  tb[14].X:=920;
  tb[14].Y:=520;
  tb[14].w:=50;
  tb[14].h:=50;
  tb[14].Visible:=true;
  tb[14].SetTexture(tex.Load('Data\textures\GUI\bt_sld_ats_Back.bmp'));
  tb[14].OnClick:=btnSldAtsBClick;

  tb[15].X:=920;
  tb[15].Y:=580;
  tb[15].w:=50;
  tb[15].h:=50;
  tb[15].Visible:=true;
  tb[15].SetTexture(tex.Load('Data\textures\GUI\bt_sld_atb_Back.bmp'));
  tb[15].OnClick:=btnSldAtbBClick;
end;

procedure LoadRes;
begin
  LogoTex[1]:=tex.Load('Data\Textures\Logo\L1.gif');
  LogoTex[2]:=tex.Load('Data\Textures\Logo\tutorial.jpg');
  LogoTex[3]:=tex.Load('Data\Textures\Logo\brif.jpg');


  AniTex[1].W:=256;
  AniTex[1].H:=256;
  AniTex[1].Texture:=tex.Load('Data\Textures\Gui\panel.jpg');

  AniTex[2].W:=64;
  AniTex[2].H:=64;
  AniTex[2].Texture:=tex.Load('Data\Textures\Gui\IC_FOOD.BMP');

  AniTex[3].W:=64;
  AniTex[3].H:=64;
  AniTex[3].Texture:=tex.Load('Data\Textures\Gui\IC_WOOD.BMP');

  AniTex[4].W:=16;
  AniTex[4].H:=16;
  AniTex[4].Texture:=tex.Load('Data\Textures\Gui\IC_Pop.BMP');

  AniTex[5].W:=16;
  AniTex[5].H:=16;
  AniTex[5].Texture:=tex.Load('Data\Textures\Gui\IC_wrk.BMP');

  AniTex[6].W:=16;
  AniTex[6].H:=16;
  AniTex[6].Texture:=tex.Load('Data\Textures\Gui\IC_sld.BMP');

  AniTex[7].W:=256;
  AniTex[7].H:=256;
  AniTex[7].Texture:=tex.Load('Data\Textures\map\back1.jpg');

  AniTex[8].W:=256;
  AniTex[8].H:=256;
  AniTex[8].Texture:=tex.Load('Data\Textures\obj\food.tga');

  AniTex[9].W:=256;
  AniTex[9].H:=256;
  AniTex[9].Texture:=tex.Load('Data\Textures\obj\wood.tga');

  AniTex[10].W:=256;
  AniTex[10].H:=256;
  AniTex[10].Texture:=tex.Load('Data\Textures\obj\BASE.tga');

  AniTex[11].W:=64;
  AniTex[11].H:=32;
  AniTex[11].Texture:=tex.Load('Data\Textures\pop\wrk.tga');

  AniTex[12].W:=64;
  AniTex[12].H:=32;
  AniTex[12].Texture:=tex.Load('Data\Textures\pop\sld.tga');

  Anims[1].Name:='1';
  Anims[1].FPS:=1;
  Anims[1].fWidth:=256;
  Anims[1].fHeight:=256;
  Anims[1].FrameCount:=1;
  Anims[1].Atex:=AniTex[1];

  Anims[2].Name:='food';
  Anims[2].FPS:=1;
  Anims[2].fWidth:=64;
  Anims[2].fHeight:=64;
  Anims[2].FrameCount:=1;
  Anims[2].Atex:=AniTex[2];

  Anims[3].Name:='wood';
  Anims[3].FPS:=1;
  Anims[3].fWidth:=64;
  Anims[3].fHeight:=64;
  Anims[3].FrameCount:=1;
  Anims[3].Atex:=AniTex[3];

  Anims[4].Name:='pop';
  Anims[4].FPS:=1;
  Anims[4].fWidth:=16;
  Anims[4].fHeight:=16;
  Anims[4].FrameCount:=1;
  Anims[4].Atex:=AniTex[4];

  Anims[5].Name:='sld';
  Anims[5].FPS:=1;
  Anims[5].fWidth:=16;
  Anims[5].fHeight:=16;
  Anims[5].FrameCount:=1;
  Anims[5].Atex:=AniTex[5];

  Anims[6].Name:='wrk';
  Anims[6].FPS:=1;
  Anims[6].fWidth:=16;
  Anims[6].fHeight:=16;
  Anims[6].FrameCount:=1;
  Anims[6].Atex:=AniTex[6];

  Anims[7].Name:='back';
  Anims[7].FPS:=1;
  Anims[7].fWidth:=256;
  Anims[7].fHeight:=256;
  Anims[7].FrameCount:=1;
  Anims[7].Atex:=AniTex[7];

  Anims[8].Name:='food';
  Anims[8].FPS:=1;
  Anims[8].fWidth:=256;
  Anims[8].fHeight:=256;
  Anims[8].FrameCount:=1;
  Anims[8].Atex:=AniTex[8];

  Anims[9].Name:='wood';
  Anims[9].FPS:=1;
  Anims[9].fWidth:=256;
  Anims[9].fHeight:=256;
  Anims[9].FrameCount:=1;
  Anims[9].Atex:=AniTex[9];

  Anims[10].Name:='base';
  Anims[10].FPS:=1;
  Anims[10].fWidth:=256;
  Anims[10].fHeight:=256;
  Anims[10].FrameCount:=1;
  Anims[10].Atex:=AniTex[10];

  Anims[11].Name:='run';
  Anims[11].FPS:=10;
  Anims[11].fWidth:=32;
  Anims[11].fHeight:=32;
  Anims[11].FrameCount:=2;
  Anims[11].Atex:=AniTex[11];

  Anims[12].Name:='run';
  Anims[12].FPS:=10;
  Anims[12].fWidth:=32;
  Anims[12].fHeight:=32;
  Anims[12].FrameCount:=2;
  Anims[12].Atex:=AniTex[12];
end;

end.
